2000-08-07  Alexandre Petit-Bianco  <apbianco@cygnus.com

	* parse.y (build_dot_class_method_invocation): Changed parameter
	name to `type.' Build signature from `type' and convert it to a
	STRING_CST if it's an array.
	(patch_incomplete_class_ref): `build_dot_class_method_invocation'
	to use `ref_type' directly.

Sun Aug  6 00:47:24 2000  Ovidiu Predescu  <ovidiu@cup.hp.com>

	* lang-options.h: Added a comma after the last element to avoid
	syntax errors when other languages define additional options.

2000-08-04  Zack Weinberg  <zack@wolery.cumb.org>

	* Make-lang.in (jc1, jv-scan): Depend on $(BACKEND), not stamp-objlist.
	* Makefile.in: Add BACKEND; delete OBJS, OBJDEPS.
	(jc1): Link with $(BACKEND).
	(jv-scan): Depend on version.o, not all of $(OBJS) or $(BACKEND).

2000-08-02  Zack Weinberg  <zack@wolery.cumb.org>

	* jvspec.c: Adjust type of second argument to
	lang_specific_driver, and update code as necessary.

	* class.c (build_dtable_decl): Initialize dummy.

2000-08-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (maybe_yank_clinit): When generating bytecode: non empty
	method bodies not to rule out discarding `<clinit>'; don't use
	<clinit> to initialize static fields with constant initializers.

2000-08-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* gjavah.c (print_method_info): Added `synth' parameter. Skip
	synthetic methods.
	(method_synthetic): New global.
	(HANDLE_METHOD): Recognize synthetic method and tell
	`print_method_info' about it.
	(HANDLE_END_METHOD): Do not issue an additional `;\n' if we're
	processing a synthetic method.
	* jcf-reader.c (skip_attribute): New function.
	( skip_attribute): Likewise.

2000-08-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (build_outer_field_access): Fixed comments.
	(fix_constructors): Emit the initialization of this$<n> before
	calling $finit$.
	(resolve_qualified_expression_name): Build an access to `decl' if
	necessary.

2000-07-31  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse-scan.y (curent_class): Non longer const.
	(inner_qualifier, inner_qualifier_length): Deleted.
	(current_class_length): New global.
	(bracket_count): Fixed typo in leading comment.
	(anonymous_count): New global.
	(class_instance_creation_expression:): Handle anonymous classes.
	(anonymous_class_creation:): New rule.
	(push_class_context): Rewritten.
	(pop_class_context): Likewise.
	(INNER_QUALIFIER): Macro deleted.
	(report_class_declaration): call `push_class_context' when
	entering the function. `fprintf' format modified not to use
	INNER_QUALIFIER.
	(report_class_declaration): Assign `package_name' and
	`current_class' to NULL separatly.

2000-07-31  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (build_invokeinterface): Call layout_class_methods on
	target interface.

2000-07-27  Tom Tromey  <tromey@cygnus.com>
            Anthony Green  <green@cygnus.com>
	    Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (make_class_data): Create vtable for abstract classes.
	(get_dispatch_table): Changed to cope with abstract classes.

2000-07-27  Tom Tromey  <tromey@cygnus.com>

	* parse.y (patch_method_invocation): Don't reverse the argument
	list when dealing with anonymous class constructors. Fixed typo in
	comment.

2000-07-27  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (build_alias_initializer_parameter_list): Reverse
	crafted list when building aliases for anonymous class
	constructors.

2000-07-25  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (jdep_resolve_class): Don't bother checking potential
	innerclass access if `decl' is NULL.
	(find_in_imports_on_demand): TREE_PURPOSE of `import' contains the
	WFL.

2000-07-25  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.c: Remove (again.)

2000-07-24  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_as_inner_class): Removed 2000-07-19 patches.
	* jcf-parse.c (HANDLE_INNERCLASSES_ATTRIBUTE): Local `decl' moved
	outside the `if' statement, alias to innerclass removed, `decl'
	used to mark the class complete.

2000-07-21  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (simple_name:): Fixed typo in error message.

2000-07-21  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_complete_lhs): LOOP_EXPR:, SWITCH_EXPR: the node
	or its first operand can be error marks.

2000-07-20  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (SET_TYPE_FOR_RESOLUTION): Use GET_CPC.
	* parse.y (method_header): Likewise.

2000-07-19  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_as_inner_class): Handle the case where the
	enclosing context of an innerclass has been loaded as bytecode.

2000-07-19  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (simple_name:): Reject `$' in type names.
	(resolve_type_during_patch): Use `type' as a second
	argument to resolve_no_layout. Fixes gcj/257.

2000-07-18  Jeff Sturm  <jeff.sturm@appnet.com>

	* lang-specs.h: Added %(jc1) to java compiler options.

2000-07-14  Zack Weinberg  <zack@wolery.cumb.org>

	* .cvsignore: New file.

2000-07-13  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (not_accessible_p): Access granted to innerclasses
	(indirectly) extending the reference type. Fixes gcj/249.

2000-07-13  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (patch_method_invocation): Fixed comment.
	(maybe_use_access_method): Build this$<n>s to the context of the
	target method, or a type that extends it. Fixes gcj/242.

2000-07-13  Mark Mitchell  <mark@codesourcery.com>

	* parse.c: Remove.

2000-07-13  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (fold_constant_for_init): Avoid bullish conversion.

2000-07-13  Tom Tromey  <tromey@cygnus.com>

	* lang-specs.h: Added %{I*}.

2000-07-13  Zack Weinberg  <zack@wolery.cumb.org>

	* lang-specs.h: Use the new named specs.  Remove unnecessary braces.

2000-07-12  Mark Mitchell  <mark@codesourcery.com>

	* parse-scan.c: Remove.

2000-07-10  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (set_super_info): Handled protected inner classes.
	(common_enclosing_context_p): Bail early if arguments aren't both
	inner classes.
	(get_access_flags_from_decl): Handle private and protected inner
	classes.
	* java-tree.h (TYPE_PROTECTED_INNER_CLASS): New macro.
	(CLASS_PROTECTED): Likewise.
	(struct lang_type): New bitfield `poic.'
	* parse.y (jdep_resolve_class): Call check_inner_class_access on
	inner classes only.
	(check_inner_class_access): Renamed arguments, added
	comments. Handles protected inner classes (fixes gcj/225)
	(not_accessible_p): Fixed comments. Avoid handling inner classes.

2000-07-10  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_qualified_expression_name): Verify qualified
	access to `this.' Fixes gcj/239.

2000-07-10  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_classfile): Don't install ConstantValue
	for null pointers.

2000-07-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_qualified_expression_name): Handle inner class
	access. Fixes gcj/256.

2000-07-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_classfile): Properly install the
	ConstantValue attribute and the initial value constant pool index
	on string constants.
	* parse.y (java_complete_lhs): Keep DECL_INITIAL when emitting
	class files.

2000-07-06  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (BUILD_PTR_FROM_NAME): Surround with a do/while
	construct.
	* parse.y (find_as_inner_class): Fixed typo.
	(do_resolve_class): Explore enclosing contexts when searching for
	innerclasses. Removed curly brackets around BUILD_PTR_FROM_NAME.
	(check_inner_class_access): Check `decl' which can be null in case
	of previous errors.

2000-07-05  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (java_debug_context): Declared `extern.'
	(safe_layout_class): Likewise.
	* parse.y (resolve_field_access): Field must be `static' in order
	to be replaced by its initial value. Added comments.
	(find_applicable_accessible_methods_list): Fixed typo.
	(find_most_specific_methods_list): Methods found in innerclasses
	take over methods founds in the enclosing contexts.
	(java_complete_tree): Loosen restrictions on the type of DECLs
	that can be replaced by their initialization values.
	(valid_ref_assignconv_cast_p): Removed call to `enclosing_context_p.'

2000-07-05  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (PARSE_DIR): New macro.
	(PARSE_RELDIR): Likewise.
	(PARSE_C): Likewise.
	(PARSE_SCAN_C): Likewise.
	($(PARSE_C)): New target.
	($(PARSE_SCAN_C)): Likewise.
	(SET_BISON): New macro.
	(BISONFLAGS): Likewise.
	(JAVABISONFLAGS): Likewise.

2000-07-02  Bryce McKinlay  <bryce@albatross.co.nz>

        * gjavah.c (HANDLE_METHOD): Call print_method_info with a NULL stream
        argument on the first pass for CNI as well as JNI.
        (print_method_info): Set up method name on the first pass only.
	
2000-07-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (parser_qualified_classname): Removed parameter
	`is_static'.
	(create_interface): Removed first passed parameter to
	parser_qualified_classname.
	(create_class): Likewise. Don't install alias on static
	innerclasses. Fixes gcj/275.

2000-07-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (maybe_generate_pre_expand_clinit): Don't build a
	debugable statement with empty_stmt_node. Fixes gcj/272

2000-07-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (build_instanceof): Layout type after it's loaded. Fixes
	gcj/271.

2000-06-29  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (push_long_const): Appropriately cast short negative
	constant to jword.

2000-06-29  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (verify_constructor_super): Use loop variable
	`m_arg_type' initialized with `mdecl_arg_type'.

2000-06-29  Tom Tromey  <tromey@cygnus.com>

	* parse.y (resolve_field_access): Handle case where `type_found'
	is NULL.

2000-06-27  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (lookup_field): The same field can be found through two
	different interface. Don't declare it ambiguous in that case.

2000-06-27  Tom Tromey  <tromey@cygnus.com>

	* lex.c (java_lineterminator): Don't recognize \r after \n.  If \r
	follows \r, then unget it at a lower level.

2000-06-26  Tom Tromey  <tromey@cygnus.com>

	* parse.y (resolve_field_access): Pass decl, not DECL_INITIAL, to
	java_complete_tree.

2000-06-25  Tom Tromey  <tromey@cygnus.com>

	* parse.y (for_statement): Wrap expression in a WFL if it is a
	constant.  For PR gcj/268.

2000-06-25  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (do_resolve_class): Minor optimiztion in the package
	list search. Removed unecessary test and return statement.
	(valid_ref_assignconv_cast_p): Order of arguments to
	enclosing_context_p fixed.

2000-06-24  Tom Tromey  <tromey@cygnus.com>

	* expr.c (lookup_field): Print error and return error_mark_node if
	field reference is ambiguous.

	* parse.y (check_abstract_method_definitions): Also check if
	`other_method' is abstract.

2000-06-23  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (set_super_info): Handle ACC_PRIVATE for (inner)
	classes.
	* java-tree.h (TYPE_PRIVATE_INNER_CLASS): New macro.
	(struct lang_type): New field `pic.'
	(CLASS_PRIVATE): New macro.
	* parse.y (check_inner_class_access): New function.
	(jdep_resolve_class): Call it.

2000-06-23  Tom Tromey  <tromey@cygnus.com>

	* parse.y (patch_incomplete_class_ref): Initialize the returned
	class.  For PR gcj/260.

2000-06-21  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* except.c (prepare_eh_table_type): Use `CATCH_ALL_TYPE'.

2000-06-20  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (ENABLE_JC1_CHECKING): Replaces ENABLE_CHECKING for
	Java specific checks.
	* expr.c (build_instanceof): CLASS_INTERFACE and CLASS_FINAL usage
	screened by DECL_P.
	* java-tree.def (CASE_EXPR): Marked 'e'.
	(DEFAULT_EXPR): Likewise.
	* jcf-parse.c (set_source_filename): CLASS_COMPLETE_P usage
	screened by DECL_P.
	* jcf-write.c (ENABLE_JC1_CHECKING): Replaces ENABLE_CHECKING for
	Java specific checks.
	(generate_bytecode_insns): Test try_block for BLOCK before using
	BLOCK_EXPR_BODY.
	* parse.y (build_wfl_wrap): Added `location' argument. Set
	EXPR_WFL_LINECOL accordingly.
	(dim_expr:): Wrap constants with WFLs.
	(method_declarator): Use TREE_TYPE not TYPE_NAME on GET_CPC.
	(resolve_package): Check for `stmt' not being a BLOCK before
	building a debuggable statement with it.
	(make_qualified_primary): Added extra parameter to build_wfl_wrap
	invocation.
	(resolve_field_access): Make sure `decl' is a DECL before treating
	it as such.
	(maybe_build_primttype_type_ref): Make sure `wfl''s node is an
	IDENTIFIER_NODE before treating it as such.
	(patch_new_array_init): Make sure `elt' is a TREE_LIST before
	treating it as such.
	(find_applicable_accessible_methods_list): CLASS_INTERFACE macro
	to be applied only on non array types.

2000-06-16  Per Bothner  <per@bothner.com>

	* java-tree.h (LABEL_RETURN_LABELS, LABEL_PENDING_CHAIN):  Don't
	define in terms of DECL_RESULT, as that fails when --enable-checking.
	
2000-06-15  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-write.c (CHECK_PUT): Add static prototype.  Make pointer
	types the same in comparison.
	(CHECK_OP): Add static prototype.

2000-06-13  Jakub Jelinek  <jakub@redhat.com>

	* typeck.c (build_java_array_type): Set TYPE_USER_ALIGN.
	* parse.y (java_complete_class): Set DECL_USER_ALIGN.
	* parse.c: Rebuilt.

2000-06-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (create_primitive_vtable): Prototype.

	* jcf-write.c (generate_bytecode_insns): Initialize variable
	`saved_context'.

	* lang.c (lang_get_alias_set): Mark parameter with ATTRIBUTE_UNUSED.

2000-06-09  Bryce McKinlay  <bryce@albatross.co.nz>

	* parse.y (find_applicable_accessible_methods_list): Use a hashtable
	to track searched classes, and do not search the same class more than
	once. Call find_applicable_accessible_methods_list on immediate
	superclass, instead of search_applicable_method_list on all ancestors.
	Fix for PR gcj/238.

2000-06-09  Bryce McKinlay  <bryce@albatross.co.nz>

	* parse.y (register_fields): Permit static fields in inner classes
	if they are final. Fix for PR gcj/255.

2000-06-06  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (REGISTER_IMPORT): Use `chainon' to link new entries.
	* parse.y (find_in_imports): Returned type changed to void,
	leading comment fixed.
	(register_package): New function.
	(qualify_and_find): Likewise.
	(package_declaration:): Use `register_package'.
	(single_type_import_declaration:): Removed local variable
	`node'. Added missing `;' for consistency.
	(type_import_on_demand_declaration:): Use `chainon' to link new
	entries.
	(lookup_field_wrapper): Lookup local variables defined in outer
	contexts first.
	(java_complete_class): Don't reverse the list of imported on demand.
	(do_resolve_class): Reorganized. Removed local variable
	`original_name'. Call `qualify_and_find' with the current package
	name, invoke `find_in_imports_on_demand' right after. Call
	`qualify_and_find' with the packages we've seen so far. Fixed
	operations numbering in comments.
	(java_expand_class): Don't reverse `package_list'.
	(find_most_specific_methods_list): New local variables `abstract'
	and `candidates'. Use them to pick the right method.

Tue Jun  6 11:39:05 2000  Tom Tromey  <tromey@ferrule.cygnus.com>

	* parse.y (check_modifiers_consistency): Don't subtract out
	`PUBLIC_TK' from argument to THIS_MODIFIER_ONLY.

2000-06-04  Philipp Thomas  <pthomas@suse.de>

	* Makefile.in (INTLLIBS): New.
	(LIBS): Add above.
	(DEPLIBS): Ditto.

Fri Jun  2 16:48:55 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (get_dispatch_table): Build the vtable dummy entry list
 	element with a null purpose. Fixed leading comment.
	(build_dtable_decl): Build an accurate dtable type when appropriate
 	and use it.

2000-06-02  Richard Henderson  <rth@cygnus.com>

	* lang.c (lang_get_alias_set): New.

2000-05-31  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_field_access): Complete the DECL_INITIAL tree
	before using it as the accessed field.

2000-05-31  Tom Tromey  <tromey@cygnus.com>

	* java-tree.h (boolean_array_vtable, byte_array_vtable,
	char_array_vtable, short_array_vtable, int_array_vtable,
	long_array_vtable, float_array_vtable, double_array_vtable):
	Declare.
	* expr.c (get_primitive_array_vtable): New function.
	(create_primitive_vtable): New function.
	(java_lang_expand_expr): Enable code to statically generate
	arrays.
	* decl.c (init_decl_processing): Create primitive vtables.
	(boolean_array_vtable, byte_array_vtable, char_array_vtable,
	short_array_vtable, int_array_vtable, long_array_vtable,
	float_array_vtable, double_array_vtable): Define.

2000-05-26  Zack Weinberg  <zack@wolery.cumb.org>

	* java/parse.y (find_applicable_accessible_methods_list):
	Don't add an uninitialized value to the list.

2000-05-25  Tom Tromey  <tromey@cygnus.com>

	* parse.y (resolve_field_access): Don't check DECL_LANG_SPECIFIC
	when trying to see if field's class should be initialized.  Always
	initialize field's declaring class, not qualified class.
	For PR gcj/162.

	* parse.y (array_constructor_check_entry): Pass `wfl_value', not
	`wfl_operator', to maybe_build_primttype_type_ref.
	Fixes PR gcj/235.

2000-05-23  Bryce McKinlay  <bryce@albatross.co.nz>

       * parse.y (patch_method_invocation): Don't try to lookup methods
       in primitive types.

2000-05-02  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_field_access): Call the appropriate <clinit>
	before accessing the length of a static array. Craft a decl for
	the field while its time. Fixes PR gcj/129.
 
2000-05-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_package): Correctly set `*next' (was off by
	one.)
	(resolve_qualified_expression_name): Fixed comment.

Thu Apr 27 17:47:34 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (jcf_parse_source): Reset current_class and 
 	current_function_decl to NULL before parsing a new file.

Thu Apr 27 17:25:33 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (block_end:): If the collected block doesn't feature a
 	statement, insert an empty statement.

2000-04-17  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (maybe_yank_clinit): New function.
        (maybe_generate_pre_expand_clinit): Always link <clinit> at the
        end of the list of methods belonging to a class.
        (java_complete_expand_method): Check whether <clinit> is really
        necessary and expand it accordingly.

2000-04-17  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (fold_constant_for_init): Let VAR_DECL and FIELD_DECL be
	processed by the method's switch statement.

2000-05-19  Tom Tromey  <tromey@cygnus.com>

	* java-tree.h: Added init state enum.
	* decl.c (emit_init_test_initialization): Initialize class
	initialization check variable by looking at class' state.

2000-05-19  Tom Tromey  <tromey@cygnus.com>

	* java-tree.h (build_instanceof): Declare.
	(build_get_class): Declare.
	* parse.y (patch_binop): Use build_instanceof.
	* expr.c (build_instanceof): New function.  If class is final,
	don't make a function call.
	(expand_java_INSTANCEOF): Use it.
	(build_get_class): New function.

2000-05-18  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* jcf-write.c (generate_classfile): Scan the source_file for
	slashes with the right pointer variable.

Wed May 17 17:27:44 2000  Andrew Cagney  <cagney@b1.cygnus.com>

	* lang.c (lang_decode_option): Update -Wunused flags by calling
 	set_Wunused.
	* decl.c (poplevel): Replace warn_unused with warn_unused_label.

2000-05-09  Zack Weinberg  <zack@wolery.cumb.org>

	* check_init.c (check_init): Constify local char *.
	* class.c (push_class): Constify local char *.
	* java_tree.h: Update prototypes.
	* jcf-io.c (open_class): Constify filename parameter and
	return value.
	(find_class): Remove redundant string copy.  Cast return from
	open_class.
	* jcf-parse.c (read_class, parse_class_file, yyparse):
	Constify local char *.
	* jcf-write.c (generate_bytecode_insns, generate_classfile):
	Constify local char *.
	* jcf.h (JCF): Constify filename and classname.
	(JCF_FINISH): Cast args to FREE to char * when appropriate.
	* lang.c (init_parse): Constify parameter and return value.
	* lex.c (java_get_line_col): Constify filename parameter.
	* parse.h: Constify parser_ctxt.filename.  Update prototypes.
	* parse.y (java_parser_context_suspend,
	issue_warning_error_from_context, safe_layout_class): Constify
	local char *.
	* parse.c: Regenerate.

2000-05-08  Tom Tromey  <tromey@cygnus.com>

	* expr.c (build_jni_stub): Cache the result of
	_Jv_LookupJNIMethod.

2000-05-05  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (predef_filenames_size): Now 7.
	(predef_filenames): New seventh entry.

2000-05-04  Tom Tromey  <tromey@cygnus.com>

	* boehm.c (mark_reference_fields): Don't mark RawData fields.
	Keep track of when we've seen a reference field after a
	non-reference field.
	(get_boehm_type_descriptor): Handle case where we see
	non-reference fields but no trailing reference field.
	* decl.c (rawdata_ptr_type_node): Define.
	(init_decl_processing): Initialize rawdata_ptr_type_node.
	* java-tree.h (rawdata_ptr_type_node): Declare.

2000-05-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-dump.c (SPECIAL_IINC): Ensure arguments match format
	specifiers in calls to fprintf.

2000-05-03  Andrew Haley  <aph@cygnus.com>

	* expr.c (build_java_jsr): Use emit_jump, not expand_goto.

	* javaop.h (WORD_TO_INT): New function.
	(IMMEDIATE_s4): Use WORD_TO_INT.
	* jcf.h (JPOOL_INT): Ditto.

	* gjavah.c (decode_signature_piece): Don't treat `$' as namespace
	separator.

2000-04-19  Tom Tromey  <tromey@cygnus.com>

	* class.c (add_method_1): Set both DECL_EXTERNAL and METHOD_NATIVE
	on native function.
	* jcf-parse.c (parse_class_file): Call build_jni_stub for native
	JNI methods.
	* expr.c (build_jni_stub): New function.
	* lang-specs.h: -fjni and -femit-class-file are incompatible.
	* parse.c: Rebuilt.
	* parse.y (java_complete_expand_methods): Expand a native method
	and call build_jni_stub if -fjni given.
	* lang-options.h: Document -fjni.
	* lang.c (flag_jni): New global.
	(lang_f_options): Added `jni' entry.
	* java-tree.h (soft_lookupjnimethod_node,
	soft_getjnienvnewframe_node, soft_jnipopsystemframe_node):
	Declare.
	(flag_jni): Declare.
	(build_jni_stub): Declare.
	(struct lang_decl): Added `native' flag.
	(METHOD_NATIVE): Redefined to use `native' field of lang specific
	structure.
	* decl.c (soft_lookupjnimethod_node, soft_getjnienvnewframe_node,
	soft_jnipopsystemframe_node): New globals.
	(init_decl_processing): Set them.  _Jv_InitClass only takes one
	argument.

	* java-tree.def: Put into `C' mode.

2000-04-27  Tom Tromey  <tromey@cygnus.com>

	Fix for PR gcj/2:
	* expr.c (expand_invoke): Generate check to see if object pointer
	is null in nonvirtual invocation case.
	* java-tree.h (soft_nullpointer_node): Declare.
	* decl.c (soft_nullpointer_node): New global.
	(init_decl_processing): Initialize soft_nullpointer_node.
	* parse.y (invocation_mode): Return INVOKE_NONVIRTUAL for `final'
	or `private' methods.
	(patch_invoke): Handle INVOKE_NONVIRTUAL case.

Wed Apr 26 14:29:33 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (complete_start_java_method): Don't call _Jv_InitClass
 	from <clinit>

2000-04-26  Tom Tromey  <tromey@cygnus.com>

	* zextract.c (find_zip_file_start): New function.
	(read_zip_archive): Use it.

2000-04-25  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (register_incomplete_type): Handle JDEP_ANONYMOUS.

2000-04-24  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (common_enclosing_context_p): New function.
	* java-tree.h (common_enclosing_context_p): Added prototype.
	* parse.h (INNER_ENCLOSING_SCOPE_CHECK): Relaxed test to allow
	classes sharing an outer context with the current instance.
	* parse.y (build_access_to_thisn): Fixed leading comment.
	(verify_constructor_super): New local `supper_inner'. Skip
	enclosing context argument in the case of inner class constructors.
	(patch_method_invocation): Insert proper context as second
	parameter to pure inner class constructor super invocations.

Mon Apr 24 14:59:36 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (end_class_declaration): Reset the interface number
 	counter.

2000-04-24  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (source_start_java_method): Deleted unecessary code.
        (patch_method_invocation): Fixed comment.

2000-04-24  Robert Lipe <robertlipe@usa.net>

	* parse.h (_jdep): Member `kind' now ENUM_BITFIELD.

2000-04-23  Tom Tromey  <tromey@cygnus.com>

	* boehm.c (mark_reference_fields): Use int_byte_position.

2000-04-22  Tom Tromey  <tromey@cygnus.com>

	* boehm.c (mark_reference_fields): Only call byte_position on
	non-static fields.

2000-04-22  Tom Tromey  <tromey@cygnus.com>

	* boehm.c (mark_reference_fields): Added `last_view_index'
	argument.  Use DECL_FIELD_OFFSET to determine field's offset.

Thu Apr 20 17:41:28 2000  Mo DeJong  <mdejong@cygnus.com>

	* parse.h (INTERFACE_INNER_MODIFIERS): New macro.
	* parse.y (check_class_interface_creation): Fixed comments. Select
 	permitted modifiers for (inner) interfaces. Changed error message
 	to report rejected modifiers used with local classes.

2000-04-20  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (INNER_ENCLOSING_SCOPE_CHECK): Immediate inner classes
	of directly inherited type considered in scope.
	* parse.y (do_resolve_class): Search inherited classes for inner
	classes.

2000-04-20  Tom Tromey  <tromey@cygnus.com>

	* parse.y (not_accessible_p): Use member's class, not current
	class, when doing inheritance check for protected reference.
	Fixes PR gcj/124.

Thu Apr 20 18:20:58 2000  Jason Schroeder  <shrode@subnature.com>

	* jcf-dump.c (SPECIAL_IINC): Fixed typo printing iinc instruction.

2000-04-19  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (lookup_field_wrapper): Search for final local aliases.
	(resolve_expression_name): Let lookup_field_wrapper search for
	final local aliases. Force the value of `name' if one is found.
	(qualify_ambiguous_name): CONVERT_EXPR is enough to now we have
	an expression name. Fixed comments.

2000-04-19  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (yyerror): `msg' can be null, don't use it in that case.

2000-04-19  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (cxx_keyword_subst): Avoid potential infinite loop.

2000-04-18  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (maybe_make_nested_class_name): Use `obstack_grow0'.

2000-04-18  Tom Tromey  <tromey@cygnus.com>

	PR gcj/211:
	* gjavah.c (utf8_cmp): Changed return value.
	(cxx_keyword_subst): Handle all C++ keywords.  Allocate new return
	result.
	(cxx_keywords): New global.
	(get_field_name): Handle new result of cxx_keyword_subst.
	(print_method_info): Likewise.

2000-04-17  Bryce McKinlay  <bryce@albatross.co.nz>

	* gjavah.c (print_name_for_stub_or_jni): Don't prefix method names 
	with a newline, for CNI.
	(print_stub_or_jni): Print a space or newline before method name for 
	CNI as well as JNI.
	(print_cxx_classname): Don't write leading "::" in CNI stub method.
	(process_file): Include gcj/cni.h if generating CNI stubs.      

2000-04-16  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decompile_method): Use print_field_name.
	Fixes PR gcj/205.

2000-04-14  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_expand_classes): Reverse the package list once.
	(java_complete_lhs): PLUS_EXPR: don't try rhs and lhs at string
	reduction.
	(patch_binop): New temp `cn'. Call patch_string on LHS/RHS of
	the `==' and `!=' operators.

2000-04-05  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): At invokation time,
	always relate an interface method to the type of its selector.
	
2000-04-05  Tom Tromey  <tromey@cygnus.com>

	Fix for PR gcj/2:
	* expr.c (expand_invoke): Generate check to see if object pointer
	is null in nonvirtual invocation case.
	* java-tree.h (soft_nullpointer_node): Declare.
	* decl.c (soft_nullpointer_node): New global.
	(init_decl_processing): Initialize soft_nullpointer_node.
	* parse.y (invocation_mode): Return INVOKE_NONVIRTUAL for `final'
	or `private' methods.
	(patch_invoke): Handle INVOKE_NONVIRTUAL case.

2000-04-05  Tom Tromey  <tromey@cygnus.com>

	Fix for PR gcj/140:
	* parse.y (check_final_assignment): Recognize assignments to the
	`length' field of an array when generating class files.

2000-04-05  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (decl_hash): Prototype removed.
	(decl_compare): Likewise.

2000-04-05  Tom Tromey  <tromey@cygnus.com>

	* parse.h (THIS_MODIFIER_ONLY): Changed meaning of `v' parameter.
	* parse.y (check_modifiers_consistency): Check for final/volatile
	clash.  Fixes PR gcj/164.

2000-04-05  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c: (java_hash_hash_tree_node): Renamed from `decl_hash',
	made global.
	(java_hash_compare_tree_node): Renamed from `decl_compare, made
	global.
	(add_method_1): Use `java_hash_hash_tree_node' and
	`java_hash_compare_tree_node'.
	* java-tree.h: (java_hash_hash_tree_node): Prototyped.
	(java_hash_compare_tree_node): Likewise.
	* parse.y (find_applicable_accessible_methods_list): Create,
	delete and use a hash table to remember already searched interfaces.

2000-04-03  Matt Welsh  <mdw@cs.berkeley.edu>

	* jcf-depend.c (add_entry): Fixed bug where list was always replaced
	with latest entry.

2000-04-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* boehm.c (mark_reference_fields, set_bit): Prototype.
	(set_bit): Un-ANSI-fy definition.

	* class.c (init_test_hash_newfunc, decl_hash, decl_compare):
	Prototype.

	* decl.c (emit_init_test_initialization): Likewise.

	* gjavah.c (jni_print_char): Likewise.

	* parse.y (create_new_parser_context): Likewise.

Thu Mar 30 15:26:56 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (java_lang_expand_expr): Added Anthony's Thu Jan 6 2000
	patch missing hunk. Fixed indentation.

2000-03-30  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (D_NAN_MASK): Only define as word-reversed when
	HOST_FLOAT_WORDS_BIG_ENDIAN and HOST_WORDS_BIG_ENDIAN disagree.

2000-03-28  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse-scan.y (pop_class_context): Reset `inner_qualifier_length'
	when negative *before* using it as an array index.
	* ChangeLog: Fixed typo.

2000-03-28  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse-scan.y (pop_class_context): Reset `inner_qualifier_length'
	to 0 when it reaches -1.

2000-03-27  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (get_constant): Properly cast `num' during the
	invocation of `add_double'.
	* jcf-write.c (push_long_const): Properly cast `lo' before
	comparing it to short bounds.
	* parse-scan.y (interface_declaration:): Rule re-arrange so that
	`interface_body:' is reduced after the current interface is
	pushed.

2000-03-26  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (jvgenmain_spec): Add `%{<...}' construct for each
	Java-specific `-f' option.

Sun Mar 26 11:37:55 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* decl.c (init_decl_processing): Only call initialize_sizetypes once.
	Adjust order of making types.
	Make bitsize_*_node values.

Sat Mar 25 09:12:10 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* class.c (make_field_value): Use byte_position.
	* expr.c (JAVA_ARRAY_LENGTH_OFFSET): Use byte_position.
	(java_array_data_offset): Likewise.
	* java-tree.h (MAYBE_CREATE_TYPE_TYPE_LANG_SPECIFIC): Add case to
	bzero call.

2000-03-22  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (check_abstract_method_definitions): New local
	`end_type_reached'. Make sure we also consider `end_type'.
	(java_check_abstract_method_definitions): Make sure we eventually
	consider `java.lang.Object'.
	(maybe_use_access_method): Don't use access method if not in the
	context of a pure inner class or if the method's context is right.
	(find_applicable_accessible_methods_list): New static flag
	`object_done'. Don't search abstract classes as interfaces. Fixed
	indentation. Fixed the `java.lang.Object' only search. Search
	class interface(s) first, then fully search enclosing contexts.
	(find_most_specific_methods_list): Pick the closest candidate when
	they're all abstract.

Mon Mar 20 08:58:51 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): TRY_FINALLY_EXPR:
	properly initialize `finished_label.' Don't emit gotos for empty
	try statements.

2000-03-19  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* except.c (emit_handlers): Clear catch_clauses_last.

2000-03-17  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (check_method_types_complete): New function.
	(create_class): Reset anonymous class counter only when seeing an
	non inner classe.
	(java_complete_class): JDEP_METHOD: Don't recompute signature
	if incomplete.

2000-03-17  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (build_static_ref): Fixed indentation in comment.
	* java-tree.def (TRY_EXPR): Fixed typo in name.
	(CLASS_LITERAL): Likewise.
	* java-tree.h: (TYPE_DOT_CLASS): New macro.
	(struct lang_type): New field `dot_class'.
	* jcf-write.c (generate_bytecode_insns): Fixed error message.
	(generate_classfile): Method `class$' is synthetic.
	* parse.y (build_do_class_method): New function.
	(build_dot_class_method_invocation): Likewise.
	(java_complete_expand_methods): Expand TYPE_DOT_CLASS if necessary.
	(resolve_qualified_expression_name): Handle CLASS_LITERAL.
	(qualify_ambiguous_name): Likewise.
	(patch_incomplete_class_ref): Invoke synthetic method if necessary.
	(build_try_statement): Fixed leading comment.

Fri Mar 17 08:09:14 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* class.c (make_field_value): Properly handle sizes.
	(get_dispatch_vector): Use tree_low_cst and host_integerp.
	(layout_class_method): Count using trees.
	* decl.c (push_promoted_type): Set TYPE_{MIN,MAX}_VALUE with copy_node.
	* expr.c (java_array_data_offset): Use int_bit_position.
	(build_newarray, build_anewarray): Use host_integerp and tree_low_cst.
	(build_invokevirtual): Use tree_low_cst and do computations with trees.
	
2000-03-16  Tom Tromey  <tromey@cygnus.com>

	* lang.c (flag_hash_synchronization): New global.
	(lang_f_options): Added `hash-synchronization'.
	* lang-options.h: Mention -fhash-synchronization.
	* java-tree.h (flag_hash_synchronization): Declare.
	* expr.c (java_lang_expand_expr): Only push `sync_info' value when
	hash table synchronization is disabled.
	* decl.c (init_decl_processing): Only push `sync_info' value when
	hash table synchronization is disabled.
	* class.c (make_class_data): Only push `sync_info' field when hash
	table synchronization is disabled.  Removed dead code.

2000-03-16  Tom Tromey  <tromey@cygnus.com>

	* lang.c (lang_decode_option): Enable -Wunused when -Wall given.

2000-03-15  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (INNER_ENCLOSING_SCOPE_CHECK): Disregard anonymous
	classes.
	* parse.y (patch_method_invocation): Handle anonymous classes
	creation in static context.

2000-03-15  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (INNER_ENCLOSING_SCOPE_CHECK): New macro.
	* parse.y (resolve_qualified_expression_name): Use it.
	(patch_method_invocation): Likewise.

2000-03-15  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (register_incomplete_type): JDEP_ENCLOSING set
	depending on the type of dependency which dictates what the
	current class is.
	(unresolved_type_p): Resolved types limited to the current class.

2000-03-15  Tom Tromey  <tromey@cygnus.com>

	* decl.c (init_decl_processing): Set type of `sync_info' to be
	pointer to Object.

	* boehm.c (get_boehm_type_descriptor): Correctly compute `bits'.
	Correctly compute bit number for current slot.  Zero `high' and
	`low' in DS_LENGTH case.  Don't skip inherited fields.  Use
	mark_reference_fields.
	(mark_reference_fields): New function.

Tue Mar 14 17:15:41 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (register_incomplete_type): Fixed initialization of
	JDEP_ENCLOSING.

2000-02-28  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse-scan.y (inner_qualifier, inner_qualifier_length): New
	static globals.
	(push_class_context, pop_class_context): New function.
	(class_body:): Call pop_class_context.
	(interface_body:): Likewise.
	(INNER_QUALIFIER): New macro.
	(report_class_declaration): Changed output format and use
	INNER_QUALIFIER. Call push_class_context.

2000-02-14  Andrew Haley  <aph@cygnus.com>

        * check-init.c (check_init): Add new cases for unary and binary
        tree nodes.

2000-03-13  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_package): Set `next' once a type name has been
	progressively discovered.
	(resolve_qualified_expression_name): Propagate resolution only if
	there are remaining qualifiers. Take into account `q' might have
	been cleared after re-qualification.
	* parse.y (patch_method_invocation): New local `resolved'.
  	Section dealing with qualified expression rewritten to use
 	resolve_field_access.

Mon Mar 13 12:21:13 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (PUSH_CPC): Fixed indentation.
	(DEBUG_CPC): New macro.
	(SET_CPC_INITIALIZER_STMT, SET_CPC_STATIC_INITIALIZER_STMT,
 	SET_CPC_INSTANCE_INITIALIZER_STMT): New macros.
	* parse.y (class_body_declaration:): Use
 	SET_CPC_INSTANCE_INITIALIZER_STMT.
	(method_declaration:): Check for null current_function_decl.
	(static_initializer:): Use SET_CPC_STATIC_INITIALIZER_STMT.
	(java_parser_context_pop_initialized_field): Better handling of
 	empty lists.
	(maybe_make_nested_class_name): Mark nested class name as
 	qualified when necessary.
	(end_class_declaration): Don't call java_parse_context_resume when
 	one or more error occured.
	(add_inner_class_fields): Use SET_CPC_INITIALIZER_STMT.
	(register_fields): Use SET_CPC_STATIC_INITIALIZER_STMT and
 	SET_CPC_INITIALIZER_STMT.
	(method_header): Check for inner classes declaring static methods.
	(resolve_qualified_expression_name): Handle situation where `this'
 	is implied.

Mon Mar 13 11:36:51 2000  Hans Boehm <boehm@acm.org>

	* typeck.c (build_prim_array_type): Correctly set the high word too.

2000-03-09  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_complete_expand_methods): Leave <clinit> out of
	ordinary methods.
	(maybe_generate_pre_expand_clinit): Put <clinit> at the end of the
	list of methods for interfaces.

2000-03-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Properly handle expressions
	using `null'.
	
2000-03-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (check_final_assignment): Extended to process
	COMPOUND_EXPR.
	(patch_assignment): Have check_final_assignment called only once.

2000-03-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (IS_INIT_CHECKED): New flag.
	* check-init.c (check_init): Test and set IS_INIT_CHECKED.
	* parse.y (patch_string): Call force_evaluation_order on the
	completed string concatenation tree.
	* expr.c (force_evaluation_order): Call force_evaluation_order on
        function's arguments too.

Mon Mar  6 18:07:07 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* decl.c (emit_init_test_initialization): Mark KEY as unused.
	* expr.c (build_newarray): Cast TREE_INT_CST_LOW to HOST_WIDE_INT.
	(build_anewarray): Likewise.
	* parse.y (patch_newarray): Likewise.
	* parse.c: Regenerated.

2000-03-06  Bryce McKinlay  <bryce@albatross.co.nz>

	* decl.c (init_decl_processing): Added new class fields `depth',
	`ancestors', and `idt' to class_type_node. Use
	_Jv_LookupInterfaceMethodIdx for soft_lookupinterfacemthod_node.
	* class.c (make_class_data): Push initial values for new fields.
	* java-tree.h: Updated prototype for `build_invokeinterface'.
	* expr.c (build_invokeinterface): Changed parameters to accept
	`method' tree. Calculate index of `method' in its declaring
	interface. Build call to _Jv_LookupInterfaceMethodIdx.
	(expand_invoke): Call `build_invokeinterface' with new parameters.
	* parse.y (patch_invoke): Call `build_invokeinterface' with new
	parameters.

2000-03-06  Bryce McKinlay <bryce@albatross.co.nz>

	* typeck.c (lookup_do): Search superinterfaces first
	when looking up an interface method. From Godmar Back
	<gback@cs.utah.edu>

2000-03-06  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (JAVA_SRCS): Added boehm.c, lex.c.

2000-03-02  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (lookup_argument_method2): Declared.
	(safe_layout_class): Prototype moved from parse.h.
	* parse.h (safe_layout_class): Prototype moved to java-tree.h.
	* parse.y (java_check_regular_methods): Local `super_class' gone.
	Call lookup_argument_method2 instead of lookup_argument_method.
	Perform modifier match for methods found declared in implemented
	interfaces. Fixed indentation problem. Overriding/hiding error
	report to take place only for methods found in classes.
	* typeck.c (lookup_argument_method): Changed leading
	comment. Re-written by calling lookup_do.
	(lookup_argument_method2): New function.
	(lookup_java_method): Re-written by calling lookup_do.
	(lookup_do): New function.

Thu Mar  2 15:18:33 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Removed dead code. Handle (blank)
 	final variables.
	* parse.y (declare_local_variables): New local `final_p', set it
 	and use it to initialize LOCAL_FINAL.
	(check_final_assignment): Only check FIELD_DECLs.

2000-02-17  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in (JAVA_OBJS): Added boehm.o.
	(boehm.o): New target.
	* Make-lang.in (JAVA_SRCS): Added boehm.c.
	* java-tree.h (flag_use_boehm_gc): Declare.
	(get_boehm_type_descriptor): Declare.
	* lang.c (lang_f_options): Added `use-boehm-gc'.
	(flag_use_boehm_gc): New global.
	* lang-options.h: Added -fuse-boehm-gc.
	* boehm.c: New file.
	* class.c (get_dispatch_table): If class uses a Boehm type
	descriptor, put it in the vtable.
	(make_class_data): Removed dead code.

2000-03-03  Per Bothner  <per@bothner.com>

	* decl.c (init_decl_processing):  Initialize sizetype properly.

2000-03-01  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (LOCAL_CLASS_P): New flag usage and macro.
	(PURE_INNER_CLASS_DECL_P, PURE_INNER_CLASS_TYPE_P): New macros.
	* jcf-dump.c (HANDLE_INNERCLASSES_ATTRIBUTE): New macro.  
	* jcf-parse.c (HANDLE_INNERCLASSES_ATTRIBUTE): Likewise.
	(jcf_parse): New local `current'. Load innerclasses seen in outer
	context being processed.
	* jcf-reader.c (HANDLE_INNERCLASSES_ATTRIBUTE): New macro.
	* jcf-write.c (append_innerclasses_attribute): New function.
	(append_innerclasses_attribute_entry): Likewise.
	(get_access_flags): Handle static classes. Set anonymous and local
	classes to be private.
	(generate_classfile): Attribute count adjusted. Call
	append_innerclasses_attribute.
	* parse.h (SKIP_THIS_AND_ARTIFICIAL_PARMS): Use
	PURE_INNER_CLASS_TYPE_P.
	* parse.y (parser_qualified_classname): New parameter `is_static',
	produce non qualified name accordingly.
	(block_statement:): Set LOCAL_CLASS_P when declaring local class.
	(create_interface): Added argument to parser_qualified_classname.
	(create_class): Added argument to parser_qualified_classname. Setup
	alias for top level classes. Use PURE_INNER_CLASS_DECP_P.
	(add_inner_class_fields): Fixed indentation.
	(method_declarator): Use PURE_INNER_CLASS_DECP_P.
	(method_declarator): Fixed typo in comment.
	(craft_constructor): Use PURE_INNER_CLASS_DECP_P.
	(build_current_thisn): Likewise.
	(patch_method_invocation): Likewise.

2000-03-01  Martin von Loewis  <loewis@informatik.hu-berlin.de>

	* decl.c (current_function_decl): Move to toplev.c.

Mon Feb 28 08:20:42 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* java-tree.h (LABEL_PC): Relect name changes in ../tree.h.
	(DECL_BIT_INDEX): Use underlying representation.
	* parse.h (DECL_INHERITED_SOURCE_LINE): Likewise.

Sun Feb 27 16:40:33 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (build_java_ret): Pass proper type to size_binop.

2000-02-25  Anthony Green  <green@cygnus.com>

	* expr.c (build_class_init): Mark the decl to be ignored by
	check_init.
	* java-tree.h (DECL_BIT_INDEX): Move definition from check-init.c
	* check-init.c: Move DECL_BIT_INDEX to java-tree.h
	* class.c (init_test_hash_newfunc): New function.
	(decl_hash): New function.
	(decl_compare): New function.
	* decl.c (emit_init_test_initialization): New function.
	(complete_start_java_method): Traverse the init test hashtable,
	calling emit_init_test_initialization.
	(always_initialize_class_p): Define.
	* expr.c (build_class_init): Use initialization tests when
	emitting class initialization code.
	(always_initialize_class_p): Declare.
	* jcf-parse.c (parse_class_file): Set always_initialize_class_p to
	1.
	* java-tree.h: Include hash.h.
	(DECL_FUNCTION_INIT_TEST_TABLE): Define.
	(struct lang_decl): Add init_test_table field.
	(init_test_hash_entry): Define.

Fri Feb 25 18:41:31 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* gjavah.c (main): Avoid using `argi' to report unimplemented
	options.

Fri Feb 25 18:47:25 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): TRY_FINALLY_EXPR:
 	initialize locals to avoid warnings. Local `exception_type' moved
	into if statement.

Fri Feb 25 18:00:37 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_expression_name): Use `orig' as a second
 	argument to resolve_field_access.
	(resolve_field_access): Removed unecessary code when dealing with
 	static fields.

Wed Feb 23 17:41:50 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (push_super_field): Don't push the field twice.
	* jcf-parse.c (parse_source_file): Call java_reorder_fields.
	* parse.h (java_reorder_fields): Prototyped.
	* parse.y (java_reorder_fields): New function.
	(java_layout_class): Simplified not to worry about re-ordering.

2000-02-23  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_name): In JNI case, correctly quote string.
	(print_method_info): Don't handle overrides in JNI mode.

2000-02-22  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (init_decl_processing): `_Jv_IsInstanceOf' returned
	value type set to `boolean_type_node'.

Mon Jan 18 14:30:09 2000  Joerg Brunsmann  <joerg.brunsmann@fernuni-hagen.de>

	* jcf-dump.c (main): Test for correct condition after
	output file creation.

2000-02-19  Anthony Green  <green@cygnus.com>

	* jcf-depend.c (add_entry): Fix test for first list entry.

Sat Feb 19 18:43:13 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* class.c (build_class_ref, push_super_field): Set DECL_SIZE_UNIT.
	* constants.c (build_constants_constructor): Likewise.

2000-02-19  Anthony Green  <green@cygnus.com>

	* jcf-depend.c (add_entry): Add entries to the end of the list.

Wed Nov 03 02:16:00 PST 1999  Pekka Nikander  <pekka.nikander@hut.fi>

	* decl.c (INT_TYPE_SIZE): Define if necessary.
	(expand_java_return): Handle the case of a native integer smaller
 	than a JVM integer.

2000-02-18  Martin von Loewis  <loewis@informatik.hu-berlin.de>

	* gjavah.c (help): Use GCCBUGURL.
	* jv-scan.c (help): Likewise.
	* jcf-dump.c (help): Likewise.

Thu Feb 17 14:30:37 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): Don't generate empty
 	`finally' clauses.

Thu Feb 17 13:20:58 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (load_class): Call `fatal' if no file containing
	the target class are found.

2000-02-16  Zack Weinberg  <zack@wolery.cumb.org>

	* Makefile.in (PARSE_C, PARSE_SCAN_C): Move dependencies on
	lex.c, lex.h, and PARSE_H to...                            
	(parse.o, parse-scan.o): ...here, respectively.

	* lex.c: Split out code that may trigger SIGFPE from yylex()
	to its own function.
	* lex.h (JAVA_FLOAT_RANGE_ERROR): Don't set value.

2000-02-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (jvspec.o): Depend on $(GCC_H), not gcc.h.

2000-02-15  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (outer_field_access_p): Stop in time when outer contexts
 	are exhausted.
	(resolve_qualified_expression_name): Properly qualify *everything*
 	after a package.type to be resoled as expression names.
	(find_applicable_accessible_methods_list): Save/restore `class' to
 	isolate it from a possible outer context search.

2000-02-15  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (jni_print_char): New function.
	(print_full_cxx_name): Use it.
	(decode_signature_piece): Likewise.
	(print_cxx_classname): Likewise.

2000-02-15  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (jv-scan, jcf-dump, gcjh): Depend on and link with
	version.o.
	(jcf-dump.o, gjavah.o, jv-scan.o): Depend on version.h.

	* gjavah.c: Include version.h.
	
	* jcf-dump.c: Likewise.

	* jv-scan.c: Likewise.

Sat Feb 12 04:34:04 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (outer_field_access_fix): First parameter now a tree
	node. Check for assignement to final. First argument to
	build_outer_field_access_fix modified to accomodate prototype.
	(build_outer_field_access): Don't check for assignment to final
	here.
	(java_complete_lhs): MODIFY_EXPR case: Check for `error_mark_node'
	possibly returned by outer_field_access_fix. Changed
	outer_field_access_fix's first argument.
	(check_final_assignment): $finit$'s context is OK.
	(patch_unaryop): Use node instead of its line/column value when
	calling outer_field_access_fix.

Fri Feb 11 17:38:26 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (interface_declaration:): No longer tagged
 	<node>. Re-installed default action.
	(class_member_declaration:): Handle inner interfaces.
	(interface_member_declaration): Handle inner interfaces and
 	classes.
	(create_interface): Push error if one seen. Suspend parsing
 	context when processing an inner interface.
	(register_fields): Inner class static field limitations not to
 	apply to inner interfaces.

Thu Feb 10 22:07:35 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (load_class): Update `java_error_count' when a
 	class' file can't be found.
	(parse.y): Avoid (byte)code generation when errors seen.

Thu Feb 10 20:10:43 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_complete_lhs): Handle TRUNC_DIV_EXPR. Ensure `fatal'
 	decodes a valid node.
	(patch_binop): Handle TRUNC_DIV_EXPR.

Thu Feb 10 16:04:26 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_package): New local `acc.' Try to progressively
 	build and guess a package and type name.

Thu Feb 10 12:52:09 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_applicable_accessible_methods_list): Load and
 	layout the search class if necessary.
	(java_complete_tree): Keep to original type of the folded initial
 	value.

2000-02-09  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * class.c (layout_class): Set and test CLASS_BEING_LAIDOUT.
        Generate error message if circularity is detected. New static
        local `list.'
        * java-tree.h (CLASS_BEING_LAIDOUT): New flag usage, new macro.  *
        * jcf-write.c (generate_bytecode_insns): Very simply handle
        SAVE_EXPR.
        * parse.y (java_check_circular_reference): Use
        `cyclic_inheritance_report' during report, if necessary.
        (java_complete_lhs): fixed comment with `THROW_EXPR:' case. Avoid
        walking NEW_ARRAY_INIT twice.

2000-02-09  Tom Tromey  <tromey@cygnus.com>

        * parse.y (check_class_interface_creation): Allow inner classes to
        be `private' or `protected', check modifiers' consistency. Prevent
        block local classes from bearing any modifiers.

2000-02-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* except.c (check_start_handlers): Re-add prototype lost in last
	patch.
	(maybe_start_try): Remove excess argument to `check_start_handlers'.

2000-02-09  Andrew Haley  <aph@cygnus.com>

	* decl.c (clear_binding_level): Remove excess initializer.
	(maybe_poplevels): Remove unused variable.
	(force_poplevels): Ditto.
	(struct binding_level): Add comment.
	
2000-02-07  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * jcf-write.c (generate_classfile): Don't consider
        pre-initialization with reference value (use <clinit> instead.)
        * parse.y (java_fix_constructors): No generated constructor for
        interfaces.
        (build_outer_field_access): Removed debug message.
        (outer_field_expanded_access_p): Adapted to bytecode generation.
        (build_outer_field_access_method): Use fix_method_argument_names.
        (build_outer_method_access_method): Fixed indentation. Added
        comment. Handle access method generation for static and also void
        methods.
        (build_access_to_thisn): Inserted debug message.
        (maybe_build_thisn_access_method): Use fix_method_argument_names.
        (resolve_qualified_expression_name): Fixed comment.
        (not_accessible_p): Adapted to bytecode generation. Added comment.
        (patch_method_invocation): Added comment.
        (maybe_use_access_method): Fixed leading comment. Handle static
        methods.
        (java_complete_lhs): Don't shortcut handling of initialized upon
        declaration String type static fields when generating bytecode.
        (patch_unaryop): Handle outer field access when generating
        bytecode.

Thu Feb  3 20:23:19 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (FIELD_THISN): New macro.
	* jcf-write.c (append_synthetic_attribute): New function.
	(generate_classfile): Set "Synthetic" attribute on this$<n>,
 	val$<name> fields, access$<n> and $finit$ methods. Fixed indentation.
	* parse.y (add_inner_class_fields): Set FIELD_THISN for created
 	this$<n> fields.
	(build_outer_field_access): Turned on access functions usage and
 	generation when compiling to bytecode.
	(maybe_use_access_method): Likewise.

2000-01-25  Andrew Haley  <aph@cygnus.com>

        * java-except.h (struct eh_range): Add `expanded' field.
        (maybe_start_try): Add end_pc arg.
        (maybe_end_try): Ditto.
	* java-tree.h (force_poplevels): new function.
        * expr.c (expand_byte_code): Don't call maybe_start_try or
        maybe_end_try.
        * except.c (add_handler): Reset expanded.
        (expand_start_java_handler): Set expanded.
        (check_start_handlers): Don't expand a start handler that's
        already been expanded.
        (maybe_start_try): Add end_pc arg.  Only expand a handler which
        ends after end_pc.
	(expand_end_java_handler): call force_poplevels.
	(force_poplevels): new function.
        * decl.c (binding_level): Add start_pc of binding level.
        (maybe_pushlevels): Call maybe_start_try when pushing binding
        levels.
        (maybe_poplevels): Call maybe_end_try when popping binding levels.
        (LARGEST_PC): Define.
        (clear_binding_level): Use LARGEST_PC.

	* java-tree.h (DEBUG_JAVA_BINDING_LEVELS): new define.
	* decl.c (DEBUG_JAVA_BINDING_LEVELS): new define.
	(binding_depth, is_class_level, current_pc): new variables.
        (struct binding_level): ditto.
	(indent): new function.
	(push_jvm_slot): add debugging info.
	(maybe_pushlevels): ditto.
	(maybe_poplevels): ditto.
	(pushlevel): ditto.
	(poplevel): ditto.
	(start_java_method): ditto.
	(give_name_to_locals): comment only.
	* except.c (binding_depth, is_class_level, current_pc): 
	new variables.
	(expand_start_java_handler): add debugging info.
	(expand_end_java_handler): ditto.
	
2000-02-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (overloaded_jni_method_exists_p): Add prototype.
	(print_name_for_stub_or_jni, process_file): Constify a char*.

2000-02-03  Tom Tromey  <tromey@cygnus.com>

	* jcf-io.c (jcf_print_utf8_replace): Handle UTF-8 input.

2000-01-31  Scott Bambrough  <scottb@netwinder.org>

	* gcc/java/javaop.h (WORDS_TO_DOUBLE): Allow WORDS_TO_DOUBLE to
	assemble doubles correctly when HOST_FLOAT_WORDS_BIG_ENDIAN is
	defined to be 1.

Wed Feb  2 18:43:37 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.def (INSTANCE_INITIALIZERS_EXPR): New tree code.
	* java-tree.h (TYPE_II_STMT_LIST): New macro.
	(struct lang_type): New field `ii_block'.
	* lex.c (java_init_lex): Use CPC_INITIALIZER_LIST,
	CPC_STATIC_INITIALIZER_LIST and CPC_INSTANCE_INITIALIZER_LIST.
	* parse.h (struct parser_ctxt): New field `instance_initializers'.
	(CPC_INITIALIZER_LIST, CPC_STATIC_INITIALIZER_LIST,
	CPC_INSTANCE_INITIALIZER_LIST, CPC_INITIALIZER_STMT,
	CPC_STATIC_INITIALIZER_STMT, CPC_INSTANCE_INITIALIZER_STMT): New
	macros.
	* parse.y (add_instance_initializer): New function.
	(in_instance_initializer): New static global.
	(class_body_declaration:): Link instance initializer block.
	(static_initializer:): Use CPC_STATIC_INITIALIZER_STMT.
	(array_creation_expression:): Remove unused local.
	(java_parser_context_push_initialized_field): Fixed leading
	comment. Use CPC_STATIC_INITIALIZER_LIST, CPC_INITIALIZER_LIST and
	CPC_INSTANCE_INITIALIZER_LIST.
	(java_parser_context_pop_initialized_field): Likewise.
	(add_inner_class_fields): Use CPC_INITIALIZER_STMT.
	(register_fields): Use CPC_STATIC_INITIALIZER_STMT and
	CPC_INITIALIZER_STMT.
	(fix_constructors): New local `class_type'. Use it. Call
	add_instance_initializer.
	(java_complete_lhs): New case INSTANCE_INITIALIZERS_EXPR.
	(patch_return): Forbid return in instance initializers.
	(patch_throw_statement): Enforce exception handling in the context
	of instance initializers.
	
2000-02-03  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (java.mostlyclean): Remove executables in
	`mostlyclean'.

2000-01-31  Scott Bambrough  <scottb@netwinder.org>

	* gcc/java/gjavah.c (D_NAN_MASK): Alternate definition required when
	HOST_FLOAT_WORDS_BIG_ENDIAN is defined to be 1.
	(java_float_finite): Convert to use union Word from javaop.h.
	(java_double_finite): Convert to use union DWord from javaop.h.

2000-02-02  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (options): Added `jni' entry.
	(help): Document -jni.
	(flag_jni): New global.
	(process_file): Handle JNI output.  Don't print text from
	-prepend, -add, etc, when generating stubs.  Only remove `.class'
	suffix if it actually exists.
	(main): Create a `.c' file when run with `--jni --stubs'.  Create
	correct output file name with `--jni'.
	(print_include): Mangle header name differently in JNI case.
	(HANDLE_METHOD): In JNI mode, call print_method_info to generate
	method list.
	(print_method_info): Handle JNI case.  Put signature info into
	method name.  Handle case when STREAM is NULL.
	(print_name_for_stub_or_jni): New function.
	(print_stub_or_jni): Renamed from `print_stub'.  Handle JNI.
	(print_cxx_classname): Handle JNI.
	(print_full_cxx_name): Likewise.
	(decode_signature_piece): Likewise.
	(overloaded_jni_method_exists_p): New function.
	(struct method_name): Added `signature' and `sig_length' fields.
	(HANDLE_END_FIELD): Do nothing in JNI mode.

2000-02-02  Tom Tromey  <tromey@cygnus.com>

	* jv-scan.c: Include version.c, <getopt.h>.
	(LONG_OPT, OPT_HELP, OPT_VERSION): New macros.
	(options): New array.
	(usage): New function.
	(version): New function.
	(main): Use getopt_long to parse command line.
	* jcf-dump.c: Include version.c, <getopt.h>.
	(LONG_OPT, OPT_classpath, OPT_CLASSPATH, OPT_HELP, OPT_VERSION,
	OPT_JAVAP): New macros.
	(options): New array.
	(usage): Return `void'.  Changed message.
	(help): New function.
	(version): New function.
	(main): Use getopt_long_only to parse command line.
	* gjavah.c: Include <getopt.h>.
	(LONG_OPT, OPT_classpath, OPT_CLASSPATH, OPT_HELP, OPT_TEMP,
	OPT_VERSION, OPT_PREPEND, OPT_FRIEND, OPT_ADD, OPT_APPEND, OPT_M,
	OPT_MM, OPT_MG, OPT_MD, OPT_MMD): New macros.
	(options): New array.
	(java_no_argument): Removed.
	(help): Updated with missing options.
	(main): Use getopt_long_only to parse command line.
	(usage): Changed message.

Tue Feb  1 22:23:41 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.def (NEW_ANONYMOUS_ARRAY_EXPR): New tree code.
	* parse.h (ANONYMOUS_ARRAY_BASE_TYPE, ANONYMOUS_ARRAY_DIMS_SIG,
	ANONYMOUS_ARRAY_INITIALIZER): New access macros.
	* parse.y (array_creation_expression:): Handle anonymous arrays.
	(build_array_from_name): Don't set `ret_name' if null.
	(resolve_qualified_expression_name): New case NEW_ANONYMOUS_ARRAY_EXPR.
	(qualify_ambiguous_name): Likewise.
	(java_complete_expand_class): Likewise.

Tue Feb  1 14:59:35 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.def (SYNCHRONIZED_EXPR): Fixed typo.
	* parse.h (MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_ID): New macro.
	(MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_STR): Likewise.
	(SKIP_THIS_AND_ARTIFICIAL_PARMS): Use DECL_FINIT_P.
	(AIPL_FUNCTION_FINIT_INVOCATION): Replaces
	AIPL_FUNCTION_COMPLETED_INVOCATION.
	(AIPL_FUNCTION_CTOR_INVOCATION): Replaces 
	AIPL_FUNCTION_INVOCATION_READY.
	(AIPL_FUNCTION_DECLARATION): New enum entry.
	* parse.y (reorder_static_initialized): New function.
	(java_parser_context_pop_initialized_field): Use it.
	(add_inner_class_fields): Use
	MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_ID. Comment
	augmented. Install marker after last alias initializer, if any.
	(generate_finit): Fixed typo. Don't try to retain only the used
	fields.
	(method_header): Compute and set DECL_FUNCTION_NAP.
	(method_declarator): Fixed comment. Insert alias initializer in
	parameter list.
	(build_alias_initializer_parameter_list): Fixed leading
	comment. New case for AIPL_FUNCTION_DECLARATION. Old enum value
	replaced by new ones. Use MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_ID.
	(java_complete_expand_class): Code to retain only used aliases
	removed.
	(java_complete_expand_methods): New local `first_decl'. Generate
	$finit$ first, then expand the constructors, regular methods and
	<clinit>.
	(java_complete_expand_method): Don't report error on missing
	return statement if previously detected bogus.
	(fix_constructors): Don't patch constructor parameters list.
	(patch_method_invocation): Use new AIPL enum values. Reverse
	alias initializer list for anonymous classes.
	
2000-01-30  Anthony Green  <green@redhat.com>

	* jcf-write.c (generate_bytecode_insns): Use TYPE_IS_WIDE to
	determine how many stack slots to pop.

2000-01-29  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (formal_parameter:): Set `$$' to NULL_TREE for better
	error handling/recovery.
	* java-tree.h (SYNCHRONIZED_EXPR): Fixed typo in comment.

Fri Jan 28 20:10:57 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (ARG_FINAL_P, FIELD_LOCAL_ALIAS,
 	FIELD_LOCAL_ALIAS_USED): New macros.
	(DECL_FUNCTION_NAP): New macro.
	(struct lang_decl): New field `nap'.
	(TYPE_FINIT_STMT_LIST, TYPE_CLINIT_STMT_LIST): New macros.
	(struct lang_type): New fields `finit_stmt_list' and
 	`clinit_stmt_list'.
	(CLASS_HAS_FINIT_P): Defined using TYPE_FINIT_STMT_LIST.
	* parse.h (MANGLE_OUTER_LOCAL_VARIABLE_NAME): New macro.
	(SKIP_THIS_AND_ARTIFICIAL_PARMS, MARK_FINAL_PARMS,
 	UNMARK_FINAL_PARMS, CRAFTED_PARAM_LIST_FIXUP): New macros.
	(AIPL_FUNCTION_CREATION, AIPL_FUNCTION_COMPLETED_INVOCATION,
 	AIPL_FUNCTION_INVOCATION_READY): New enum fields.
	(BUILD_THROW): Macro line separator re-indented.
	* parse.y (end_class_declaration): New function.
	(maybe_generate_pre_expand_clinit): New name for
 	java_pre_expand_clinit. Create <clinit> off TYPE_CLINIT_STMT_LIST,
 	pre-expand static fields.
	(maybe_generate_clinit): Function deleted.
	(check_for_static_method_reference): Prototype's parameter list
 	indented.
	(generate_finit): New name for maybe_generate_finit. Changed
 	leading comment. Function rewritten to use
 	TYPE_FINIT_STMT_LIST. Call build_alias_initializer_parameter_list.
	(build_alias_initializer_parameter_list): New function.
	(java_parser_context_pop_initialized_field): Likewise.
	(add_inner_class_fields): Likewise.
	(type_declaration:): Call end_class_declaration.
	(class_member_declaration:): Likewise.
	(formal_parameter_list:): Fixed typos.
	(formal_parameter:): Use ARG_FINAL_P to mark created tree list
 	element. Improved error handling.
	(block_statement:): Call end_class_declaration.
	(anonymous_class_creation:): Likewise.
	(create_anonymous_class): Fixed comments.
	(create_class): Call add_inner_class_fields.
	(register_fields): Set FIELD_LOCAL_ALIAS according to ARG_FINAL_P.
	(method_header): Use MARK_FINAL_PARMS.
	(finish_method_declaration): Use UNMARK_FINAL_PARMS.
	(method_declarator): Propagate final argument flag.
	(craft_constructor): New local `artificial'. Call
 	build_alias_initializer_parameter_list. Use
 	CRAFTED_PARAM_LIST_FIXUP, assign DECL_FUNCTION_NAP.
	(source_start_java_method): Mark parm decls with LOCAL_FINAL if
 	necessary.
	(complete_expand_class): Get rid of unused outer context local
 	alias fields.
	(java_complete_expand_methods): Fixed leading
 	comment. Generate/pre-expand <clinit> first. Changed method
 	expansion order to regular, $finit$, constructors, <clinit>.
	(java_complete_expand_method): Set current_function_decl.
	(fix_constructors): Fix constructor parameter list to account for
 	outer context local alias initializers.
	(verify_constructor_super): Use SKIP_THIS_AND_ARTIFICIAL_PARMS.
	(resolve_expression_name): Lookup outer context local aliases. New
 	local `access', use it.
	(patch_method_invocation): Patch inner class ctor invocation with
 	outer context local aliases initialization values. $finit$
 	invocation patching now includes things generated with
 	build_alias_initializer_parameter_list.
	(argument_types_convertible): Use SKIP_THIS_AND_ARTIFICIAL_PARMS.
	(build_super_invocation): Likewise.
	(patch_assignment): Changed comment.

2000-01-27  Andrew Haley  <aph@cygnus.com>

        * jcf-write.c (emit_goto): RESERVE 3 bytes for insn.
        (emit_if): Ditto.
        (emit_jsr): Ditto.

2000-01-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* parse.h (OBSOLETE_MODIFIER_WARNING): Don't use ANSI string
	concatenation.
	(OBSOLETE_MODIFIER_WARNING2): New macro allowing two args.

	* parse.y (register_fields): Don't pass a format specifier to
	OBSOLETE_MODIFIER_WARNING.
	(check_abstract_method_header): Use OBSOLETE_MODIFIER_WARNING2
	instead of OBSOLETE_MODIFIER_WARNING, and don't pass a format
	specifier.
	(check_modifiers): Change function into a macro.
	(check_class_interface_creation): Pass a literal format string.

2000-01-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* buffer.h: PROTO -> PARAMS.
	* check-init.c: Likewise.
	* class.c: Likewise.
	* constants.c: Likewise.
	* convert.h: Likewise.
	* decl.c: Likewise.
	* except.c: Likewise.
	* expr.c: Likewise.
	* gjavah.c: Likewise.
	* java-except.h: Likewise.
	* java-tree.h: Likewise.
	* jcf-depend.c: Likewise.
	* jcf-dump.c: Likewise.
	* jcf-parse.c: Likewise.
	* jcf-path.c: Likewise.
	* jcf-reader.c: Likewise.
	* jcf-write.c: Likewise.
	* jcf.h: Likewise.
	* jv-scan.c: Likewise.
	* jvgenmain.c: Likewise.
	* jvspec.c: Likewise.
	* lang.c: Likewise.
	* lex.c: Likewise.
	* lex.h: Likewise.
	* parse-scan.y: Likewise.
	* parse.h: Likewise.
	* parse.y: Likewise.
	* typeck.c: Likewise.
	* verify.c: Likewise.
	* xref.c: Likewise.
	* xref.h: Likewise.
	* zextract.c: Likewise.
	* zipfile.h: Likewise.
	
2000-01-18  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (make_class): Use MAYBE_CREATE_TYPE_TYPE_LANG_SPECIFIC.
	(is_compiled_class): Remove test on TYPE_LANG_SPECIFIC, use TYPE_JCF.
	* constants.c (build_constant_data_ref): Check for cached
	current_constant_pool_data_ref. Cache current_constant_pool_data_ref
	in TYPE_CPOOL_DATE_REF.
	* java-tree.h (TYPE_JCF, TYPE_CPOOL, TYPE_CPOOL_DATA_REF,
	MAYBE_CREATE_TYPE_TYPE_LANG_SPECIFIC:) New macros.
	(struct lang_type): New fields `cpool' and `cpool_data_ref'.
	(LOCAL_FINAL): New macro.
	* jcf-parse.c (init_outgoing_cpool): Always allocate new outgoing
	constant pool -- don't try to reuse.
	(parse_zip_file_entries): Use TYPE_JCF, don't lazily allocate
	TYPE_LANG_SPECIFIC.
	(find_in_current_zip): Use TYPE_JCF.
	* parse.h (java_check_final): Prototype removed.
	* parse.y (create_class): Reversed Jan 12, 2000 extra argument patch.
	(maybe_create_class_interface_decl,
	check_class_interface_creation): Likewise.
	(java_expand_finals): Function removed.
	(class_declaration:): Reversed Jan 12, 2000 extra argument patch.
	(block_statement:): Fixed comment.
	(anonymous_class_creation:): Likewise.
	(check_class_interface_creation): Reversed Jan 12, 2000 extra
	argument patch.
	(check_class_interface_creation): Loosened error report on (inner)
	public class declarations. CPC_INNER_P replaces GET_CPC_LIST.
	(link_nested_class_to_enclosing): Reversed Jan 12, 2000 patch.
	(maybe_create_class_interface_decl): Reversed Jan 12, 2000 extra
	argument patch.
	(create_interface): Likewise.
	(anonymous_class_counter): New static global.
	(create_anonymous_class): Reversed Jan 12, 2000 extra argument
	patch. Fixed comments.
	(create_class): Reversed Jan 12, 2000 extra argument patch. Reset
	anonymous_class_counter when declaring a toplevel class.
	(craft_constructor): Fixed constructor name when handling
	anonymous classes. Anonymous class constructors to feature hidden
	this$<n> parameter.
	(java_fix_constructors): Added comment.
	(java_check_final): Function removed.
	(java_complete_expand_methods): Fixed comment. Don't generate
	class data, save its outgoing constant pool instead.
	(verify_constructor_super): Skip anonymous class constructor
	hidden this$<n> parameter.
	(java_expand_classes): New local `saved_ctxp'. Removed call to
	java_expand_finals and java_check_final. Expand anonymous class
	constructors. Generate class data.
	(build_super_invocation): Skip anonymous class hidden this$<n>
	parameter.
	* typeck.c (build_java_signature): Use TYPE_SIGNATURE and
	MAYBE_CREATE_TYPE_TYPE_LANG_SPECIFIC.
	(set_java_signature): Likewise.
	
Mon Jan 18 14:30:09 2000  Joerg Brunsmann  <joerg.brunsmann@fernuni-hagen.de>

	* gjavah.c: Delete ACC_VISIBILITY define.
	* jcf.h: Add ACC_VISIBILITY define.
	* parse.y: final: rule tagged <value>.
	(java_check_regular_methods): Use ACC_VISIBILITY define for
	default package access check.
	(local_variable_declaration_statement): Use final: rule.

Mon Jan 17 11:58:17 2000  Joerg Brunsmann  <joerg.brunsmann@fernuni-hagen.de>

	* parse.y (format_parameter:): Use final: rule instead of modifiers:.
	(final:): New rule.

2000-01-17  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_field_info): Allow non-static final fields.

Fri Jan 14 18:03:41 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (enum jdep_code): New entry `JDEP_ANONYMOUS'.
	* parse.y (patch_anonymous_class): New function.
	(create_anonymous_class): Register incomplete type when the
 	class/interface to extends/implement isn't known yet.
	(parser_check_super_interface): Simplify argument to CLASS_INTERFACE.
	(verify_constructor_super): Tuned error message.

Fri Jan 14 00:14:24 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (FOR_LOOP_P): Replaces IS_FOR_LOOP_P.
	(ANONYMOUS_CLASS_P): New macro.
	(TYPE_SIGNATURE, TYPE_JCF): New macros.
	(INNER_CLASS_TYPE_P): Fixed typo in leading comment.
	* parse.y (create_class): Added leading argument.
	(maybe_create_class_interface_decl,
 	check_class_interface_creation): Likewise.
	(craft_constructor): New function.
	(verify_constructor_super): Added argument in prototype.
	(class_declaration:): Inserted leading argument.
	(for_begin:): Use FOR_LOOP_P.
	(anonymous_class_creation): Create WFL of the anonymous class to
 	instantiate. Call build_new_invocation. Added comments.
	(check_class_interface_creation): Handle parameter `anonymous' in
 	verbose mode class creation announce.
	(link_nested_class_to_enclosing): Exclude anonymous classes.
	(maybe_create_class_interface_decl): Don't set DECL_CONTEXT on
 	anonymous class, even though they appear to have an enclosing
 	context.
	(create_interface): Pass extra argument to
 	check_class_interface_creation.
	(create_anonymous_class): Set ANONYMOUS_CLASS_P to 1.
	(create_class): Call check_class_interface_creation and
 	maybe_create_class_interface_decl with extra new argument. Don't
 	add private this$<n> to anonymous classes.
	(method_declarator): Insert hidden this$<n> to anonymous class
 	constructors.
	(java_fix_constructors): Deleted code creating default
 	constructor. Call craft_constructor instead.
	(java_check_regular_methods): Set `saw_constructor' to 1 for
 	anonymous classes.
	(fix_constructors): Pass extra argument to verify_constructor_super.
	(verify_constructor_super): New local `sdecl', use it. Search for
 	matching constructor (possibly featuring arguments) in super
 	class.
	(lookup_method_invoke): Craft constructor according to arguments
 	list when dealing with anonymous class constructors.
	(build_super_invocation): Pass arguments to anonymous class super
 	constructors.
	(search_loop): Use FOR_LOOP_P.
	(labeled_block_contains_loop_p): Likewise.
	
Wed Jan 12 00:38:47 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (set_super_info): Set CLASS_STATIC when appropriate.
	(enclosing_context_p): New function.
	(get_access_flags_from_decl): Handle CLASS_STATIC.
	(maybe_layout_super_class): Extra first argument passed to
 	do_resolve_class.
	(layout_class_method): Use ID_FINIT_P, DECL_CLINIT_P and
 	ID_INIT_P.
	* decl.c (access0_identifier_node): New global.
	(init_decl_processing): access0_identifier_node initialized. 
	(pushdecl): Set DECL_CONTEXT only on non type decls.
	* expr.c (lookup_field): Lookup inner class fields in enclosing
 	contexts.
	(expand_invoke): Use ID_INIT_P.
	(expand_java_field_op): Use DECL_CLINIT_P.
	* java-tree.def (CLASS_LITERAL): New tree code.
	* java-tree.h (DECL_FUNCTION_ACCESS_DECL,
 	DECL_FUNCTION_INNER_ACCESS, FIELD_INNER_ACCESS): New macros.
	(struct lang_decl): New field `inner_access'.
	(enclosing_context_p): Prototyped.
	(DECL_INIT_P, DECL_FINIT_P, DECL_CLINIT_P, ID_INIT_P, ID_FINIT_P,
 	ID_CLINIT_P): New macros.
	(CLASS_STATIC): New macro.
	(CLASS_ACCESS0_GENERATED_P): New macro.
	(OUTER_FIELD_ACCESS_IDENTIFIER_P, INNER_CLASS_DECL_P,
 	TOPLEVEL_CLASS_DECL_P, INNER_CLASS_TYPE_P, TOPLEVEL_CLASS_TYPE_P,
 	INNER_CLASS_P): New macros.
	(DECL_INNER_CLASS_LIST): New macro.
	* jcf-parse.c (yyparse): Avoid the use of ANSI string
 	concatenation.
	* jcf-write.c (generate_bytecode_insns): binop: Change the type of
 	the shift value to int. Fixed typo in comment.
	* lex.c (inst_id, wpv_id): Initialize.
	* mangle.c (unicode_mangling_length): Take `$' into account.
	* parse.h (DRECOVER, RECOVER): Terminate properly.
	(IDENTIFIER_INNER_CLASS_OUTER_FIELD_ACCESS): New macro.
	(typedef struct _jdep): New field `enclosing'.
	(JDEP_ENCLOSING): New macro.
	(IS_CLINIT): Deleted (DECL_CLINIT_P replaces it.)
	(struct parser_ctxt): New fields `marker_beginning', `marked_end'.
	(GET_CPC_LIST, CPC_INNER_P, GET_CPC, GET_CPC_UN, GET_CPC_UN_MODE,
 	GET_CPC_DECL_NODE, GET_ENCLOSING_CPC, GET_NEXT_ENCLOSING_CPC,
 	GET_ENCLOSING_CPC_CONTEXT): New macros.
	(PUSH_CPC, PUSH_ERROR, POP_CPC): New macros.	
	(do_resolve_class): Added extra argument in prototype.
	* parse.y (resolve_class): Added extra argument in prototype.
	(maybe_create_class_interface_decl): Likewise.
	(maybe_use_access_method, build_wfl_wrap): New functions.
	(java_complete_expand_classes, java_complete_expand_class):
 	Likewise.
	(java_parser_context_push_initialized_field,
 	java_parser_context_suspend, java_parser_context_resume):
 	Likewise.
	(maybe_make_nested_class_name, make_nested_class_name,
 	set_nested_class_simple_name_value,
 	link_nested_class_to_enclosing, find_as_inner_class,
 	find_as_inner_class_do, check_inner_class_redefinition,
 	build_thisn_assign, build_current_thisn, build_access_to_thisn,
 	maybe_build_thisn_access_method, build_outer_field_access,
 	build_outer_field_access_methods, build_outer_field_access_expr,
 	build_outer_method_access_method, build_new_access_id,
 	build_outer_field_access_method, outer_field_access_p,
 	outer_field_expanded_access_p, outer_field_access_fix,
 	build_incomplete_class_ref, patch_incomplete_class_ref,
 	create_anonymous_class): Likewise.
	(inst_id, wpv_id): New static global variables.
	(synchronized:): New rule, tagged <node>.
	(type_declaration:): No longer tagged <node>. Call POP_CPC in sub
 	rules.
	(anonymous_class_creation:): New rule, tagged <node>.
	(NEW_TK): Tagged <node>.
	(type_literals, array_type_literal): New rules, tagged <node>.
	(class_declaration:): Removed action when reducing by class_body:
	(class_body:): Set DECL_END_SOURCE_LINE and rule's returned value
 	using GET_CPC in sub-rules.
	(class_member_declaration): Handle inner classes.
	(method_declaration): When reducing method_header:, reset
 	current_function_decl when appropriate.
	(method_declarator:): Set the number of formal parameter to 0 for
 	method declared without arguments.
	(constructor_declarator:): Likewise.
	(static_initializer:): List of elements kept in a list.
	(static:): Rule modifiers: replaces MODIFIER_TK. Enforce correct
 	use of the keyword `static' for type declarations.
	(block_statement:): Handle inner class declarations.
	(primary_no_new_array:): Use type_literals:. Fixed comment. Handle
 	type qualified `this'.
	(class_instance_creation_expression): Use anonymous_class_creation:
	to handle inner class instances creation. Handle qualified `new'.
	(something_dot_new): Added appropriate actions.
	(create_new_parser_context): New function.
	(java_push_parser_context, java_parser_context_save_global,
 	java_parser_context_suspend): Use create_new_parser_context.
	(check_modifiers): Changed leading comment.
	(check_class_interface_creation): Handle interclasses.
	(add_superinterfaces): Fixed comment.
	(create_interface): Build qualified name from the raw_name instead
 	of its matching WFL. Push the initialized fields list. raw_name added
 	as an extra argument to maybe_create_class_interface_decl.
	(create_class): Build qualified name from the raw_name instead of
 	its matching WFL. Removed assignment to	current_parsed_class_un.
	Call PUSH_ERROR before returning an error. Suspend the current
 	parser context when processing an inner class. Push the
 	initialized fields list. raw_name added as an extra argument to
 	maybe_create_class_interface_decl. Add the private this$<n>
 	field. 
	(duplicate_declaration_error_p): Use GET_CPC when calling find_field.
	(register_fields): Get the class type from GET_CPC and handle
 	previous errors.  Added code to handle the creation of static
 	fields in inner classes. Initialized fields initialization
 	statements kept in a list of lists.
	(maybe_generate_finit): Initialized fields initialization
 	statements kept in a list of lists. Use GET_CPC.
	(maybe_generate_clinit): Likewise.
	(method_header): Use GET_CPC and GET_CPC_UN.
	(parser_qualified_classname): Handle inner classes.
	(register_incomplete_type): Set JDEP_ENCLOSING using GET_CPC.
	(java_fix_constructors): Hide pointer to enclosing context
 	instance in constructor list when dealing with inner classes.
	(jdep_resolve_class): Call resolve_class with extra first argument
 	JDEP_ENCLOSING.
	(resolve_class): Add enclosing context as a first extra argument
 	to do_resolve_class.
	(do_resolve_class): Call find_as_inner_class. Handle WFLs
 	properly.
	(resolve_no_layout): Extra argument added to resolve_class
 	invocation.
	(reset_method_name): Use DECL_CLINIT_P, DECL_FINIT_P.
	(java_get_real_method_name): Use GET_CPC_UN.
	(check_abstract_method_definitions): Use DECL_CLINIT_P.
	(java_check_abstract_methods): Handle static method declared in
 	inner classes by an error.
	(java_check_regular_methods): Use DECL_CLINIT_P.
	(source_start_java_method): Also set DECL_MAX_LOCALS.
	(create_artificial_method): Call java_parser_context_save_global
 	and java_parser_context_restore_global instead of saving/restoring
 	the context by hand.
	(expand_start_java_method): Improved verbose mode message.
	(java_complete_expand_methods): Fixed leading comment. Use
 	DECL_CLINIT_P.
	(fix_constructors): Added assignment to this$<n> if necessary.
	(java_expand_classes): Call java_complete_expand_classes instead
 	of java_complete_expand_methods.
	(make_qualified_primary): Simplified.
	(merge_qualified_name): Optimized for missing left or right parts.
	(resolve_expression_name): Handle access to outer class fields from
 	interclasses.
	(resolve_qualified_expression_name): New macro
 	RESTORE_THIS_AND_CURRENT_CLASS, used. Handle creation of inner
 	classes. Report error on non appropriate qualification of
 	`new'. Handle qualified `this'.
	(not_accessible_p): Allow access to outer class private fields from
 	inner classes.
	(patch_method_invocation): Handle method invocations through
 	access methods and inner class constructor invocations.
	(find_applicable_accessible_methods_list): Search enclosing
 	contexts of an inner class.
	(search_applicable_methods_list): Fixed typo.
	(argument_types_convertible): Handle inner class constructors'
 	hidden outer context reference argument.
	(qualify_ambiguous_name): Handle qualified `this'.
	(java_complete_lhs): Handle use of field accessed through
 	artificial access methods in various cases of assignments. Handle
 	CLASS_LITERAL node.
	(check_final_assignment): Use DECL_CLINIT_P.
	(valid_ref_assignconv_cast_p): Handle the destination being an
 	enclosing context of the source.
	(patch_unaryop): Handle use of field accessed through artificial
 	access methods.
	(patch_return): Use DECL_CLINIT_P.
	(patch_throw_statement): Use DECL_CLINIT_P.
	(check_thrown_exceptions): Use DECL_FINIT_P and DECL_INIT_P.
	* verify.c (verify_jvm_instructions): Use ID_CLINIT_P and
 	ID_INIT_P.
	
2000-01-16  Anthony Green  <green@cygnus.com>

	* parse.y (build_string_concatenation): Only use
	StringBuffer(String) shortcut if String arg is constant.

Wed Jan 12 20:20:11 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): binop: Change the type of
	the shift value to int. Fixed typo in comment.

2000-01-11  Mumit Khan  <khan@xraylith.wisc.edu>

	* jcf-path.c: Delete PATH_SEPARATOR and DIR_SEPARATOR macros.
	* jcf-write.c: Likewise.
	* parse.y: Likewise.
	* parse.c: Regenerate.

2000-01-09  Anthony Green  <green@cygnus.com>

	* jcf-write.c (generate_bytecode_insns): Emit invokeinterface
	bytecodes in the correct order.

2000-01-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (jcf-dump, gcjh): Move ../errors.o before $(LIBS).

Thu Jan  6 16:31:28 2000  Anthony Green  <green@cygnus.com>

	* expr.c (java_lang_expand_expr): Switch to permanent obstack
	before building constant array decl.

Thu Jan  6 00:54:10 2000  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (generate_byecode_conditional): Fixed indentation in
	method invocation and typo in conditional expression.
        (generate_bytecode_insns): COND_EXPR can be part of a binop. Issue
 	the appropriate NOTE_POP.
	* parse.y (patch_binop): Shift value mask to feature the right
 	type.

1999-12-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (assume_compiled, assume_compiled_node): Add static
	prototype.
	(add_assume_compiled): Use xmalloc/xstrdup, not malloc/strdup.

	* jcf-dump.c (ARRAY_NEW_NUM): Cast long to int in switch.

	* jvgenmain.c (usage): Add static prototype with ATTRIBUTE_NORETURN.

	* parse.h (OBSOLETE_MODIFIER_WARNING): Rename parameter `modifier'
	to `__modifier' to avoid stringifying it.

	* parse.y (verify_constructor_circularity): Don't call a variadic
	function with a non-literal format string.
	(java_check_abstract_methods): Move unreachable code inside
	`continue' statement.
	(lookup_method_invoke): Call xstrdup, not strdup.

	* expr.c (expand_java_field_op): Avoid the use of ANSI string
	concatenation.

	* jcf-parse.c (yyparse): Likewise.

	* jv-scan.c (main): Likewise.
	
1999-12-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* parse.h (ABSTRACT_CHECK, JCONSTRUCTOR_CHECK,
	ERROR_CANT_CONVERT_TO_BOOLEAN, ERROR_CANT_CONVERT_TO_NUMERIC,
	ERROR_CAST_NEEDED_TO_INTEGRAL): Avoid the use of ANSI string
	concatenation.

	* parse.y (synchronized, variable_redefinition_error,
	check_class_interface_creation, create_interface, create_class,
	method_header, finish_method_declaration,
	check_modifiers_consistency, method_declarator,
	complete_class_report_errors, check_abstract_method_definitions,
	java_check_regular_methods, check_throws_clauses,
	java_check_abstract_methods, read_import_dir,
	check_pkg_class_access, declare_local_variables, fix_constructors,
	cut_identifier_in_qualified, resolve_expression_name,
	resolve_qualified_expression_name, patch_method_invocation,
	java_complete_lhs, patch_assignment, try_builtin_assignconv,
	patch_binop, patch_array_ref, patch_newarray, build_labeled_block,
	patch_exit_expr, patch_exit_expr, patch_switch_statement,
	patch_try_statement, patch_synchronized_statement,
	patch_throw_statement, check_thrown_exceptions,
	patch_conditional_expr): Likewise.

Fri Dec 24 00:25:29 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* Makefile.in (LIBDEPS): Added gcc's errors.o
	(../jcf-dump$(exeext):): Link with gcc's errors.o
	(../gcjh$(exeext):): Likewise.
	* expr.c (expand_java_NEW): Layout the entire target type instead of
 	laying out its methods only.
	(lookup_field): Layout the class after having loaded it.
	* java-tree.h (java_debug_context): Declared.
	* jcf-io.c (toplev.h): Included.
	(find_class): Removed assignment to jcf's outofsynch
 	field. Force source file to be read if newer than its matching
 	class file. Tweaked debug messages.
	* jcf-parse.c (jcf_out_of_synch): Deleted.
	(read_class): Call to jcf_out_of_synch removed.
	* jcf.h (typedef struct JCF): Field `outofsynch' deleted.
	(jcf_out_of_synch): Prototype deleted.
	* parse.h (struct parser_ctxt): `minus_seen', `java_error_flag',
 	`deprecated' and `class_err': integer turned into bit fields.
	New bit fields `saved_data_ctx' and `saved_data'. Fixed comments.
	* parse.y (package_list): New global.
	(package_declaration:): Record newly parsed package name.
	(extra_ctxp_pushed_p): Static global deleted.
	(java_parser_context_save_global): Create buffer context for the
 	purpose of saving globals, if necessary.
	(java_parser_context_restore_global): Pop context pushed for the
 	purpose of saving globals, if necessary.
	(java_debug_context_do): New prototype and function.
	(java_debug_context): Likewise.
	(do_resolve_class): Use already parsed package names to qualify
 	and lookup class candidate. 
	(java_pre_expand_clinit): Removed unnecessary local variable.	

1999-12-17  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decode_signature_piece): Print "::" in JArray<>.  This
	fixes PR gcj/119.
	(process_file): Use `\n\' at end of each line in string.

Thu Dec 16 00:09:45 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (expand_invoke): Layout the loaded class before
 	attempting to use it.
	(expand_java_field_op): Allow final field assignments to take
 	place in $finit$.
	* typeck.c (convert): Return error_mark_node if expr is null. 

1999-12-14  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (class_depth): Return -1 if the class doesn't load
	properly.
	* expr.c (can_widen_reference_to): Check for errors during depth
	computation and return 0 accordingly.
	* jcf-parse.c (parse_source_file): Call java_fix_constructors to
	create default constructors and add an other error check.
	* parse.h (java_fix_constructors): Prototyped.
	* parse.y (java_pre_expand_clinit): Likewise.
	(build_super_invocation): Re-prototyped to feature one argument.
	(java_check_circular_reference): Directly use `current'.
	(java_fix_constructors): New function.
	(java_check_regular_methods): Don't create default constructors
	here, but abort if none were found.
	(java_complete_expand_methods): Pre-process <clinit> calling
	java_pre_expand_clinit.
	(java_pre_expand_clinit): New function.
	(fix_constructors): build_super_invocation invoked with the
	current method declaration as an argument.
	(build_super_invocation): Use the context of the processed method
	decl argument instead of current_class.
	* typeck.c (lookup_java_method): Take WFLs in method names into
	account.
	
Tue Dec 14 14:20:16 1999  Per Bothner  <per@bothner.com>

	* class.c (make_class_data): flag_keep_inline_functions to keep
	private methods in the method array.

1999-12-15  Anthony Green  <green@cygnus.com>

	* check-init.c (check_init): Take into account both types of
        `throw's when checking for uninitialized variables.

Fri Dec 10 21:53:45 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (java_complete_lhs): Force convertion of array
        dimensions to int_type_node, that's what runtime's ABI expects.

Fri Dec 10 16:13:48 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (EXPR_WFL_QUALIFICATION): Temporary uses the third
 	operand of a WFL, until the Java front-end gets fixed with regard
 	to Mark Mitchell's gcc/tree.h patch (1999-12-04.)

1999-12-10  Andrew Haley  <aph@cygnus.com>

	* parse.h (BUILD_THROW): Add support for sjlj-exceptions.
	decl.c (init_decl_processing): Add _Jv_Sjlj_Throw.
	expr.c (build_java_athrow): Add support for sjlj-exceptions.
	java-tree.h: Ditto.
	jcf-write.c: Ditto.	

Wed Dec  8 15:33:26 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * expr.c (java_lang_expand_expr): Switch to permanent obstack
        before calling expand_eh_region_start and expand_start_all_catch.
        * except.c (expand_start_java_handler): Switch to permanent
        obstack before calling expand_eh_region_start.
        (expand_end_java_handler): Switch to permanent obstack before
        calling expand_start_all_catch.

1999-12-5  Anthony Green  <green@cygnus.com>

	* decl.c (init_decl_processing): Mark throw_node as a noreturn
	function with side effects.
	(init_decl_processing): Mark all memory allocating DECLs with
	DECL_IS_MALLOC.

Wed Dec  1 04:25:06 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * except.c (expand_end_java_handler): Call
        expand_resume_after_catch and end_catch_handler.

Tue Nov 30 12:36:15 1999  Anthony Green  <green@cygnus.com>

        * verify.c (verify_jvm_instructions): Create new return label
        chain if non existant (don't rely on the verified state of the jsr
        target.)

Tue Nov 30 12:28:34 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * jcf-write.c (generate_byecode_insns): Fixed indentation for
        COMPOUND_EXPR and FIX_TRUNC_EXPR cases.

        * parse.y (patch_assignment): Removed bogus final class test on
        lhs when checking on whether to emit an ArrayStoreException runtime
        check.
        * expr.c (expand_java_arraystore): Likewise. 

1999-11-28 Anthony Green <green@cygnus.com>

	* decl.c (find_local_variable): Reuse single slot decls when
	  appropriate.

Wed Nov 24 17:33:26 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * jcf-parse.c (saw_java_source): Global variable removed.
        (read_class): Don't use `saw_java_source'. Added extra braces.
        (yyparse): Code setting `saw_java_source' removed.

1999-11-24  Mark Mitchell  <mark@codesourcery.com>

	* except.c (emit_handlers): Zero catch_clauses after emitting them.

Tue Nov 23 17:29:40 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * verify.c (merge_type_state): Non verified subroutines being
        considered more than once to trigger passive type merge.

Tue Nov 23 10:55:18 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (catch_clause_parameter:): Still set `$$' to NULL_TREE
 	in case of error. Error message tuned.

1999-11-21  Anthony Green  <green@cygnus.com>

	* constants.c (find_methodref_index): Unwrap method names before
	inserting them in the constant pool.

	* jcf-parse.c (jcf_parse): Display `interface' when appropriate.

	* class.c (assume_compiled_node): New typedef.
	(assume_compiled_tree): New static data.
	(find_assume_compiled_node): New function.
	(add_assume_compiled): New function.
	(assume_compiled): New function.
	* class.c (make_class_data): Use assume_compiled.
	(is_compiled_class): Use assume_compiled.

	* java-tree.h (add_assume_compiled): Declare.

	* lang.c (lang_decode_option): Parse new options.

Wed Nov 17 21:09:28 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class): Always convert TYPE_SIZE_UNIT to
 	int_type_node: that's what `_Jv_AllocObject' expects.

Thu Nov 11 01:57:14 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (lookup_method_invoke): Use lang_printable_name to
 	reliably build the type name during error report. Fixes PR gcj/97.

1999-11-09  Tom Tromey  <tromey@cygnus.com>

	* jcf-path.c: Include <sys/stat.h>.
	(jcf_path_init): Search for libjava.zip.  Fixes PR gcj/84.
	(DIR_UP): New macro.

Tue Nov  9 12:12:38 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (source_end_java_method): Resume permanent allocation,
 	reversing Apr 27 1998 patch.
	(patch_string_cst): Pop obstacks after having pushed the permanent
 	ones.

1999-11-05  Tom Tromey  <tromey@cygnus.com>

	* class.c (finish_class): Emit inlined methods if any native
	methods exist in the class.  Fixes PR gcj/85.

Thu Nov  4 16:27:01 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_qualified_expression_name): Handle PLUS_EXPR.
	(qualify_ambiguous_name): Likewise.
	
Wed Nov  3 15:20:02 MST 1999  Godmar Back <gback@cs.utah.edu>

	* typeck.c: (lookup_java_method):  search all inherited
	interfaces when looking up interface method.

Mon Nov  1 23:42:00 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (method_header:): Issue error message for rule `type
 	error'.
	(synchronized:): Error report when not using synchronized.
	
Mon Nov  1 01:32:48 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_qualified_expression_name): Prevent `this' from
 	being used before the superclass constructor has been called.
	(complete_function_arguments): Use CALL_EXPLICIT_CONSTRUCTOR_P
 	instead of `CALL_THIS_CONSTRUCTOR_P'.

Sat Oct 30 21:35:13 1999  Todd T. Fries <todd@lighthouse.fries.net>

	* check-init.c: Fix typo in comment.

Fri Oct 29 14:35:18 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (add_method_1): Set DECL_INLINE to 1 for private, static
 	and final method.

Fri Oct 29 14:23:32 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (expression_statement:): Call function to report
 	improper invocation of a constructor.
	(parse_ctor_invocation_error): New function.

1999-10-26  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (poplevel): Don't set BLOCK_TYPE_TAGS or call
	remember_end_note.

1999-10-21  Tom Tromey  <tromey@cygnus.com>

	* jvgenmain.c (main): _Jv_Compiler_Properties now an extern; set
	in generated `main'.

Thu Oct 21 01:27:31 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_qualified_expression_name): Handle MODIFY_EXPR.
	(qualify_ambiguous_name): Likewise.

Wed Oct 20 01:41:47 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_complete_tree): fold_constant_for_init to work on
 	permanent_obstack.
	(java_complete_lhs): Likewise.
	(array_constructor_check_entry): Complete an initializer element
 	on permanent_obstack.

1999-10-19  Tom Tromey  <tromey@cygnus.com>

	* jcf-parse.c (parse_source_file): Call jcf_dependency_add_file.
	From Mike Moreton <mike@pillim.demon.co.uk>.

1999-10-15  Greg McGary  <gkm@gnu.org>

	* java-tree.h (flag_bounds_check): Remove extern decl.
	* lang.c (flag_bounds_check): Remove global variable.
	(lang_f_options): Remove "bounds-check" entry.
	(lang_init_options): Default flag_bounds_check to "on".

1999-10-14  Tom Tromey  <tromey@cygnus.com>

	* jvgenmain.c (usage): New function.
	(main): Use it.  Also, handle `-D' options.
	* jvspec.c (lang_specific_driver): Recognize -D.
	(jvgenmain_spec): Added `%{D*}' to jvgenmain invocation.

	* jvspec.c (jvgenmain_spec): Use `%umain', not just `%u'.

1999-10-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-dump.c (print_constant, disassemble_method): Don't call a
	variadic function with a non-literal format string.

	* parse-scan.y (report_main_declaration): Likewise.

	* parse.h (ERROR_CAST_NEEDED_TO_INTEGRAL): Likewise.

	* parse.y (read_import_dir, patch_assignment, patch_binop,
	patch_array_ref): Likewise.

	* typeck.c (build_java_array_type): Likewise.

	* verify.c (verify_jvm_instructions): Likewise.

Tue Oct 12 22:28:10 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (RELOCATION_VALUE_1): Fixed integer value from 0 to 1.

1999-10-07  Anthony Green  <green@cygnus.com>

	* jcf-write.c (generate_classfile): Use UNSAFE_PUTx in cases
	where CHECK_PUT may fail for valid reasons.

	* jcf-write.c (UNSAFE_PUT1, UNSAFE_PUT2, UNSAFE_PUT3,
 	UNSAFE_PUTN): New macros.

1999-10-04  Tom Tromey  <tromey@cygnus.com>

	* lex.h (BUILD_OPERATOR2): Return ASSIGN_ANY_TK in `lite' case as
	well.  Fixes Java PR gcj/59.
	* parse-scan.y (yyerror): Report errors.

Fri Sep 24 12:23:05 1999  Glenn Chambers  <GChambers@provsol.com>

	* decl.c (insert_block): Remove unconditional `abort'.

Fri Sep 24 10:48:10 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* decl.c (builtin_function): No longer static.  New arg CLASS.  Arg
	FUNCTION_CODE now of type int.  All callers changed.
	Set the builtin's DECL_BUILT_IN_CLASS.

1999-09-23  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (lang_specific_driver): Don't read spec file if
	-fsyntax-only given.

1999-09-22  Tom Tromey  <tromey@cygnus.com>

	* lang-specs.h: Added `%(jc1)' to the jc1 spec.

	* javaop.h (WORD_TO_FLOAT): Use `inline' unconditionally.
	(WORDS_TO_LONG): Likewise.
	(WORDS_TO_DOUBLE): Likewise.

Tue Sep 14 16:24:19 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-write.c (RELOCATION_VALUE_0): New macro.
	(RELOCATION_VALUE_1): Likewise.
	(emit_iinc, emit_reloc, push_constant1, push_constant2,
 	push_in_const, push_long_const): Prototyped.
	(push_constant1): Argument `index' is of type HOST_WIDE_INT.
	(push_constant2): Likewise.
	(push_int_const): Cast find_constant1's integer arguments to `jword'.
	(find_constant_wide): Cast find_constant2's integer arguments to
 	`jword'.
	(find_constant_index): Cast find_constant2's and find_constant2's
 	integer arguments to `jword'.
	(emit_pop): Argument `value' is of type HOST_WIDE_INT.
	(emit_switch_reloc): Use RELOCATION_VALUE_0.
	(emit_if): Use RELOCATION_VALUE_1.
	(emit_goto): Likewise.
	(emit_jsr): Likewise.
	(generate_bytecode_insns): Use RELOCATION_VALUE_0. Cast second
 	argument to push_long_const to HOST_WIDE_INT.

1999-09-15  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (parse.o): Depend on $(JAVA_TREE_H).

1999-09-20  Nick Clifton  <nickc@cygnus.com>

	* lang.c (lang_decode_option): Extend comment.

Thu Sep 16 15:42:39 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_method_add_stmt): Test against GET_CURRENT_BLOCK
 	instead of fndecl.

1999-09-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (get_field_name, print_method_info, print_include,
	add_namelet): Use xmalloc, not malloc.

	* jcf-depend.c (add_entry): Likewise.  Use xstrdup, not strdup.
	(munge): Use xrealloc, not realloc, trust xrealloc to handle a
	NULL pointer.

	* jcf-io.c (open_in_zip, find_class): Use xstrdup, not strdup.

	* jcf-parse.c (jcf_out_of_synch, yyparse): Likewise.
	
	* jcf-path.c (add_entry): Likewise.

	* jcf.h (ALLOC, REALLOC): Use xmalloc/xrealloc, not malloc/realloc.

	* jv-scan.c (xmalloc): Remove definition.

	* jvgenmain.c (xmalloc): Likewise.

	* jvspec.c (lang_specific_driver): Use xcalloc, not xmalloc/bzero.

	* lex.c (java_store_unicode): Use xrealloc, not realloc.

	* parse-scan.y: Use concat, not of xmalloc/assign/strcpy.  Use
	concat, not xmalloc/sprintf.
	(java_push_parser_context): Use xcalloc, not xmalloc/bzero.
	(xstrdup): Remove definition.

	* parse.y (duplicate_declaration_error_p,
	constructor_circularity_msg, verify_constructor_circularity,
	check_abstract_method_definitions, java_check_regular_methods,
	java_check_abstract_methods, patch_method_invocation,
	check_for_static_method_reference, patch_assignment, patch_binop,
	patch_cast, array_constructor_check_entry, patch_return,
	patch_conditional_expr): Use xstrdup, not strdup.

	* zextract.c (ALLOC): Use xmalloc, not malloc.

Sun Sep 12 23:30:09 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (jvspec.o): Depend on system.h and gcc.h.

	* jvspec.c: Include gcc.h.  Don't include gansidecl.h.
	(do_spec, lang_specific_pre_link, lang_specific_driver,
	input_filename, input_filename_length): Don't declare.
	(main_class_name, jvgenmain_spec, lang_specific_driver):
	Constify a char*.
	(lang_specific_driver): All calls to the function pointer
	parameter now explicitly call `fatal'. 

Sat Sep 11 16:46:44 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_applicable_accessible_methods_list): Search
 	abstract classes as interfaces.

Thu Sep  9 17:33:28 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (finish_class): We're now outside a valid method
 	declaration. Tell the rest of gcc so.

1999-09-08  Bruce Korb  autogen@linuxbox.com

	* Makefile.in: Give the gperf user a hint about why "gperf -F" fails.

1999-09-07  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (add_class_decl): Generate include for gcj/array.h, not
	java-array.h.
	(decode_signature_piece): Don't emit "::" in JArray<>.
	(print_namelet): Only print trailing `;' when printing a class.

Fri Sep 10 10:32:32 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* java-tree.h: Delete declarations for all tree nodes now moved to
	global_trees.
	* decl.c: Delete their definitions.

1999-09-04  Mark Mitchell  <mark@codesourcery.com>

	* Make-lang.in (jc1): Depend on ggc-callbacks.o.
	* Makefile.in (OBJS): Add ggc-callbacks.o.
	(OBJDEPS): Likewise.

1999-09-03  Tom Tromey  <tromey@cygnus.com>

	* parse.y (strip_out_static_field_access_decl): Return operand if
	it satisfies JDECL_P.

1999-09-02  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decode_signature_piece): Emit "::" in JArray<>.
	Handle nested arrays, like `[[I'.

1999-09-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (finish_class): Remove unused parameter, all callers
	changed.

	* expr.c (build_java_athrow): Change return type to void.
	(java_lang_expand_expr): Make sure each case in switch returns a
	value.

	* java-tree.h (finish_class): Fix prototype to take void args.

	* jcf-dump.c (usage): Mark with ATTRIBUTE_NORETURN.
	(main): Issue return from main, not exit.

	* jcf-parse.c (parse_class_file): Fix call to `finish_class'.

	* jcf.h (jcf_unexpected_eof): Mark with ATTRIBUTE_NORETURN.

	* jv-scan.c (main): Issue return from main, not exit.

	* parse.y (check_abstract_method_definitions,
	java_check_abstract_method_definitions): Add static prototypes.
	(java_complete_expand_methods): Fix call to `finish_class'.

	* verify.c (verify_jvm_instructions): Initialize variables `oldpc'
	and `prevpc'.

1999-08-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* lang.c (language_string): Constify.

1999-08-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (LIBS): Fix definition so we link with $(CLIB).
	Remove hacks for stuff which comes from libiberty.

	* Make-lang.in: Likewise.

Mon Aug 30 16:41:41 1999  Hans-Peter Nilsson  <hp@axis.se>

	* Makefile.in (xref.o): Depend on xref.c explicitly.

1999-08-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* java-tree.h (lang_printable_name): Constify a char*.

	* lang.c (lang_printable_name): Likewise.

Fri Aug 27 23:31:57 1999  Jeffrey A Law  (law@cygnus.com)

	* gjavah.c, jcf-write.c, verify.c: Do not use C++ style
	comments in C code.

1999-08-26  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_cxx_classname): Print "::" before qualified
	name.

Thu Aug 26 09:10:58 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (lookup_cl): Changed leading comment. Now does its best
 	to set the column number.
	(qualify_ambiguous_name): Take WFL wrappers into account.

Wed Aug 25 15:37:15 1999  Gregg Townsend  <gmt@cs.arizona.edu>

	* verify.c (verify_jvm_instructions): Don't check instruction
	validity beyond end of method.

1999-08-25  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (lang_specific_driver): Correctly handle --help again.

1999-08-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (print_name, print_base_classname, utf8_cmp,
	cxx_keyword_subst, generate_access, name_is_method_p,
	get_field_name, print_field_name, super_class_name, print_include,
	decode_signature_piece, print_class_decls, usage, help,
	java_no_argument, version, add_namelet, print_namelet): Add static
	prototype.
	(print_base_classname, utf8_cmp, cxx_keyword_subst,
	name_is_method_p): Constify a char*.
	(get_field_name): Likewise.  Prefer xstrdup over malloc/strcpy.
	Provide a final else clause in an if-else-if.
	(print_field_info): Add missing final arg in function call to
	`print_field_name'.
	(print_method_info, decompile_method, decode_signature_piece,
	print_c_decl, print_full_cxx_name, print_stub,
	print_mangled_classname, super_class_name, print_include,
	add_namelet, add_class_decl, print_class_decls, process_file,
	help): Constify a char*.

	* jcf-write.c (jcf_handler, push_constant1, push_constant2,
	push_int_const, find_constant_wide, find_constant_index,
	push_long_const, field_op, maybe_wide, emit_dup, emit_pop,
	emit_iinc, emit_load_or_store, emit_load, emit_store, emit_unop,
	emit_binop, emit_reloc, emit_switch_reloc, emit_case_reloc,
	emit_if, emit_goto, emit_jsr, call_cleanups,
	make_class_file_name): Add static prototypes.
	(generate_bytecode_return, generate_bytecode_insns): Pass a
	NULL_PTR, not a NULL_TREE.

	* jv-scan.c: Include "jcf.h".
	(main): Declare using DEFUN macro.

	* jvspec.c (find_spec_file, lang_specific_pre_link,
	lang_specific_driver): Add prototypes.
	(find_spec_file): Constify a char*.

	* keyword.gperf (hash, java_keyword): Add prototypes.

	* lang.c (lang_print_error): Add static prototype.
	(lang_init): Prefer memcpy over bcopy to avoid casts.

	* lex.c (yylex): Add static prototype.

	* parse-scan.y: Include "lex.c" earlier.

	* parse.h: Remove redundant declaration for `yylex'.

	* parse.y (java_decl_equiv, binop_compound_p, search_loop,
	labeled_block_contains_loop_p): Add static prototypes.
	(not_accessible_p): Make static to match prototype.

	* verify.c (start_pc_cmp): Don't needlessly cast away const.

Sun Aug 22 11:07:41 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (check_method_redefinition): Changed leading comment.
	(check_abstract_method_definitions): New function.
	(java_check_abstract_method_definitions): New function.
	(java_check_regular_methods): Call it.
	(verify_constructor_super): Fixed indentation.
	(lookup_method_invoke): Likewise.

Thu Aug 19 10:26:18 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (method_header): Return a null pointer if the current
 	class node is null.
	(finish_method_declaration): Return if the current function decl
 	is null.
	(source_start_java_method): Likewise.
	(java_method_add_stmt): Likewise.

Wed Aug 18 13:17:15 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (emit_register_class): Removed unnecessary call to
 	start_sequence.
	* parse.y (labeled_block_contains_loop_p): Removed unused local
 	variable.

Tue Aug 17 22:51:44 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (java_refold): Added prototype.

Tue Aug 17 21:48:41 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (BINOP_COMPOUND_CANDIDATES): New macro.
        (java_stabilize_reference): Removed unnecessary `else'.
        (java_complete_lhs): Set flag to remember boolean. Call
        java_refold. Added comments.
        (java_decl_equiv): New function.
        (binop_compound_p): Likewise.
        (java_refold): Likewise.
        (patch_unaryop): Striped static field access assigned to decl and
        op. Changed promotion scheme for ++/-- operators.
        (search_loop): New function.
        (labeled_block_contains_loop_p): Likewise.
        (patch_loop_statement): Call labeled_block_contains_loop_p. Added
        comment.
        (patch_bc_statement): Call search_loop. Fixed comment.

1999-08-14  Anthony Green  <green@cygnus.com>

	* expr.c (java_lang_expand_expr): Mark static array data as
	referenced.

Tue Aug	10 00:28:31 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* jvgenmain.c (main): NUL-terminate name_obstack.

1999-08-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* check-init.c (check_bool2_init, done_alternative): Add static
	prototypes.

	* class.c (add_interface_do, maybe_layout_super_class): Likewise.
	(add_method, build_utf8_ref, build_class_ref,
	append_gpp_mangled_type, layout_class_method): Constify a char*.

	* decl.c (push_promoted_type, make_binding_level): Add static
	prototypes.
	(push_promoted_type, pushdecl): Constify a char*.

	* except.c (find_handler_in_range, link_handler,
	check_start_handlers): Add static prototypes.

	* expr.c (process_jvm_instruction): Constify a char*.

	* gjavah.c (main): Constify a char*.

	* java-tree.h (verify_jvm_instructions, process_jvm_instruction):
	Constify a char*.

	* jcf-depend.c (free_entry, add_entry, munge, print_ents): Add
	static prototypes.
	(add_entry, jcf_dependency_set_target, jcf_dependency_add_target,
	munge, print_ents): Constify a char*.

	* jcf-dump.c (disassemble_method): Constify a char*.
	(print_constant_pool, print_exception_table): Add static prototypes.
	(print_constant, print_exception_table, main, disassemble_method):
	Constify a char*.

	* jcf-io.c (find_classfile, find_class): Likewise.

	* jcf-parse.c (JPOOL_UTF_DATA, find_in_current_zip): Likewise.
	(set_source_filename, predefined_filename_p): Add static prototypes.
	(set_source_filename, get_constant, get_class_constant,
	find_in_current_zip): Constify a char*.

	* jcf-path.c (free_entry, append_entry, add_entry, add_path): Add
	static prototypes.
	(add_entry, add_path, jcf_path_classpath_arg,
	jcf_path_CLASSPATH_arg, jcf_path_include_arg): Constify a char*.

	* jcf-reader.c (get_attribute, jcf_parse_preamble,
	jcf_parse_constant_pool, jcf_parse_class, jcf_parse_fields,
	jcf_parse_one_method, jcf_parse_methods,
	jcf_parse_final_attributes): Add static prototypes.
	(get_attribute): Constify a char*.

	* jcf.h (find_class, find_classfile, jcf_dependency_set_target,
	jcf_dependency_add_target, jcf_path_classpath_arg,
	jcf_path_CLASSPATH_arg, jcf_path_include_arg): Constify a char*.

	* jv-scan.c (main): Constify a char*.
	(gcc_obstack_init): Add prototype arguments.

	* jvgenmain.c (gcc_obstack_init): Likewise.
	(main): Constify a char*.

	* lang.c (put_decl_string, put_decl_node, java_dummy_print): Add
	static prototypes.
	(put_decl_string, lang_print_error): Constify a char*.
	(lang_init): Remove redundant extern prototype.
	
	* mangle.c (emit_unicode_mangled_name): Constify a char*.

	* typeck.c (convert_ieee_real_to_integer, parse_signature_type):
	Add static prototypes.
	(get_type_from_signature): Constify a char*.

	* verify.c (check_pending_block, type_stack_dup, start_pc_cmp ):
	Add static prototypes.
	(start_pc_cmp): Prefer PTR over GENERIC_PTR.
	(verify_jvm_instructions): Constify a char*.

	* xref.c (xref_flag_value): Likewise.
	
	* xref.h (xref_flag_value): Likewise.

	* zextract.c (makeword, makelong): Add static prototypes.
	(makeword, makelong): Constify a uch*.

1999-08-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * lang.c (java_dummy_print): Constify a char*.
        (lang_print_error): Likewise.
        (lang_init): Remove redundant prototype for `print_error_function'.
        (lang_init_source): Likewise.
        (lang_identify): Constify a char*.
	
1999-08-09  Tom Tromey  <tromey@cygnus.com>

	* javaop.h (WORD_TO_FLOAT): only inline if building with gcc.
	(WORDS_TO_LONG): Likewise.
	(WORDS_TO_DOUBLE): Likewise.

1999-08-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (lang.o): Depend on $(RTL_H) $(EXPR_H).

	* expr.c (java_stack_pop, java_array_data_offset,
	build_java_throw_out_of_bounds_exception, case_identity,
	build_java_check_indexed_type): Add static prototypes.
	(linenumber_table, expand_invoke, expand_java_field_op,
	build_primtype_type_ref, expand_byte_code): Constify a char*.

	* java-tree.h (build_primtype_type_ref, linenumber_table):
	Constify a char*.
	(java_lang_expand_expr): Add prototype.

	* lang.c: Include rtl.h and expr.h.  Remove extern prototype for
	`java_lang_expand_expr'.

	* lex.c (java_lex_error): Constify a char*.
	(java_get_unicode, java_read_char, java_allocate_new_line,
	java_unget_unicode, java_sneak_unicode): Prototype.

	* parse-scan.y (current_class, package_name, method_declarator,
	report_class_declaration, yyerror): Constify a char*.

	* parse.h (java_report_errors): Prototype.
	(yyerror): Constify a char*.

	* parse.y (classitf_redefinition_error, check_modifiers,
	parse_jdk1_1_error, lookup_package_type,
	lookup_package_type_and_set_next, get_printable_method_name,
	purify_type_name): Constify a char*.
	(build_super_invocation, maybe_generate_finit,
	verify_constructor_super, parser_add_interface,
	add_superinterfaces, jdep_resolve_class, note_possible_classname,
	java_complete_expand_methods, java_expand_finals,
	cut_identifier_in_qualified, java_stabilize_reference,
	do_unary_numeric_promotion, operator_string, do_merge_string_cste,
	merge_string_cste): Prototype.
	(single_type_import_declaration, yyerror,
	variable_redefinition_error, build_array_from_name,
	build_unresolved_array_type, check_class_interface_creation,
	resolve_class, complete_class_report_errors,
	note_possible_classname, read_import_dir,
	find_in_imports_on_demand, resolve_package, fix_constructors,
	check_deprecation, lookup_method_invoke,
	maybe_build_primttype_type_ref, array_constructor_check_entry):
	Constify a char*.
	(java_complete_expand_methods, java_expand_finals): Make static.
	(convert_narrow): Remove static prototype.

Tue Aug  3 20:21:20 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* Makefile.in (decl.o): Depends on $(srcdir)/../defaults.h.

1999-08-02  Richard Henderson  <rth@cygnus.com>

	* decl.c: Include defaults.h instead of expr.h.
	* parse.y: Likewise.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* java/decl.c (start_java_method): Change all uses of
	PROMOTE_PROTOTYPES, so that it tests it as a C expression.
	Ensure expr.h is included.
	* java/expr.c (pop_arguments): Ditto.
	* java/parse.y (expand_start_java_method): Ditto.

1999-08-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (ALL_CFLAGS): Add '-W -Wall'.

1999-07-31  Bernd Schmidt  <bernds@cygnus.co.uk>

	* decl.c: Include "function.h".
	* except.c: Likewise.
	* parse.y: Likewise.
	* Makefile.in: Update dependencies.

1999-07-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* expr.c (build_java_soft_divmod): Provide a default case in switch.
	(java_lang_expand_expr): Mark parameters `target', `tmode' and
	`modifier' with ATTRIBUTE_UNUSED.

	* gjavah.c (process_file): Add braces around ambiguous `else'.

	* jcf-dump.c (print_access_flags, localvar_free): Change return
	type to void.

	* parse.y (java_complete_expand_method): Initialize variable
	`exception_copy'.
	(resolve_qualified_expression_name): Likewise for `field_decl'.
	(patch_method_invocation): Likewise for `class_to_search'.
	(qualify_ambiguous_name): Likewise for `name' and `ptr_type'.
	(patch_assignment): Likewise for `lhs_type'.

	* verify.c (verify_jvm_instructions): Remove unused variable
	`caller'.

1999-07-25  Richard Henderson  <rth@cygnus.com>

	* decl.c (va_list_type_node): New.

1999-07-25  Anthony Green  <green@cygnus.com>

	* gjavah.c (print_stub): New function.
	(METHOD_IS_NATIVE): New macro.
	(print_mangled_classname): Make static.
	(HANDLE_END_FIELD): Don't emit fields during stub generation.
	(process_file): Perform stub generation.
	(HANDLE_METHOD): Don't emit class decls during stub
	generation.
	(HANDLE_END_METHOD): Take into account stub generation.
	(print_method_info): Handle stub generation.
	(print_stub): New function.
	(print_cxx_classname): Make signature consistant with others.
	(help): Describe -stubs option.
	(main): Create stub file.
	(version): Use version.c.
	(print_full_cxx_name): New function.
	(print_c_decl): Use print_full_cxx_name.

Thu Jul 22 12:41:12 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Handle MAX_EXPR.

1999-07-15  Andrew Haley  <aph@cygnus.com>

        * lang.c (flag_use_divide_subroutine): New variable.
        * typeck.c: (convert_ieee_real_to_integer): Bounds check
        fp-to-integer conversion.
        (convert): Call convert_ieee_real_to_integer when flag_fast_math
        is not set.

        * expr.c (build_java_soft_divmod): New function.
        (build_java_binop): Call build_java_soft_divmod if
        flag_use_divide_subroutine is set.
        * decl.c: soft_idiv_node, soft_irem_node, soft_ldiv_node, tree
        soft_lrem_node: new builtin functions.
        (init_decl_processing) Initialize the new builtins.
        * java-tree.h soft_idiv_node, soft_irem_node, soft_ldiv_node, tree
        soft_lrem_node: new builtin functions.
        (build_java_soft_divmod): New function.
        * parse.y: Call build_java_soft_divmod if
        flag_use_divide_subroutine is set.
        * parse.c: Rebuilt.

        * jvspec.c (lang_specific_driver): Always allow an extra arg (for
        a --specs= arg) even if not linking.
        * lang-options.h (DEFINE_LANG_NAME ("Java")): Add
        -fuse-divide-subroutine

Tue Jul 20 13:20:05 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_and_layout): Check methods only once.
	(resolve_qualified_expression_name): Verify thrown exceptions
 	compatibility.
	(check_thrown_exceptions): Reject exceptions thrown in
 	initializer. Error message tuned.
	
1999-07-14  Andrew Haley  <aph@cygnus.com>

        * expr.c (expand_expr): Do not return the last statement in a
        block as the block's value.

Sat Jul  3 22:26:32 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (force_evaluation_order): Save the COMPOUND_EXPR'ed
 	CALL_EXPR, to avoid order of evaluation changes.

Fri Jul  2 17:44:08 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Do not use
 	IDENTIFIER_LOCAL_VALUE when name is a STRING_CST.

Thu Jul  1 23:31:16 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Handle MAX_EXPR.
	* expr.c (force_evaluation_order): Force method call arguments to
 	be evaluated in left-to-right order.
	* parse.y (qualify_ambiguous_name): Loop again to qualify
 	NEW_ARRAY_EXPR properly.

Wed Jun 30 17:27:58 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (patch_invoke): Resolve unresolved invoked method
 	returned type.
	(qualify_ambiguous_name): STRING_CST to qualify expression for
 	type name resolution.

1999-06-24  Andrew Haley  <aph@cygnus.com>

	* class.c (finish_class): Whenever a deferred method is
	output, rescan the list of methods to see if a new candidate for
	output can be found.

1999-06-28  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (lang_specific_driver): Recognize --help.

Fri Jun 25 13:35:19 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (resolve_package): Fixed bogus return statement.
	(patch_method_invocation): Resolve method invocation beginning with
 	a package name qualifier.

1999-06-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (java.stage1): Depend on stage1-start.
	(java.stage2): Likewise for stage2-start.
	(java.stage3): Likewise for stage3-start.
	(java.stage4): Likewise for stage4-start.

Thu Jun 24 13:12:15 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_complete_lhs): When doing cross referencing, don't
 	try to keep file location on a WFL expanded as a CALL_EXPR.

Wed Jun 23 14:37:15 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (finish_method_declaration): Insert a RETURN_EXPR when
 	compiling to class file a void method with an empty method body.
  	As a side effect, the bytecode backend will generate the
 	appropriate `return' instruction.
	
Tue Jun 22 20:43:49 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (lookup_package_type_and_set_next): New function prototype.
	(resolve_package): Search current and imported packages.
	(lookup_package_type_and_set_next): New function.

1999-06-22  Andrew Haley  <aph@cygnus.com>

	* verify.c (verify_jvm_instructions): Check for pending blocks
	before invalid PC test and opcode switch, not after.

1999-06-21  Andrew Haley  <aph@cygnus.com>

        * except.c (find_handler_in_range): The upper limit for exception
        ranges is exclusive, not inclusive: (start <= pc < end).  
        (link_handler): find child pointer which points to outer by
        searching sibling list: previous code incorrectly assumed that
        outer->outer->first_child must point to outer.
        * verify.c (verify_jvm_instructions): FIXME added to code for
        `athrow'.
        (verify_jvm_instructions): Do not assume that the last block
        processed in a subroutine is a block which ends with a `ret'
        instruction.  With some control flows it is possible that the last
        block ends with an `athrow'.

Mon Jun 14 13:13:39 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Reorganized the post
 	evaluation of non WFL leading expression nodes.

Fri Jun 11 21:37:18 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Handle ARRAY_REF after
 	CONVERT_EXPR.

Thu Jun 10 22:26:17 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Handle qualified expression
 	beginning with a STRING_CST.

Thu Jun 10 20:27:25 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (register_fields): Set DECL_INITIAL on both
 	pre-initialized static and public fields.
	(resolve_field_access): Static field access expressions to always
 	use pointer types.
	(qualify_ambiguous_name): Work out buried CALL_EXPR for proper
 	qualification. CONVERT_EXPR to be resolved as an expression name.
	(java_complete_lhs): Identify and access qualified final
 	initialized field in switch statement case expression.
	(fold_constant_for_init): Pre-initialized field decl constant to
 	be folded.

Mon Jun  7 16:09:51 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (note_possible_classname): Mark returned node with
 	QUALIFIED_P only if the original class name contained a '/'.

Sat Jun  5 11:46:59 1999  Anthony Green  <green@cygnus.com>

	* Make-lang.in (gcjh): More parallel build fixes.

1999-06-03  Mike Stump  <mrs@wrs.com>

	* Make-lang.in (JCF_DUMP_SOURCES, jvgenmain): Fix parallel builds.

Wed Jun  2 10:44:38 1999  Anthony Green  <green@cygnus.com>

	* except.c (link_handler): Chain exception handlers in order.

Wed Jun  2 10:41:24 1999  Anthony Green  <green@cygnus.com>

	* expr.c (expand_byte_code): Fill unreachable bytecode regions
 	with nops and process as usual in order to always set correct EH
 	ranges.  Emit detailed warnings about unreachable bytecodes.

Wed Jun  2 10:35:13 1999  Anthony Green  <green@cygnus.com>

	* class.c (build_utf8_ref): Mark cinit and utf8 tree nodes as
 	constant.

Fri May 28 18:22:45 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (lookup_field_wrapper): Unified returned value to NULL
          or the searched field decl.
	
Fri May 28 11:34:05 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (fold_constant_for_init): Convert numerical constant
 	values to the type of the assigned field.

Thu May 27 19:57:40 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (lookup_field): Relaxed the test on class loading error
 	detection.
	* parse.y (fold_constant_for_init): Enabeled old code.

Wed May 26 18:06:02 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (valid_ref_assignconv_cast_p): Let `_Jv_CheckCast'
 	decide the validity of the cast of a java.lang.Cloneable reference
 	to an array.
	(patch_conditional_expr): Fixed first argument passed to
 	binary_numeric_promotion.

Wed May 26 15:33:06 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (qualify_ambiguous_name): Take into account that a
 	CONVERT_EXPR might specify a type as a WFL.

Tue May 25 15:06:13 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>
 
        * parse.y (patch_assignment): Save the rhs before using it as an
        argument to _Jv_CheckArrayStore.
 
Tue May 25 11:23:59 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lex.c (java_parse_doc_section): Fixed `tag' buffer size.

Mon May 24 13:26:00 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * lex.c (java_lex): Accepts `+' or `-' after the beginning of a
        floating point litteral only when the exponent indicator has been
        parsed.

Sat May 22 13:54:41 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (formal_parameter:): Construct argument tree list
 	element even if a yet unsupported final parameter was encountered.

Tue May 18 00:28:58 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (finish_method_declaration): Issue errors for native or
 	abstract methods declared with a method body, as well as for non
 	native or non abstract methods with no method body.

1999-05-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (build_utf8_ref): Initialize variable `field'.

	* decl.c (init_decl_processing): Initialize variable `field'.

	* expr.c (build_known_method_ref): Mark parameters `method_type',
	`method_signature' and `arg_list' with ATTRIBUTE_UNUSED.
	(process_jvm_instruction): Likewise for parameter `length'.

	* jvspec.c (lang_specific_driver): Mark variables `saw_math',
	`saw_libc', `saw_gc', `saw_threadlib' and `saw_libgcj' with
	ATTRIBUTE_UNUSED.

	* parse.y (maybe_generate_clinit): Remove unused variable
	`has_non_primitive_fields'.
	(find_in_imports_on_demand): Initialize variables `node_to_use'
	and `cl'.
	(patch_binop): Likewise for variable `prom_type'.
	(patch_unaryop): Likewise for variable `prom_type'.

	* verify.c (verify_jvm_instructions): Likewise for variable `last'.

	* xref.c (xref_table): Add missing initializer.

1999-05-14  Tom Tromey  <tromey@cygnus.com>

	* java-except.h (struct eh_range): Removed unused `next' member.
	* verify.c (verify_jvm_instructions): Call check_nested_ranges
	after adding all exception handlers.  Sort exception ranges in
	order of start PC.
	(struct pc_index): New structure.
	(start_pc_cmp): New function.
	* except.c (add_handler): Return `void'.  Don't call link_handler;
	instead construct an ordinary linked list and do range
	coalescing.
	(check_nested_ranges): New function.
	(link_handler): Changed interface to allow merging of eh_ranges.
	Split overlapping ranges.  Return `void'.

Mon May 17 19:20:24 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (constructor_block_end:): New rule, tagged <node>.
	(constructor_body:): Use `constructor_block_end' instead of
 	`block_end'.

Mon May 17 18:01:40 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (statement_nsi:): Pop `for' statement block.
	(java_complete_lhs): Labeled blocks containing no statement are
 	marked as completing normally.

Fri May 14 12:31:08 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* xref.c (xref_set_current_fp): New function, defined.
	* xref.h (xref_set_current_fp): New function, prototyped.

Fri May 14 11:57:54 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Take into account that
 	LABELED_BLOCK_STMT can be empty.

Thu May 13 18:30:48 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_check_regular_methods): Warning check on not
 	overriding methods with default access in other packages does not
 	apply to `<clinit>'.
	(java_complete_lhs): If block body is an empty_stmt_node, replace
 	it by NULL_TREE. This prevents gcc from generating an irrelevant
 	warning.

Thu May 13 13:23:38 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Removed code accepting to see things
	falling through default:, when doing xrefs.
	* java-tree.h (do_not_fold): New global variable, declared.
	* parse.y (do_not_fold): New global variable, defined.
	(java_complete_expand_method): Set `do_not_fold' to the value of
 	`flag_emit_xref'. When doing xrefs: copy the thrown exceptions,
 	and reinstall them after them have been purged; do not check for
 	initializations; do not issue missing return errors.
	(java_complete_lhs): Do not attempt to patch INSTANCEOF_EXPR nodes
 	when doing xrefs.
	(patch_binop): Skip the fold part when doing xrefs.
	(build_string_concatenation): Skip the concatenation part when
 	doing xrefs.
	(patch_synchronized_statement): Do not generate a try-finally when
 	doing xrefs.
	(patch_throw_statement): When doing xrefs, do not call BUILD_THROW
 	and keep the location where the throw was seen.
	* typeck.c (convert): When `do_not_fold' is set, do not attempt
 	any treatment on the converted node an simply return a NOP_EXPR of
 	the targeted type.
	* xref.c (xref_get_data): New function, defined.
	* xref.h (xref_get_data): New function, declared.
	(XREF_GET_DATA): Use xref_get_data.
	
1999-05-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * gjavah.c (print_include): Cast the result of `strlen' to int
        when comparing against a signed value.
        (add_namelet): Likewise.

1999-05-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* expr.c (expand_invoke): Mark parameter `nargs' with
	ATTRIBUTE_UNUSED.
	(PRE_LOOKUP_SWITCH): Likewise for variable `match'.

	* jcf-io.c (jcf_unexpected_eof): Mark parameter `count' with
	ATTRIBUTE_UNUSED.

	* jcf-reader.c (get_attribute): Cast a value to long
	when comparing against a signed expression.  Likewise.

	* lex.h: Never define HOST_WIDE_INT, HOST_BITS_PER_WIDE_INT or
	HOST_BITS_PER_CHAR.

1999-05-11  Andrew Haley  <aph@cygnus.com>

        * parse.y (source_end_java_method): If the current method contains
        any exception handlers, force asynchronous_exceptions: this is
        necessary because signal handlers in libjava may throw exceptions.
        * decl.c (end_java_method): Ditto.

1999-05-11  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (jvspec.o): Don't define WITH_THREAD_x or WITH_GC_x
	flags.
	* jvspec.c (THREAD_NAME): Removed.
	(GC_NAME): Likewise.
	(MATHLIB): Likewise.
	(WITHLIBC): Likewise.
	(GCLIB): Likewise.
	(THREADLIB): Likewise.
	(MATH_LIBRARY): Likewise.
	(lang_specific_driver): Don't add `-l' options to command line.
	Instead, add a single --specs option.  Recognize `-L' options and
	use them to search for spec file.
	(find_spec_file): New function.
	(SPEC_FILE): New define.

Tue May 11 11:46:36 1999  Dave Brolley  <brolley@cygnus.com>

	* lang-options.h: -MD, -MMD, -M and -MM not needed here for
	cpplib-enabled build.

1999-05-05  Per Bothner  <bothner@cygnus.com>

	* class.c (make_field_value):  DECL_INITIAL may be a string literal;
	temporarily zero it while calling rest_of_decl_compilation.

	* java-tree.h (string_ptr_type_node):  Add declaration.
	* decl.c:  Define and initialize string_ptr_type_node.
	* parse.y (patch_string_cst):  Use string_ptr_type_node.

	* parse.h (LOOP_HAS_LABEL_P, LOOP_HAS_LABEL_SKIP_P):  Removed.
	* parse.y (for_statement):  Now unconditionally exit_block.
	(finish_labeled_statement):  No longer exit_block if for-loop.
	(patch_loop_statement):  Check harder if the loop is already labeled.

	* parse.y (patch_initialized_static_field):  Removed function.
	(maybe_generate_clinit):  Removed special handling for interfaces.
	(java_complete_expand_methods):  Do a preliminary java_complete_tree
	on <clinit> to determine if it can be removed.
	(java_complete_expand_method):  Remove special handling for <clinit>.
	(java_complete_lhs):  For BLOCK and EXPR_WITH_FILE_LOCATION
	optimize if we get back empty_stmt_node.
	For MODIFY_EXPR, re-do checking of static initializers.
	(fold_constant_for_init):  Don't return immediate if VAR_DECL.
	For VAR_DECL, pass correct context.

	* verify.c (verify_jvm_instructions):  Better error messages.

1999-05-03  Tom Tromey  <tromey@cygnus.com>

	* parse-scan.y (interface_declaration): Call
	report_class_declaration for interfaces.

1999-04-30 20:54 -0400  Zack Weinberg  <zack@rabi.columbia.edu>

	* Makefile.in: Remove -v from bison command lines.

Fri Apr 30 17:54:40 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* check-init.c (check_init): Exclude a case of error when doing
 	xrefs.
	* class.c (layout_class_method): Don't generate the error message
 	twice when compiling from source.
	* lang-options.h: Added `-Wredundant-modifers' and
	`-Wunusupported-jdk11' flags and help text.
	* lang.c (lang_decode_option): Added support for
 	`-Wunsupported-jdk11' and `-Wredundant-modifiers'. 
	flag_static_local_jdk11 and flag_redundant set accordingly.
	* lex.c (java_lex): Call BUILD_OPERATOR on CCB_TK.
	* parse.h (EXPR_WFL_ADD_COL): New macro.
	(DECL_END_SOURCE_LINE): Likewise.
	(DECL_INHERITED_SOURCE_LINE): Likewise.
	* parse.y (static_ref_err): New function, prototyped.
	(CCB_TK): Now tagged <operator>.
	(class_body:): Remember the location of the closing '}' of a class
 	definition when doing xrefs.
	(block:): Likewise.
	(block_end:): Likewise.
	(create_class): Remember the location of the inherited class
 	identifier when doing xrefs.
	(register_fields): Added test on first operand of `init' before
 	testing it TREE_CODE.
	(method_header): Store the location of the class identifier in the
 	class decl when doing xrefs.
	(finish_method_declaration): Don't combine first/last method line
 	when doing xref.
	(java_check_regular_methods): Warning check on not overriding
 	methods with default access on other packages move before check on
 	static methods. Initialization of `aflags' also moved up.
	(resolve_expression_name): Call static_ref_err to report the error.
	(static_ref_err): New function, implemented.
	(resolve_field_access): Returned simplified static field access
 	when doing xrefs.
	(resolve_qualified_expression_name): Check for illegal use of
 	static fields in a non static context. Call static_ref_err to
 	report error in various places.
	(java_complete_tree): Do not fold initialized static fields when
 	doing xrefs.
	(java_complete_lhs): Likewise.

1999-04-29  Anthony Green  <green@cygnus.com>

	* expr.c (generate_name): Use ASM_GENERATE_INTERNAL_LABEL to
	create internal labels.
	(lookup_label): Ditto.

Sat Apr 24 16:50:19 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class_method): Generate <clinit>'s rtl for
 	interfaces.
	* decl.c (complete_start_java_method): Don't call _Jv_InitClass
 	for interfaces' <clinit>.
	* expr.c (lookup_field): Search for fields in interfaces.
	(expand_invoke): Fixed indentation.
	(expand_java_field_op): Likewise. Use IS_CLINIT.
	* parse.h (JPRIMITIVE_TYPE_OR_VOID_P): Macro removed.
	(IS_CLINIT): New macro.
	* parse.y (type_declaration:): Call maybe_generate_clinit after an
 	interface was parsed.
	(maybe_generate_clinit): Don't generate if the current class is an
 	interface with only fields of primitive types.
	(reset_method_name): Use IS_CLINIT.
	(java_complete_expand_method): Expand <clinit> when it exists for
 	interfaces. Use IS_CLINIT.
	(resolve_expression_name): Use DECL_CONTEXT instead of
 	current_class to build static field references.
	(java_complete_lhs): Use IS__CLINIT. Don't use SAVE_EXPR on
 	ARRAY_REF when doing xreferencing.
	(check_final_assignment): Fixed typo in leading comment. Use
 	IS_CLINIT.
	(patch_array_ref): Don't fully expand array references when
 	xreferencing.
	(patch_return): Use IS_CLINIT.
	(patch_throw_statement): Likewise.

1999-04-22  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (JAVA_SRCS): Added check-init.c.

Wed Apr 21 11:13:36 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (predef_filenames, predef_filenames_size): New globals
	(init_decl_processing): predef_filenames and predef_filenames_size
 	initialized.
	* java-tree.h (predef_filenames, predef_filenames_size): Declared
 	extern.
	* jcf-parse.c (predefined_filename_p): New function.
	(yyparse): Check that files on the command line are specified only
 	once and issue a warning otherwise.
	* parse.h (JPRIMITIVE_TYPE_OR_VOID_P): New macro.
	* parse.y (source_end_java_method): Nullify NOP method bodies, to
 	avoid a gcc warning with -W -Wall turned on.
	(java_expand_classes): Abort if errors were encountered.
	(java_complete_lhs): If the cross reference flag is set, wrap
 	field DECL node around a WFL when resolving expression name.
	
Mon Apr 19 14:44:48 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lang.c (lang_decode_option): Fixed returned value when parsing
 	`-fxref=...' and `-Wall'.
	* parse.y (source_end_java_method): Do not generate code when
 	flag_emit_xref is set.
	(resolve_expression_name): Do not build static field access when
 	flag_emit_xref is set.
	(resolve_field_access): No special treatment on `length' when
 	flag_emit_xref is set. Do not build qualified static field access
 	when flag_emit_xref is set.
	(patch_invoke): Keep the method DECL as operand 0 of the CALL_EXPR
 	when flag_emit_xref is set.
	(patch_assignment): Do not generate array store runtime check when
 	flag_emit_xref is set.
	* xref.c (xref_flag_value): Fixed function declaration
 	indentation.
	(xset_set_data): New function.
	* xref.h (xref_set_data): Added prototype for new function.
	(typedef struct xref_flag_table): New field data.
	(XREF_GET_DATA): New macro.

1999-04-19  Tom Tromey  <tromey@cygnus.com>

	* xref.h (enum): Removed trailing comma.

	* parse.y (resolve_qualified_expression_name): Added missing
	`break'.

Thu Apr 15 13:08:03 1999  Anthony Green  <green@cygnus.com>

	* gjavah.c: New prototypes for java_float_finite and
	java_double_finite.

Mon Apr 12 18:27:32 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (patch_unaryop): Fixed ++/-- operator check on array
 	references.

Tue Apr  6 23:15:52 1999  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (TREE_H): Add tree-check.h.
	(RTL_H): Add genrtl.h.

Tue Apr  6 15:15:51 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

        * parse.y (patch_assignment): Added ArrayStoreException runtime
        check.

1999-04-06  Per Bothner  <bothner@cygnus.com>

	* expr.c (pop_type_0):  New function.
	(pop_type):  Use pop_type_0.
	* java-tree.h (pop_type_0):  New declaration.
	* verify.c (verify_jvm_instructions):  Check return instructions.

	* parse.y (patch_binop):  Don't fold if non-constant and emiting
	class files.

Mon Apr  5 16:06:09 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (gjavah.o): Depend on $(JAVA_TREE_H).

	* gjavah.c: Include math.h earlier.  Include tree.h/java-tree.h.
	(main_jcf): Don't define.
	(process_file): Don't set `main_jcf'.
	
	* java-tree.h (main_jcf): Don't declare.

	* jcf-parse.c (main_jcf): Add static definition.

	* lang.c (main_jcf): Don't define.

Mon Apr  5 15:43:51 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * class.c (add_method_1): Cast the argument of `bzero' to PTR.

        * decl.c (copy_lang_decl): Likewise for `bcopy'.

        * jcf-depend.c: Include "config.h", not <config.h>.

        * jcf-parse.c (jcf_figure_file_type): Cast the arguments of
	`bcopy' to PTR.

        * jcf-path.c: Include "config.h", not <config.h>.

        * lex.c: Don't include various system header files.
	(java_init_lex): Cast the argument of `bzero' to PTR

        * parse-scan.y (java_push_parser_context): Likewise.

        * parse.y (java_push_parser_context): Likewise.
	(patch_bc_statement): Match format specifier to variable argument.

        * xref.c: Don't include <stdio.h>.

Mon Apr  5 11:24:19 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (struct parser_ctxt *ctxp): Now global.
	(declare_local_variables): Use WFL compound value for the
 	declaration source line value, when doing cross-referencing.

1999-03-31  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_field_info): Allow constants of other types.
	(print_include): Generate include when new name is proper prefix
	of already printed name.
	(add_namelet): Likewise.
	(cxx_keyword_subst): New function.
	(print_method_info): Use it.
	(print_field_name): New function.
	(get_field_name): New function.
	(print_field_info): Use get_field_name and print_field_name.

Wed Mar 31 11:00:32 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * Makefile.in (keyword.h): Generate using gperf language 'C', not
        'KR-C', so gperf uses the `const' keyword on strings.

        * keyword.gperf (java_keyword): Const-ify a char*.

Tue Mar 30 11:31:53 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (patch_bc_statement): Fixed identation and a bogus
 	`printf' format.

Tue Mar 30 11:29:29 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (patch_assignment): Allow static variables in other
 	classes to be assigned.

Sun Mar 28 22:12:10 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (maybe_add_interface): Remove unused variable
	`interface_binfo'.
	(make_class_data): Use = for assignment, not ==.  Likewise.
	(emit_register_classes): Remove unused variable `decl'.

	* lex.c: Fix comment so as not to contain an embedded `/*'.

	* verify.c (verify_jvm_instructions): Remove unused variable
	`self_type'.	

Sat Mar 27 15:49:18 1999  Per Bothner  <bothner@cygnus.com>

	* parse.y (complete_loop_body):  Rename to finish_loop_body.
 	(complete_labeled_statement):  Rename to finish_labeled_statement.
	(complete_for_loop):  Rename to finish_for_loop.
	(complete_method_declaration):  Rename to finish_method_declaration.

	* java-tree.h (continue_identifier_node):  New global node.
	* decl.c:  Define and initialize continue_identifier_node.
	* parse.y (generate_labeled_block):  Remove - no longer needed.
	(build_loop_body):  Use continue_identifier_node for continue block.
	(finish_labeled_statement):  Also do pop_labeled_block actions.
	(java_complete_lhs):  POP_LOOP even if error.
	(build_labeled_block):  Special handling for continue_identifier_node.
	(patch_loop_statement):  Re-organize.
	(patch_bc_statement):  Re-write.

Sat Mar 27 15:13:21 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (EXPR_WFL_GET_LINECOL): Set a line and column count
 	using a WFL compound value.
	* parse.y (xref.h): Include.
	(maybe_create_class_interface_decl): Set DECL_SOURCE_LINE to the
 	WFL compound value.
	(register_fields): Set WFL compound value to lineno if doing
 	xrefs.
	(java_complete_expand_method): Call expand_xref if flag_emit_xref
 	is set.
	* xref.c (system.h, jcf.h, parse.h, obstack.h): Include.
	* xref.h (expand_xref): Prototype renamed from xref_generate.

Sat Mar 27 14:16:32 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h (BLOCK_CHAIN_DECL): New use GET_CURRENT_BLOCK.
	(GET_CURRENT_BLOCK): New macro.
	* parse.y (current_static_block): New global variable.
	(method_body:): Define action.
	(complete_method_declaration): Set current_function_decl to NULL
 	when work on the current method is done.
	(declare_local_variables): Use GET_CURRENT_BLOCK.
	(java_method_add_stmt): Likewise.
	(java_complete_expand_method): Disable the use of `this' when
 	expanding <clinit>.
	(enter_a_block): If no current method exist, use
 	current_static_block to link static initializer blocks.
	(exit_block): Rewritten to use current_static_block when no current
 	method decl exists.
	(lookup_name_in_blocks): Use GET_CURRENT_BLOCK.
	(patch_return): Forbid the use of `return' in static initializers.
	(patch_throw_statement): Fixed indentation. Issue specific error
 	for uncaught thrown checked exception in static initializer
 	blocks. Removed FIXME.

1999-03-25  Zack Weinberg  <zack@rabi.columbia.edu>

	* java/Make-lang.in: Remove all references to gcj.o/gcj.c.
	Link gcj from gcc.o.

Tue Mar 23 10:48:24 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_applicable_accessible_methods_list): When dealing
 	with interface: ensure that a given interface or java.lang.Object
 	are searched only once.

Tue Mar 23 10:05:27 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (print_c_decl): Remove unused argument `flags'.

	* jcf-dump.c (print_access_flags): Add braces around if-else.

	* jvspec.c (lang_specific_driver): Wrap variable `len' in macro
	COMBINE_INPUTS.

	* lex.c (build_wfl_node): Add static prototype.

	* lex.h (build_wfl_node): Remove static prototype.

	* parse.y: Include lex.c early enough to declare everything needed.
	Ensure calls to `build_wfl_node' pass the proper arguments.
	(create_class): Remove unused variable `super_decl'.
	(get_printable_method_name): Initialize variable `name'.
	
Mon Mar 22 20:14:26 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* Changelog: Fixed 1999-03-22 typos.
	* lang.c (lang_decode_option): Fixed typo in error string in the
 	XARG section.

1999-03-22  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* Makefile.in (JAVA_OBJS): Added entry xref.o.
	(xref.o): New rule.
	* java-tree.h (flag_emit_xref): Declared extern.
	* lang.c (xref.h): Included.
	(flag_emit_xref): New global variable.
	(lang_decode_option): Added support for -fxref.
	* xref.c: Created.
	* xref.h: Likewise.

1999-03-21  Manfred Hollstein  <manfred@s-direktnet.de>

	* Make-lang.in ($(GCJ)$(exeext)): Add intl.o to list of files to be
	linked with.

Sun Mar 21 08:30:30 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (jcf-dump.o): Depend on $(CONFIG_H)
	$(srcdir)/../system.h and $(JAVA_TREE_H).
	(jcf-io.o): Depend on $(JAVA_TREE_H).
	(mangle.o): Likewise.

	* check-init.c (check_cond_init): Add static prototype.

	* class.c (build_java_method_type, hashUtf8String,
	make_field_value, get_dispatch_vector, get_dispatch_table,
	append_gpp_mangled_type, mangle_static_field): Likewise.
	(strLengthUtf8): Hide unused definition.
	(hashUtf8String): Const-ify.
	(make_field_value): Un-ANSI-fy.

	* constants.c: Move inclusion of jcf.h above java-tree.h.
	(set_constant_entry, find_class_or_string_constant,
	find_name_and_type_constant, get_tag_node,
	build_constant_data_ref): Add static prototype.

	* decl.c (push_jvm_slot, builtin_function,
	lookup_name_current_level): Likewise.
	(builtin_function): Const-ify.

	* except.c (expand_start_java_handler, expand_end_java_handler):
	Add static prototype.

	* expr.c (flush_quick_stack, push_value, pop_value,
	java_stack_swap, java_stack_dup, build_java_athrow,
	build_java_jsr, build_java_ret, expand_java_multianewarray,
	expand_java_arraystore, expand_java_arrayload,
	expand_java_array_length, build_java_monitor, expand_java_pushc,
	expand_java_return, expand_java_NEW, expand_java_INSTANCEOF,
	expand_java_CHECKCAST, expand_iinc, expand_java_binop, note_label,
	expand_compare, expand_test, expand_cond, expand_java_goto,
	expand_java_call, expand_java_ret, pop_arguments, expand_invoke,
	expand_java_field_op, java_push_constant_from_pool): Likewise.

	(decode_newarray_type, expand_iinc): Un-ANSI-fy.
	(build_java_arraynull_check): Mark parameters `node' and `type'
	with ATTRIBUTE_UNUSED.
	(note_label): Likewise for parameter `current_pc'.
	(expand_java_call, expand_java_ret): Hide unused definition.

	* java-tree.h (make_class, build_constants_constructor,
	java_set_exception_lang_code, pop_labeled_block, emit_handlers,
	init_outgoing_cpool, register_class, emit_register_classes,
	java_layout_seen_class_methods): Prototype.
	(unicode_mangling_length): Const-ify.
	(append_gpp_mangled_name, append_gpp_mangled_classtype,
	emit_unicode_mangled_name, format_int, format_uint,
	jcf_trim_old_input, jcf_print_utf8, jcf_print_char,
	jcf_print_utf8_replace, open_class): Prototype.

	* jcf-dump.c: Include "config.h", not <config.h>.  Don't include
	<stdio.h>.  Include tree.h/java-tree.h.
	(utf8_equal_string usage, process_class): Add static prototype.
	(open_class): Don't prototype this here.
	(utf8_equal_string): Match arguments to format specifiers.
	(HANDLE_CODE_ATTRIBUTE, BRANCH, JSR, RET, LOOKUP_SWITCH,
	TABLE_SWITCH, disassemble_method): Likewise.

	* jcf-io.c: Include tree.h/java-tree.h.
	(open_class, find_classfile, jcf_print_utf8,
	jcf_print_utf8_replace): Const-ify.

	* jcf-parse.c (parse_zip_file_entries, process_zip_dir,
	parse_class_file): Add static prototype.
	(find_in_current_zip): Match definition to existing static
	prototype.
	
	* jcf-write.c: Include jcf.h before tree.h/java-tree.h.
	(alloc_chunk, append_chunk, append_chunk_copy, gen_jcf_label,
	finish_jcf_block, define_jcf_label, get_jcf_label_here,
	put_linenumber, localvar_alloc, localvar_free, get_access_flags,
	write_chunks, adjust_typed_op, generate_bytecode_conditional,
	generate_bytecode_return, perform_relocations, init_jcf_state,
	init_jcf_method, release_jcf_state, generate_classfile):
 	Add static prototype.
	(emit_unop): Mark parameter `type' with ATTRIBUTE_UNUSED.
	(make_class_file_name): Const-ify.

	* jcf.h (find_classfile): Const-ify.

	* jv-scan.c (reset_report): Remove prototype.

	* jvgenmain.c: Include jcf.h/tree.h/java-tree.h.
	(error): Rewrite to allow varargs.

	* lang.c (lang_f_options): Const-ify.

	* lex.c (java_parse_escape_sequence): Add static prototype.
  	(java_allocate_new_line): Match definition to existing static
 	prototype.
	
	* mangle.c Include tree.h/java-tree.h.
	(unicode_mangling_length, emit_unicode_mangled_name,
	append_gpp_mangled_name, append_gpp_mangled_classtype): Const-ify.

	* parse.h (jdep_code): Remove trailing comma in enumeration.
	(java_get_line_col): Move prototype outside of !JC1_LITE test.
	(reset_report): Add prototype.

	* verify.c (push_pending_label, merge_types): Add static
	prototypes.

	* zipfile.h (opendir_in_zip, open_in_zip): Prototype.
	
1999-03-19  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (find_applicable_accessible_methods_list): Extend the
	search to superinterfaces when relevant.
	(search_applicable_methods_list): New function.

1999-03-18  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (unmangle_classname): Implemented stricter testing
	before setting the QUALIFIED_P flag on an identifier.

Tue Mar 16 15:15:41 1999  Per Bothner  <bothner@cygnus.com>

	* parse.y (java_complete_lhs):  Call force_evaluation_order
	after patch_newarray.
	(patch_binop):  Don't call fold if there are side effects.

1999-03-16  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_stabilize_reference): Use save_expr instead of
	building a SAVE_EXPR node.
	(java_complete_lhs): Patch the resulting string of the `+='
	operator (if necessary) and complete the RHS after having built
	the cast.

Mon Mar 15 12:18:29 1999  Per Bothner  <bothner@cygnus.com>

	* class.c (make_class):  Don't set CLASS_P here (because
	this function is also called by build_java_array_type).
	(push_class):  Set CLASS_P here instead.
	* parse.h (TYPE_CLASS_P):  Check for TYPE_ARRAY_P is redundant.

	* jcf-dump.c (print_access_flags):  Take extra parameter to indicate
	context.  If the context is class, perfer "super" over "synchronized".
	* jcf-write.c (generate_classfile):  Don't add ACC_SUPER if interface.

	* parse.y (create_class):  Don't call parser_check_super here;
	it is not robust.  Always wait until later.

	* parse.y (method_header):  For interfaces, set ACC_ABSTRACT (to
	match what JDK 1.2 does), but don't set ACC_PUBLIC.

Sat Mar 13 18:16:34 1999  Per Bothner  <bothner@cygnus.com>

	* lex.c (java_read_char):  UNGET invalid non-initial utf8 character.
	* lex.h (UNGETC):  Change misleading macro.

1999-03-12  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (java_stabilize_reference): Return NODE when patching a
	COMPOUND_EXPR.
	(java_complete_lhs): Put parenthesis around truth values.

1999-03-12  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class_method): Don't make rtl for interface
	methods.
	* parse.h (GET_TYPE_NAME): New macro.
	* parse.y (if_then_statement:): Fixed indentation.
	(if_then_else_statement:): Likewise.
	(for_statement:): Fixed spacing.
	(try_statement:): Fixed indentation.
	(create_interface): Don't force interfaces to be abstract.
	(method_header): Abstract methods are OK in interfaces.
	(declare_local_variables): Fixed typo in comment.
	(java_complete_expand_method): Fixed indentation.
	(resolve_qualified_expression_name): Use GET_TYPE_NAME to report
	non accessible fields.
	(java_stabilize_reference): New function.
	(java_complete_lhs): Fixed indentation. Use
	java_stabilize_reference in compound assignement. Insert the
	cast. If not processing `+' fix string constants before processing
	binop.

Fri Mar 12 19:42:55 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* constants.c (find_class_or_string_constant): Cast variable `j'
 	to a `jword' when comparing against one.

	* expr.c (java_lang_expand_expr): Remove unused variables
	`has_finally_p' and `op0'.

	* gjavah.c (print_field_info): Cast a value to jint when comparing
	against one.  Likewise for a jlong.
	(add_namelet): Likewise cast a `sizeof' to an int when comparing
	against a signed quantity.
	
	* jcf-dump.c (print_signature_type): Remove unused variable `digit'.
	(print_signature): Don't needlessly dereference variable `str'

	* jcf-reader.c (get_attribute): Mark variables `max_stack' and
	`max_locals' with ATTRIBUTE_UNUSED.
	(jcf_parse_class): Likewise for variable `index'.

	* parse.h (reverse_jdep_list): Remove static prototype.

	* parse.y (build_jump_to_finally): Remove prototype and definition.
	(reverse_jdep_list): Add static prototype.

	* typeck.c (convert_ieee_real_to_integer): Remove unused variables
	`assignment' and `expr_decl'.

	* verify.c (verify_jvm_instructions): Remove unused label `bad_ldc'.

1999-03-12  Andrew Haley  <aph@cygnus.com>

	* jcf-path.c (add_entry): alloca len+2 rather than len+1 bytes;
        we'll need a directory separator and a null character.

Wed Mar 10 23:20:11 1999  Per Bothner  <bothner@cygnus.com>

	* jcf-write.c (generate_bytecode_insns):  Handle __builtin_fmod, for %.

  Tue Mar  9 11:52:08 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>
  
 	* parse.y (method_header): Don't set ACC_ABSTRACT flags on
  	interfaces.
  
Fri Mar  5 15:17:29 1999  Per Bothner  <bothner@cygnus.com>

	* lex.c (java_parse_end_comment):  Take extra parameter (next char).

	* class.c (build_utf8_ref):  Fix possible name class/ambiguity.

	* class.c (layout_class_method):  A static method in a base class
	is never overridden, so treat it like it doesn't exist.
	However, do complain about private non-static method overriding
	public static method.

	* parse.y:  Don't set unused INITIALIZED_P flag.
	* java-tree.h (INITIALIZED_P):  Removed no-longer needed flag.

	* parse.y (find_expr_with_wfl):  Optimize tail-calls.
	(build_array_from_name):  Re-order &index[string] to &string[index].

	* parse.y (java_complete_lhs):  Don't call patch_assignment if rhs is
	error_mark (it might catch more errors, but it is more likely to lose).

Sat Mar  6 11:17:16 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (jcf-parse.o): Depend on $(PARSE_H).
	(parse-scan.o): Depend on toplev.h.

	* class.c (make_method_value): Add prototype.  Make it static.
  	Remove unused second argument, caller changed.

	* expr.c (java_lang_expand_expr): Remove unused variable
	`return_label'.

	* java-tree.h: Don't prototype find_in_current_zip.
	Add prototypes for verify_constant_pool, start_java_method,
	end_java_method, give_name_to_locals, expand_byte_code,
	open_in_zip, set_constant_value, find_constant1, find_constant2,
	find_utf8_constant, find_string_constant, find_class_constant,
	find_fieldref_index, find_methodref_index, write_constant_pool,
	count_constant_pool_bytes and encode_newarray_type.

	* jcf-dump.c: Remove unused variable `LONG_temp'.

	* jcf-parse.c: Include parse.h.
	(jcf_parse_source): Remove unused parameter, all callers changed.
	(jcf_figure_file_type): Add static prototype.
	(find_in_current_zip): Likewise.  Also remove unused parameter,
	all callers changed.
	(read_class): Initialize variable `saved_pos'.
	
	* jcf-reader.c (jcf_parse_preamble): Mark variables
	`minor_version' and `major_version' with ATTRIBUTE_UNUSED.

	* lex.c (java_is_eol): Wrap prototype and definition in !JC1_LITE.
	(java_init_lex): Wrap variable `java_lang_imported' in !JC1_LITE.
	(java_parse_doc_section): Initialize variable `seen_star'.
	(java_lex): Wrap variable `number_beginning' in !JC1_LITE.
	(java_lex_error): Mark parameters `msg' and `forward' with
	ATTRIBUTE_UNUSED.
	(java_get_line_col): Mark parameters `filename' and `line' with
	ATTRIBUTE_UNUSED.

	* parse-scan.y: Include toplev.h.
	(yyerror): Mark parameter `msg' with ATTRIBUTE_UNUSED.

	* parse.h: use `struct JCF', not plain `JCF'.
	(java_parser_context_save_global, java_expand_classes
	java_parser_context_restore_global, java_parse): Add prototypes.

	* typeck.c (convert_ieee_real_to_integer): Remove unused variable
	`node'.

Wed Feb 24 16:13:59 1999  Per Bothner  <bothner@deneb.cygnus.com>

	*  check-init.c (check_init):  COPYN takes word count, not bit count.

Fri Feb 26 14:06:21 1999  Per Bothner  <bothner@cygnus.com>

	* typeck.c (convert_ieee_real_to_integer):  Use save_expr instead of
	explicit build_decl.  (Avoids crash in reload when optimizing.)

Thu Feb 25 21:05:04 1999  Per Bothner  <bothner@cygnus.com>

	* decl.c (complete_start_java_method):  Handle synchronized method
	even when compiling from bytecode.

1999-02-26  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (add_class_decl): Only generate `#include' if outer
	class is not the name of the class we are processing.  Correctly
	append `.h' in #include.
	(process_file): Clean up newlines around generated `#include's.
	(decode_signature_piece): Correctly handle inner classes.
	(struct include): New structure.
	(all_includes): New global.
	(print_include): New function.
	(add_class_decl): Use it.
	(process_file): Likewise.
	(add_class_decl): Generate include for java-array.h if array
	seen.
	(process_file): Don't generate java-array.h include.

	* gjavah.c (add_namelet): Check for standard package names here.
	(add_class_decl): Don't check for standard package names here.

1999-02-25  Tom Tromey  <tromey@cygnus.com>

	* parse.y (read_import_dir): Use `|=', not `+=', to set `found'.
	When reading a zip file, only use strncmp if both strings are
	bigger than the buffer length.  Initialize `k' when looping
	through zip file.

1999-02-24  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (struct namelet): New structure.
	(add_namelet): New function.
	(print_namelet): New function.
	(print_class_decls): Use add_namelet and print_namelet to generate
	namespaces and not classes.
	(method_printed): New global.
	(HANDLE_END_METHOD): Examine method_printed.
	(print_method_info): Set method_printed when required.  Print
	error if function to be ignored is marked virtual.  Handle $finit$
	method.
	(METHOD_IS_FINAL): New macro.
	(print_field_info): Use it.
	(HANDLE_METHOD): Clear method_printed.
	(method_pass): New global.
	(HANDLE_END_FIELD): Call add_class_decl on the first pass.
	(process_file): Do two passes over both fields and methods.
	(HANDLE_METHOD): Examine method_pass.
	(root): New global.
	(add_class_decl): New function.
	(print_class_decls): Don't scan over entire constant pool.

1999-02-23  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (lang_specific_driver): Recognize -fsyntax-only and
	disable linking in that case.

1999-02-20  Tom Tromey  <tromey@cygnus.com>

	* jcf.h (UTF8_GET): Mask first byte of 3-byte encoding with 0x0f,
	not 0x1f.

Sun Feb 21 14:56:11 1999  Per Bothner  <bothner@cygnus.com>

	* decl.c (build_result_decl), java-tree.h:  New method.
	(complete_start_java_method):  Handle synchronized methods.
	Don't build DECL_RESULT here.  (Ordering dependency problem.)
	(start_java_method):  Call build_result_decl here instead  ...
	* parse.y (java_complete_expand_method):  ... and here.
	(expand_start_java_method): Don't call complete_start_java_method here.
	(java_complete_expand_method):  Call it here instead.
	* parse.h (BUILD_MONITOR_ENTER, BUILD_MONITOR_EXIT):  Moved to ..
	* java-tree.h:  ... here.

	* expr.c (force_evaluation_order):  Fix typo, don't handle ARRAY_REF.
	* parse.y (java_complete_lhs):  Don't call force_evaluation_order
	for ARRAY_REF - it doesn't work when array bounds are checked.
	(patch_array_ref):  Handle it here instead.

	* jcf-write.c (generate_classfile):  Emit "Exceptions" attribute.

Fri Feb 19 15:35:01 1999  Per Bothner  <bothner@cygnus.com>

	Force left-to-right evaluation of binary operations etc.
	* expr.c (force_evaluation_order), java-tree.h:  New function.
	* parse.y (java_complete_lhs):  Pass binary operations, procedure
	calls, and ARRAY_REFs to force_evaluation_order.
	(various):  Set TREE_SIDE_EFFECTS more carefully.

	Tolerate random (non-UTF8) encoding in comments without complaining.
	* lex.c (java_read_char):  Return 0xFFFE if bad UTF8 encoding.
	(java_is_eol):  Handle '\r' followed by '\n' instead of vice versa.

	* parse.y (resolve_qualified_expression_name):  Handle error_mark.
	(java_complete_node case EXPR_WITH_FILE_LOCATION):  Likewise.

	* parse.y (java_complete_lhs):  Ignore an empty statement in a
	COMPOUND_EXPR.  Don't complain about empty statement after return.
	
Fri Feb 19 13:00:56 1999  Per Bothner  <bothner@cygnus.com>

	* parse.y (obtain_incomplete_type):  Don't wrap unknown types
	in TREE_LIST - just chain the POINTER_TYPEs together.
	(resolve_class):  If type already resolved, return decl.
	After resolving, update TREE_TYPE(class_type), and name (if array).
	* parse.h (do_resolve_class), parse.y:  Make non-static.	
	* class.c (maybe_layout_super_class):  Take this_class argument.
	Do do_resolve_class if necessary.
	(layout_class, layout_class_methods): Adjust calls appropriately.
	* parse.h (JDEP_TO_RESOLVE, JDEP_RESOLVED_DECL, JDEP_RESOLVED,
	JDEP_RESOLVED_P):  Redefined for new TREE_LIST-less convention.
	* typeck.c (build_java_array_type):  Don't call layout_class.

Wed Feb 17 15:47:20 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (check_pkg_class_access): Allow private class access
 	within the same package.
	(strip_out_static_field_access_decl): New function.
	(patch_unaryop): Call strip_out_static_field_access_decl on ++/--
 	operator argument before testing its nature.

Wed Feb  3 12:38:43 1999  Per Bothner  <bothner@cygnus.com>

	* java-tree.def (FINALLY_EXPR):  Removed.  (Now uses TRY_FINALLY_EXPR.)
	(TRY_EXPR):  Simplify - it no longer has a finally clause.
	* check-init.c (check_init):  Handle TRY_FINALLY_EXPR.
	Simpler handling of TRY_EXPR, which no longer has a finally clause.
	* expr.c (java_lang_expand_expr):  Likewise.
	* java-tree.h (CATCH_EXPR_GET_EXPR):  Removed - no longer needed.
	* parse.h (java_get_catch_block), parse.y:  Removed - no longer needed.
	* parse.y (java_complete_lhs):  Add support for TRY_FIANLLY_EXPR.
	(build_try_statement):  Remove finally parameter and handling.
	(build_try_finally_statement):  New function.
	(patch_try_statement):   No longer need to support finally clause.
	(try_statement):  Update grammar action rules.
	* jcf-write.c (generate_bytecode_insns):  Handle TRY_FINALLY_EXPR.
	Simpler handling of TRY_EXPR, which no longer has a finally clause.

1998-11-26  Andrew Haley  <aph@viagra.cygnus.co.uk>

	* jcf-parse.c (get_constant): Add braces around computation of 'd'
	when REAL_ARITHMETIC is not defined.  [Oct 26 fix got overwritten -PB]

1999-02-17  Andrew Haley  <aph@cygnus.com>

	* class.c (build_utf8_ref): Back out broken patch which was
        intended to to output signatures using '.' as a separator.

        * class.c (make_class_data): Output signatures using '.' as a
        separator, rather than '/'.
        (mangled_classname): Likewise.
        (make_field_value): Likewise.
        (make_method_value): Likewise.
        * constants.c (alloc_class_constant): Likewise.
        * expr.c (build_invokeinterface): Likewise.

Thu Feb 11 21:25:51 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>
 
 	* parse.y (valid_builtin_assignconv_identity_widening_p): Got rid
 	of an ancient workaround.

Wed Feb 10 23:27:33 1999  Jeffrey A Law  (law@cygnus.com)

	* jvspec.c (xmalloc): Kill the prototype.  It does not belong
	here anymore.

1999-02-10  Alexandre Petit-Bianco  <apbianco@cygnus.com>
	
	* lex.c (yylex): Encode \0 as UTF8.

1999-02-10  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (lang_specific_driver): Use libgcj, not libjava.
	* Makefile.in (jcf-path.o): Define LIBGCJ_ZIP_FILE.
	(libgcj_zip): Renamed.
	* jcf-path.c (add_entry): Use LIBGCJ_ZIP_FILE, not
	LIBJAVA_ZIP_FILE.
	(jcf_path_init): Use LIBGCJ_ZIP_FILE.

	* jvspec.c (THREAD_NAME): Renamed -lqthreads to -lgcjcoop.
	(GC_NAME): Renamed -lgc to -lgcjgc.

Tue Feb  9 19:31:09 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lex.c (java_lang_cloneable): Initialize.
	* parse.y (java_lang_cloneable): New static variable.
	(qualify_ambiguous_name): Take CONVERT_EXPR into account when
 	doing one more qualification round.
	(valid_ref_assignconv_cast_p): Reject null source or
 	destination. Allow an array to be cast into java.lang.Cloneable.
	(patch_cast): Swapped two first arguments to first call to
 	valid_ref_assignconv_cast_p.

Mon Feb  8 11:50:50 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.h: DECL_P renamed JDECL_P.
        * parse.y: DECL_P replaced by JDECL_P.
        (build_array_from_name): Always use pointer's type.
        (patch_bc_statement): Extra code to search continue target in a
        for loop. Fixed comments. Continue target is current loop when
        unlabeled.

1999-02-05  Andrew Haley  <aph@cygnus.com>

	* class.c (make_class_data): The superclass of an interface should
	be null, not class Object.

	* lex.c (java_lex): Sign extend hex literals.

1999-02-04  Andrew Haley  <aph@cygnus.com>

	* class.c (build_utf8_ref): Output signatures using '.' as a
	separator, rather than '/'.
	(make_class_data): Likewise.

Wed Feb  3 22:50:17 1999  Marc Espie <Marc.Espie@liafa.jussieu.fr>

        * Make-lang.in ($(GCJ)(exeext)): Remove choose-temp.o, pexecute.o and
        mkstemp.o.  Get them from libiberty now.

Tue Feb  2 19:49:12 1999  Jeffrey A Law  (law@cygnus.com)

	* jcf-io.c: Do not include sys/stat.h or sys/wait.h

Tue Feb  2 20:04:50 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jvspec.c (xmalloc): Fix the prototype to match the one obtained
 	from libiberty.h

Tue Feb  2 10:39:47 1999  Per Bothner  <bothner@cygnus.com>

	Optimize: `return (a ? b : c)' as: `if (a) return b; else return c;'.
	* jcf-write.c (generate_bytecode_return):  New function.
	(generate_bytecode_insns):  Use it, for RETURN_EXPR.

	* jcf-write.c (generate_bytecode_insns):  For REAL_CST that is 0 or 1,
	generate special [fd]const_[01] instructions.
	
	* jcf-parse.c (yyparse):  Don't emit_register_classes if -fsyntax-only.

	* verify.c (verify_jvm_instructions):  Do INVALIDATE_PC after
	handling OPCODE_lookupswitch or OPCODE_tableswitch.

Mon Feb  1 20:44:47 1999  Per Bothner  <bothner@cygnus.com>

	* parse.y (patch_method_invocation):  Handle calling static methods,
	even in the form EXPR.METHOD(ARGS), not just TYPE.METHOD(ARGS).

	* parse.y (java_complete_lhs):  Don't complain about unreachable
	exit condition in a do-while statement.
	
Fri Jan 29 18:19:02 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lex.c (java_read_char): Fixed utf8 decoding.
	(java_unicode_2_utf8): Fixed utf8 encoding in the 0x800-0xffff
 	range.
	* parse.y (valid_builtin_assignconv_identity_widening_p): Fixed
 	comments. Local variable `all_primitive' is gone. Broadened
 	acceptance of `0' to floating point targets. `long' can now be
 	widened to `double' or `float'.
	(valid_method_invocation_conversion_p): Added leading
 	comment. Fixed tabulation.
	(build_string_concatenation): Optimize out left or right empty
 	string constants.

Thu Jan 28 18:51:26 1999  Per Bothner  <bothner@cygnus.com>

	* jcf-write.c (localvar_alloc):  Only emit entry for
	LocalVariableTable if debug_info_level > DINFO_LEVEL_TERSE.
	(generate_bytecode_insns):  Only call put_linenumber if
	debug_info_level > DINFO_LEVEL_NONE.
	* jvspec.c (lang_specific_driver):  If no -O* or -g* option
	is specified, add -g1 (for compatibility wih javac).

Thu Jan 28 09:17:51 1999  Hans-Peter Nilsson  <hp@axis.se>

	* java/Makefile.in: Add missing dependencies for jcf-dump.o,
	gjavah.o, check-init.o, jv-scan.o

Mon Feb  1 09:50:48 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (gjavah.o): Depend on $(CONFIG_H) and system.h.

	* gjavah.c: Include config.h and system.h.

	* javaop.h (inline): Don't define, its handled by system.h.
	(WORD_TO_FLOAT, WORDS_TO_LONG, WORDS_TO_DOUBLE): Change these
	from `inline' to `static inline'.

	* jcf.h (inline): Don't define, its handled by system.h.

	* lex.c (inline): Likewise.

Sun Jan 31 20:34:29 1999  Zack Weinberg  <zack@rabi.columbia.edu>

	* lang-specs.h: Map -Qn to -fno-ident.

Fri Jan 29 16:51:56 1999  Richard Henderson  <rth@cygnus.com>

	* check-init.c (check_init): Fix CLEANUP_POINT_EXPR typo.

1999-01-29  Tom Tromey  <tromey@cygnus.com>

	* parse.h (BUILD_APPEND): If ARG is a non-String object reference,
	then cast it to Object before calling `append' method.

Thu Jan 28 14:45:39 1999  Per Bothner  <bothner@cygnus.com>

	* check-init.c (check_bool2_init, check_bool_init, check_init):
	Handle TRUTH_AND_EXPR, TRUTH_OR_EXPR, and TRUTH_XOR_EXPR.
	* jcf-write.c (generate_bytecode_insns):  Likewise.

Thu Jan 28 11:50:11 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (jcf_parse): Don't parse the same class file twice.
	* parse.y (patch_cast): Allow a boolean to be cast into a
 	boolean.

Wed Jan 27 10:19:29 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y: (class_declaration:): Fixed indentation.
	(class_member_declaration:): Extra `;' after field declaration now
 	accepted.
	(interface_declaration:): Removed debug messages in error reports.
	(patch_binop): Nodes created and returned inherit the orignal
 	node's COMPOUND_ASSIGN_P flag value.
	(patch_cast): Fix cast from char to floating point.

Mon Jan 25 17:39:19 1999  Andrew Haley  <aph@cygnus.com>

        * except.c, java-except.h (expand_resume_after_catch): new
        function.
        * expr.c (java_lang_expand_expr): call expand_resume_after_catch
        to branch back to main flow of control after a catch block.

Sat Jan 23 23:02:43 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (parse.o): Depend on $(CONFIG_H) and
	$(srcdir)/../system.h.
	(class.o): Depend on $(PARSE_H) and $(srcdir)/../output.h.
	(jcf-parse.o): Depend on $(srcdir)/../toplev.h.
	(jcf-write.o): Likewise.
	(jv-scan.o): Depend on $(CONFIG_H) and $(srcdir)/../system.h.
	(mangle.o): Depend on $(srcdir)/../toplev.h.
	(parse-scan.o): Depend on $(CONFIG_H) and $(srcdir)/../system.h.
	(zextract.o): Depend on $(CONFIG_H) and $(srcdir)/../system.h.

	* class.c: Include output.h and parse.h.
	(mangled_classname): Add the `const' keyword to a char*.
	(find_named_method): Hide unused function definition.
	(build_utf8_ref): Change type of variable `c' to unsigned char.
	Use ISALPHA/ISDIGIT instead of isalpha/isdigit.
	(build_class_ref): Add the `const' keyword to a char*.
	(layout_class_method): Remove unused variable `buf'.

	* decl.c (find_local_variable): Remove unused variable `rtl'.
	(pushdecl): Likewise for variables `different_binding_level' and
	`oldglobal'.
	(pushlevel): Mark parameter `unused' with ATTRIBUTE_UNUSED.
	(maybe_build_cleanup): Likewise for parameter `decl'.

	* except.c (expand_start_java_handler): Mark parameter `range'
	with ATTRIBUTE_UNUSED.

	* expr.c: Include except.h.
	(pop_type): Remove unused variable `i'.
	(pop_value): Likewise for variables `n_words' and `i'.
	(expand_java_arrayload): Likewise for variable `convert'.
	(java_lang_expand_expr): Likewise for variables `op0', `type',
	`mode', `unsignedp', `node' and `elements'.
	(expand_byte_code): Likewise for variables `prev_eh_ranges' and
	`eh_ranges'.
	(process_jvm_instruction): Add a `const' qualifier to a char*.

	* gjavah.c (output_directory): Add the `const' keyword to a char*.
	(temp_directory): Likewise.
	(print_c_decl): Likewise.
	(print_method_info): Likewise.
	(decode_signature_piece): Likewise.
	(print_mangled_classname): Likewise.

	* java-except.h: Provide prototypes for maybe_start_try,
	maybe_end_try and add_handler.

	* java-tree.h (mangled_classname): Add the `const' keyword to a char*.
	(parse_error_context): Likewise.  Also add ATTRIBUTE_PRINTF_2.
	(pushdecl_top_level, alloc_class_constant, unicode_mangling_length,
	init_expr_processing, push_super_field, init_class_processing,
	can_widen_reference_to, class_depth, verify_jvm_instructions,
	maybe_pushlevels, maybe_poplevels, process_jvm_instruction,
	set_local_type, merge_type_state, push_type, load_type_state,
	add_interface, find_in_current_zip, append_gpp_mangled_classtype,
	emit_unicode_mangled_name): Add prototypes.

	* jcf-dump.c (print_constant): Add the `const' keyword to a char*.
	(print_signature_type): Use ISDIGIT, not isdigit.
	(print_signature): Remove unused variable `j'.

	* jcf-io.c (jcf_filbuf_from_stdio): Cast the result of `fread' to
	int when comparing against one.

	* jcf-parse.c: Include toplev.h.

	* jcf-write.c: Likewise.  Don't include <string.h> or <sys/stat.h>.
	(localvar_free): Remove unused variable `i'.
	(generate_bytecode_conditional): Likewise for variable `kind'.

	* jv-scan.c: Include config.h and system.h.  Remove redundant
	OS header and gansidecl.h includes.
	(warning): Add the `const' keyword to a char*.  Also add
	ATTRIBUTE_PRINTF_1 to the prototype.  Check ANSI_PROTOTYPES, not
	__STDC__, when determining whether to use ANSI-isms.
	(fatal): Likewise.  Also add ATTRIBUTE_UNUSED.
	(xmalloc): Don't redundantly prototype here.
	(main): Remove unused parameter `envp'.  Also fix the arguments
	passed to function `fatal' to match the format specifier.

	* lang.c (java_tree_code_name): Add the `const' keyword to a char*.

	* mangle.c: Include toplev.h.
	(emit_unicode_mangled_name): Declare parameter `len'.

	* parse.y (parse_warning_context): Add the `const' keyword to a
	char*.  Also add ATTRIBUTE_PRINTF_2 to the prototype.  Check
	`ANSI_PROTOTYPES' not `__STDC__' for whether to use ANSI-isms.
	(issue_warning_error_from_context): Add the `const' keyword to
	a char*.
	(parse_error_context): Likewise.  Also check `ANSI_PROTOTYPES'
	not `__STDC__' for whether to use ANSI-isms.

	* typeck.c (incomplete_type_error): Mark parameters `value' and
	`type' with ATTRIBUTE_UNUSED.
	(parse_signature_type): Use ISDIGIT, not isdigit.

	* verify.c (check_pending_block): Add the `const' keyword to a char*.
	(verify_jvm_instructions): Likewise.  Remove unused variables
	`field_name' and `default_val'.
	
	* zextract.c: Include config.h and system.h.  Remove redundant
	OS header includes.
	
	* zipfile.h: Prototype `read_zip_archive'.

Thu Jan 21 16:00:06 1999  Andrew Haley  <aph@cygnus.com>

	* typeck.c (convert): Allow conversions to void type: some
 	optimizations in gcc do this.

Thu Jan 21 15:21:49 1999  Andrew Haley  <aph@cygnus.com>

	* typeck.c (convert_ieee_real_to_integer): New function.
	(convert): When not using fast-math and using hardware fp, convert
 	an IEEE NaN to zero.
 
1999-01-18  Andrew Haley  <aph@cygnus.com>

	* parse.y (patch_binop): Do a type conversion from signed to
	unsigned and then back to signed when a ">>>" is found.

Sun Jan 17 22:34:22 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h: (check_for_initialization): Added prototype.
	* lex.c (java_parse_doc_section): `\n' breaks the `*/' string.
	* parse.y (do_resolve_class): Removed unused locals.
	(read_import_dir): Likewise.
	(resolve_qualified_expression_name): Array creation
 	expressions are valid primary expressions.
	(qualify_ambiguous_name): Likewise.
	(patch_synchronized_statement): Removed unused local.

Sun Jan 17 21:55:42 1999  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (zextract.o): Add dependencies.

        * Makefile.in: Do not put ^Ls at the start of a line.

Fri Jan 15 20:16:20 1999  Per Bothner  <bothner@cygnus.com>

	* expr.c (process_jvm_instruction):  Coerce to correct Throwable
	sub-type the result of the call that gets the exception value.

	* parse.y (java_complete_expand_methods):  If flags_syntax_only,
	don't call finish_class.

	* parse.y (java_check_regular_methods):  If METHOD_PRIVATE,
	clear found before continuing.

	* verify.c (verify_jvm_instructions):  On an array load, allow
	and handle top of stack to be TYPE_NULL.

	* gjavah.c (generate_access):  Translate Java package private or
	protected access to C++ public, but with a comment.

1999-01-13  Andrew Haley  <aph@cygnus.com>

	* expr.c (generate_name): Name prefix changed to avoid clashes
	with assembler temp labels.

	* parse.y (patch_synchronized_statement): Set TREE_SIDE_EFFECTS on
	MODIFY_EXPR.  Without this, code for the assignement may not be
	generated at all and the synchronized statement will read an
	uninitialized variable.
  	
Wed Jan 13 01:24:54 1999  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (maybe_layout_super_class): Fixed returned value.
	* lex.c: Added 1999 to the copyright.
	(java_init_lex): Initialize java_lang_imported.
	* lex.h: Added 1999 to the copyright.
	* parse.h: Added 1999 to the copyright.
	(REGISTER_IMPORT): Fixed typo in trailing macro.
	(CURRENT_OSB): New macro.
	(struct parser_ctxt): New fields osb_depth, osb_limit.
	* parse.y (java_lang_id): New global variable.
	(type_import_on_demand_declaration): Don't import java.lang.* twice.
	(array_creation_expression:): Use CURRENT_OSB.
	(dims:): Uses a stack to keep track of array dimensions.
	(cast_expression:): Use CURRENT_OSB.
	(find_expr_with_wfl): Return NULL if node found doesn't meet the
 	conditions.
	(register_fields): Fixed typos in comment.
	(check_method_redefinition): Fixed comment indentation.
	(java_check_regular_methods): Set saved found wfl to NULL after
 	having reinstalled it in the previously found DECL_NAME.

Sun Jan 10 13:36:14 1999  Richard Henderson  <rth@cygnus.com>

	* gjavah.c (java_float_finite): Use a union to do type punning.
	(java_double_finite): Likewise.

Sat Jan  9 11:25:00 1999  Per Bothner  <bothner@cygnus.com>

	* parse.y (build_new_array_init):  Don't set EXPR_WFL_LINECOL
	on CONSTRUCTOR (since that trashes TREE_CST_RTL).
	(patch_new_array_init):  Clear TREE_CONSTANT also if INDIRECT_REF.
	(register_fields):  Set TREE_STATIC on NEW_ARRAY_INIT, not on
	CONSTRUCTOR (which causes expand_expr to call output_constant_def).
	* expr.c (java_lang_expand_expr):  Check TREE_STATIC of NEW_ARRAY_INIT.

Fri Jan  8 15:48:03 1999  Per Bothner  <bothner@cygnus.com>

	* check-init.c (check_init):  If compiling to native, we don't
	see THROW_EXPR.  Instead, look for a call to throw_node (_Jv_Throw).

1999-01-08  Tom Tromey  <tromey@cygnus.com>

	* parse-scan.y (variable_declarator_id): Set or increment
	bracket_count.
	(bracket_count): New global.
	(formal_parameter): Handle case where bracket pairs trail variable
	declarator id.

1999-01-07  Andrew Haley  <aph@viagra.cygnus.co.uk>

	* jcf-parse.c (yyparse): variable len changed from a char to an
	int to prevent overflow.

Wed Jan  6 17:19:46 1999  Per Bothner  <bothner@cygnus.com>

	* java-tree.h:  Declare read_class.
	* jcf-parse.c (read_class):  New function.
	(load_class):  Now just call read_class.

	* java-tree.h (java_parse_abort_on_error):  Only return if new errors.
	* jcf-parse.c (parse_source_file):  Declare save_error_count,
	which is needed by java_parse_abort_on_error macro,
	* parse.y (java_layout_classes, java_expand_classes):  Likewise.

	* parse.y (register_fields):  Set TREE_STATIC flag of NEW_ARRAY_INIT
	constructor, if initializing a static field.
	(patch_new_array_init):  Set TREE_CONSTANT if it is.
	* expr.c (java_lang_expand_expr):  For a static array constructor
	of primitive elements, allocate the array itself statically.
	Disabled until we can set the vtable field statically.
	
	* check-init.c:  New file.  Checks for definite assignment.
	* Makefile.in (JAVA_OBJS):  Add check-init.o.
	* parse.y (java_complete_expand_method): Call check_for_initialization.
	* parse.h (BLOCK_EXPR_DECLS, BLOCK_EXPR_BODY):  Moved to java-tree.h.

Wed Jan  6 14:53:10 1999  Graham <grahams@rcp.co.uk>

	* parse.y : include system.h instead of including
	standard headers directly with the exception of <dirent.h>.

Wed Jan  6 16:20:06 1999  Per Bothner  <bothner@cygnus.com>

	* lex.h:  Moved static function declarations to lex.c,
	to shut up some -Wall warnings.
	* lex.c:  Static function declarations moved here.
	* jcf-dump.c:  Small fixes to shut up -Wall warnings.

Tue Jan  5 22:15:40 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * Make-lang.in ($(GCJ).o): Depend on prefix.h.

Tue Dec 22 11:25:19 1998  Per Bothner  <bothner@cygnus.com>

	* expr.c (process_jvm_instruction):  Do load_type_state after JSR.
	* verify.c (verify_jvm_instructions):  Fix off-by-one error.

	* jcf-write.c (CHECK_PUT):  Add (void) cast to avoid -Wall warnings.
	(localvar_alloc):  Change return type to void,
	(emit_unop):  Remove unused variable size.
	
	* jcf-write.c (struct jcf_block):  Add new union.
	(PENDING_CLEANUP_PC, PENDING_EXIT_PC, UNDEFINED_PC):  New macros.
	(call_cleanups):  New functions.
	(struct jcf_partial):  New fields num_finalizers and return_value_decl.
	(generate_bytecode_insns):  Support CLEANUP_POINT_EXPR and
	WITH_CLEANUP_EXPR.  Handle cleanups in RETURN_EXPR and EXIT_BLOCK_EXPR.
	* lang.c (lang_init):  Call using_eh_for_cleanups.
	* parse.y (java_complete_lhs):  For SYNCHRONIZED_EXPR, defer
	completing operands to patch_synchronized_statement.
	Support CLEANUP_POINT_EXPR, WITH_CLEANUP_EXPR.
	(patch_synchronized_statement): Re-write suing CLEANUP_POINT_EXPR and
	WITH_CLEANUP_EXPR instead of TRY_EXPR.	

Sun Dec 20 16:15:44 1998  John F. Carr  <jfc@mit.edu>

	* Make-lang.in: Comment out control-Ls; they upset some makes.

1998-12-18  Tom Tromey  <tromey@cygnus.com>

	* parse.y (check_class_interface_creation): Use DIR_SEPARATOR
	consistently.

1998-12-17  Tom Tromey  <tromey@cygnus.com>

	* parse.y (DIR_SEPARATOR): New define.
	(check_class_interface_creation): Use it.

	* parse-scan.y (report_main_declaration): Recognize
	`java.lang.String' in argument to main.

Wed Dec 16 16:18:59 1998  Per Bothner  <bothner@cygnus.com>

	* parse.y (create_interface):  Remove bogus test.

Wed Dec 16 14:42:19 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-parse.c (get_constant):  Set TREE_TYPE for string constants.
	(HANDLE_CONSTANTVALUE):  If flag_emit_class_files, call get_constant.

1998-12-16  Tom Tromey  <tromey@cygnus.com>

	* parse-scan.y (qualified_name): Use correct sprintf format.

1998-12-15  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_field_info): Changed how most negative number is
	printed.

Mon Dec 14 18:49:29 1998  Per Bothner  <bothner@cygnus.com>

	* parse.y (fold_constant_for_init):  New function.
	(resolve_expression_name):  Don't replace static final
 	constant-initialized fields by its value.
	(java_complete_lhs):  New.  Same as java_complete_tree, except does
	not replace static final constant-initialized fields by their values.
	(register_fields):  If there is an initializer, set DECL_INITIAL and
	MODIFY_EXPR_FROM_INITIALIZATION_P.
	(java_complete_tree):  For MODIFY_EXPR, use java_complete_lhs for lhs.
	Only call patch_initialized_static_field if
	MODIFY_EXPR_FROM_INITIALIZATION_P.
	(patch_initialized_static_field):  If not valid constant, clear
	DECL_INITIAL.

	* parse.y (lookup_field_wrapper):  Fix thinko.

	* parse.y (java_complete_tree):  In EXPR_WITH_FILE_LOCATION,
	set and restore global lineno.

1998-12-14  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (print_field_info): If value to print is the smallest
	value of its size, then print as hex to avoid later warnings from
	C++ compiler.

1998-12-14  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decompile_method): Decompile `return null'.
	(process_file): Generate `#pragma interface'.
	(method_declared): New global.
	(print_method_info): Set it.
	(HANDLE_CODE_ATTRIBUTE): Only print it method_declared set.
	(print_method_info): Handle abstract methods.

Sun Dec 13 17:31:40 1998  Per Bothner  <bothner@cygnus.com>

	* parse.y (patch_method_invocation):  If class_decl is null
	(e.g. an array type), use original type.

	* parse.y (check_thrown_exceptions):  Temporary hack to suppress
	errors about uncaught exception from clone (of array, specifically).

1998-12-13  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decompile_method): Handle all types of `return'
	opcode.  Decompile `return this' and `return'.
	(method_access): New global.
	(print_method_info): Set it.
	(decompile_method): Don't decompile a synchronized method.

1998-12-13  Tom Tromey  <tromey@cygnus.com>

	* jcf-reader.c (jcf_parse_one_method): Recognize
	HANDLE_END_METHOD.
	* gjavah.c (HANDLE_END_METHOD): New macro.
	(HANDLE_CODE_ATTRIBUTE): New macro.
	(decompile_method): New function.
	(print_method_info): Don't print `;\n' at end of function decl.
	Include java-opcodes.h.
	(decompiled): New global.

Sat Dec 12 20:13:19 1998  Per Bothner  <bothner@cygnus.com>

	* class.c (build_class_ref):  Handle PRIMTYPE.class if
	flag_emit_class_files.
	* expr.c (expand_java_field_op):  Don't optimize java.lang.XXX.TYPE
	if flag_emit_class_files.
	* parse.y (java_complete_tree):  Pre-liminary support for
	COMPONENT_REF - only to handle PRIMCLASS.TYPE.

	* parse.y (patch_synchronized_statement):   Don't call monitorexit
 	unless block CAN_COMPLETE_NORMALLY.  Propagate that flag properly.

	* java-tree.h (DECL_LOCAL_STATIC_VALUE):  Removed - no longer used.

	* zipfile.h (opendir_in_zip):  New declaration.
	* jcf-io.c (saw_java_source):  Moved to jcf-parse.c.
	(opendir_in_zip):  New function, using code from open_in_zip.
	(open_in_zip):  Call opendir_in_zip.
	(find_class):  Remove no-longer-used do_class_file parameter,
	but add source_ok parameter.  Change logic so if we find a .java file,
	we don't look for .class in later classpath emtries.
	* jcf-parse.c (load_class):  Pass saw_java_source to find_class.
	(jcf_figure_file_type):  Only call open_in_zip if correct magic number.
	* gjavah.c: Update call to find_class.
	* jcf-dump.c:  Likewise.

	* jcf-write.c (put_linenumber):  Handle duplicate line numbers.
	(generate_bytecode_insns):  For EXPR_WITH_FILE_LOCATION, do
	nothing if body is empty_stmt_node.
	Various little fixes so SP gets correctly adjusted.
	For NEW_ARRAY_INIT, handle IGNORE_TARGET.
	For CALL_EXPR, test if static first.
	(generate_classfile):  Ignore fields that are DECL_ARTIFICIAL,
	such as the ones we create for Object and Class.
	Set and restore current_function_decl.
	* parse.y:  Check/set IS_AN_IMPORT_ON_DEMAND_P in read_import_dir.
	(note_possible_classname):  New function.
	(read_import_entry):  Removed.  Merged with read_import_dir.
	(read_import_dir):  Don't call find_class - that only gives us
	the first classpath entry having the needed package.
	Use the struct buffer data structure from buffer.h.
	(read_import_dir, find_in_imports_on_demand):  The remembered
	class names now use '.' (not '/') as package separator.

	* parse.y (java_complete_expand_methods):  Call write_classfile
	here, and not in java_expand_classes (which only gets first class).

Sat Dec 12 19:46:04 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (<type_declaration>):  Do maybe_generate_clinit last.
	(register_fields):  If a static fields has an initializer, just
	chain it on ctxp->static_initialized, and handle later.
	(java_complete_expand_methods):  Force <clinit> first.
	(resolve_expression_name, resolve_field_access):  Just get DECL_INITIAL
	- it's already been completed.
	(patch_initialized_static_field):  New function.
	(java_complete_field):  Call it.

Sat Dec 12 19:21:11 1998  Per Bothner  <bothner@cygnus.com>

	* expr.c (encode_newarray_type, build_new_array):  New functions.
	* java-tree.h:  Declare build_new_array.
	* jcf-write.c (patch_newarray):  Use build_new_array.

	* expr.c (java_lang_expand_exp):  Support NEW_ARRAY_INIT.
	* jcf-write.c (generate_bytecode_insns):  Support NEW_ARRAY_INIT.

	* parse.y (patch_new_array_init):  Re-organize.
	Now is passed the actual array (pointer) type of the value.
	Set the type of the CONSTRUCTOR to be an ARRAY_TYPE.
	(patch_array_constructor):  Removed - merged into patch_new_array_init.
 	(java_complete_tree):  Update patch_new_array_init.

	* jcf-write.c (find_constant_index):  New function.
	(generate_bytecode_insns):  Use find_constant_index.
	(generate_classfile):  Use find_constant_index for ConstantValue.

1998-12-11  Tom Tromey  <tromey@cygnus.com>

	* expr.c (invoke_build_dtable): Renamed dtable -> vtable.
	* decl.c (init_decl_processing): Renamed dtable -> vtable.
	* class.c (make_class_data): Renamed dtable -> vtable, and
	dtable_method_count -> vtable_method_count.

Thu Dec 10 20:00:54 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (long_zero_node, float_zero_node, double_zero_node): New
 	global variables, initialized.
	* java-tree.h (long_zero_node, float_zero_node, double_zero_node):
 	Declared new global variables.
	* lex.c (java_lex): Return long_zero_node, float_zero_node,
 	double_zero_node, integer_zero_node upon direct matching.
	* parse.y (purify_type_name): Added function prototype.
	(duplicate_declaration_error_p): Consider new_type as potentially
 	being a incomplete type. Use purify_type_name on type string.
	(method_header): saved_type: unused variable removed. Don't figure
 	return type if method name is invalid.
	(java_complete_tree): Set CAN_COMPLETE_NORMALLY after `node' was
 	processed by patch_unaryop.
	(patch_unaryop): Fixed typo in comment. Re-convert pre/post
 	increment/decrement node into its original type after binary
 	numeric promotion on its operands.

Thu Dec 10 11:02:49 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (array_initializer:): Array init operand is NULL_TREE
 	instead of a TREE_LIST of NULL_TREEs when parsing `{}'. `{,}' is
 	now an error. Fixed indentation problems.
	(patch_string): Handle error_mark_node as an argument.
	(patch_new_array_init): Fixed indentation problems.
	(array_constructor_check_entry): Removed check on null wfl_value.
  	Return an error if wfl_value's walk returns an error.

Wed Dec  9 15:37:05 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.def (NEW_ARRAY_INIT): New Java tree code.
	* lex.c (java_lex): Remember column position before advancing one
 	token. Retain location information on OCB_TK.
	* lex.h (typedef struct java_lc): Added new field.
	* parse.h (GET_SKIP_TYPE): New macro.
	(QUAL_DECL_TYPE): Redefined using GET_SKIP_TYPE.
	* parse.y (build_new_array_init, patch_new_array_init,
 	patch_array_constructor, maybe_build_array_element_wfl,
 	array_constructor_check_entry): New function prototypes.
	(switch_block:): Tagged <node>.
	(OCB_TK): Tagged <operator>.
	(array_initializer:): Installed actions.
	(variable_initializer): Build location information on element if
 	necessary.
	(switch_statement:): Fixed indentation typo.
	(switch_block:): Redefined default action.
	(java_complete_tree): Handle NEW_ARRAY_INIT in MODIFY_EXPR:.
	(patch_assignment): Removed duplicate code.
	(maybe_build_array_element_wfl, build_new_array_init,
 	patch_new_array_init, patch_array_constructor,
 	array_constructor_check_entry): New functions.

Mon Dec  7 15:13:52 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse.y (array_initializer): Tagged <node>.
	(variable_initializer:): Use default rule.
	(array_initializer:): Defined actions.
	(variable_initializers:): Likewise.
	(resolve_qualified_expression_name): Use DECL_CONTEXT to build
 	non-static field accesses.
	(patch_invoke): Fixed indentation typo.
	(java_complete_tree): Likewise.
	(build_labeled_block): Changed leading comment. Generate an error
 	in case of duplicate loop labels.
	(patch_conditional_expr): Patch results of string concatenation
 	operations.

Sun Dec  6 13:45:00 1998  Per Bothner  <bothner@cygnus.com>

	* constants.c (find_methodref_index):  When the class is an interface,
	generate CONSTANT_InterfaceMethodref instead of a CONSTANT_MethodRef.

	* decl.c (finit_identifier_node):  Use "$finit$", rather than
	"<finit>" (which Sun's verifier rejects).
	* parse.y (maybe_generate_finit):  Leave out meaningless final flag.
	(generate_field_initialization_code):  Removed.
	(fix_constructors)  Don't add call to $finit$ here (wrong order).
	(patch_method_invocation):  Add $finit$ call here.

	* java-tree.h (CALL_USING_SUPER):  New macro.
	* parse.y (patch_invoke):  Remove im local variable.
 	(patch_method_invocation, patch_invoke):  Don't pass super parameter.
	(patch_invoke):  Use CALL_USING_SUPER instead of from_super parameter. 
	(resolve_qualified_expression_name):  Maybe set CALL_USING_SUPER.

	* jcf-write.c (get_access_flags):  Fix typo ACC_PUBLIC -> ACC_FINAL.

	* parse.y (java_complete_tree):  Don't complain about unreachable
	statement if it is empty_stmt_node.

	* jcf-write.c (find_constant_wide):  New function.
	(push_long_const):  Use find_constant_wide.

	* jcf-write.c (generate_bytecode_insn):  Fix bug in switch handling.
	(generate_bytecode_insn):  Use correct dup variant for MODIFY_EXPR.
	Add "redundant" NOTE_PUSH/NOTE_POP uses so code_SP_max gets set.
	Emit invokeinterface when calling an interface method.
	Emit invokespecial also when calling super or private methods.

	* jcf-write.c (generate_classfile):  Emit ConstantValue attributes.

Sun Dec  6 13:21:18 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-dump.c (INVOKE):  If invokeinterface, print number of args.

Thu Dec  3 17:11:12 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (java_layout_seen_class_methods): New function
 	prototype.
	(LAYOUT_SEEN_CLASS_METHODS): Macro removed.
	* jcf-parse.c (parse_class_file): Call java_layout_seen_class_methods.
	* parse.h (PROMOTE_RECORD_IF_COMPLETE): New macro.
	* parse.y (method_declarator:): Defined action.
	(issue_warning_error_from_context): input_filename saved, set to
 	the appropriate value and restored after java_error is called.
	(build_unresolved_array_type): Fixed comment.
	(register_fields): Use PROMOTE_RECORD_IF_COMPLETE.
	(method_header): Deal with return type the same way type are
 	handled for fields and method's parameters and local variables
 	types are handled.
	(check_method_redefinition): Removed extra CR.
	(declare_local_variables): Use PROMOTE_RECORD_IF_COMPLETE.
	(java_layout_seen_class_methods): New function.
	(java_layout_classes): Call java_layout_seen_class_methods.
	
Thu Dec  3 15:56:50 1998  Per Bothner  <bothner@cygnus.com>

	* parse,y (patch_synchronized_statement):  Set CAN_COMPLETE_NORMALLY.

Thu Dec  3 15:08:30 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-dump.c (main):  Fix error message.
	* jcf-path.c (add_entry):  Style fix.

Wed Dec  2 15:52:25 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class_method): Call build_java_argument_signature
	on constructors too.
	* parse.y (check_method_redefinition): Use TYPE_ARGUMENT_SIGNATURE.
	(patch_method_invocation): Define a primary when resolving an
 	expression name. Augmented comment on code checking illegal `this'
 	usage. Loosened it test by accepting NEW_CLASS_EXPR.

Tue Dec  1 13:53:24 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class_method): Don't report error on non-static
 	overriding static if the method is private.
	* java-tree.h (finish_class): Prototype added.
	* lex.c (java_get_line_col): Handle col argument -2 value.
	* parse.h: All static method declarations moved to parse.y.
	* parse.y: Now contains all static method declarations previously
 	found in parse.h.
	(find_expr_with_wfl, missing_return_error,
 	unreachable_stmt_error): New functions.
	(java_get_real_method_name): Identify constructors bearing class
 	names in source code compiled classes only.
	(java_complete_expand_methods): Call missing_return_error.
	(invocation_mode): Private methods invoked as static methods.
	(java_complete_tree): Call unreachable_stmt_error.

1998-12-01  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in (+target): Removed.
	(+xmake_file): Likewise.
	(+tmake_file): Likewise.
	(.NOEXPORT): Removed duplicate.

Fri Nov 27 13:20:51 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (jc1, jv-scan): Link with $(SUBDIR_OBSTACK).

	* jv-scan.c: Fix xmalloc prototype.  Provide an xmalloc definition.
	
	* jvgenmain.c: Remove the xmalloc prototype, we get it from
	libiberty.h.  Provide an xmalloc definition.

	* jvspec.c: Remove the xmalloc prototype.

	* parse-scan.y: Include config.h and system.h.  Don't include
	OS headers or gansidecl.h.  Don't prototype xmalloc/xstrdup.
	Provide an xstrdup definition.

Thu Nov 26 22:03:58 1998  Alexandre Oliva  <oliva@dcc.unicamp.br>

	* jcf-path.c (add_entry): Recognize ".jar" too.
	* lang-specs.h: Likewise.

Thu Nov 26 12:44:07 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-write.c (generate_bytecode_insns):  In Call_EXPR, handle
	soft_monitorenter_node, soft_monitorexit_node, throw_node.

	* jcf-write.c (generate_bytecode_insns):
  	Handle pre/post-increment/decrement of long.

	* jcf-write.c (generate_bytecode_insns):
	Handle missing exception handler (finally for synchronized).

Wed Nov 25 09:47:15 1998  Per Bothner  <bothner@cygnus.com>

	* java-tree.h (end_params_node):  Declare global.
	* decl.c (end_params_node):  New global.
	(init_decl_processing, start_java_method):  Use end_params_node for
	end of list of parameter types.  Follows correct gcc conventions.
	* expr.c (pop_argument_types, pop_arguments):  Likewise.
	* lang.c (put_decl_node):  Likewise.
	* typeck.c (various places):  Likewise.
	* class.y (various places):  Likewise.
	* parse.y (various places):  Likewise.

	* parse.y (java_complete_tree):  Move CAN_COMPLETE_NORMALLY.
	(build_jump_to_finally):  Add missing CAN_COMPLETE_NORMALLY.

	* class.c:  Add #include flags.h, remove no-longer needed declaration.

	* class.c (layout_class_method):  Remove commented-out code, re-format.
	Don't add vtable entry (or index) for private methods.
	* expr.c (expand_invoke):  A private method is implicitly final.
	* class.c (make_class_data):  If inlining or optimizing,
	skip private methods.

	* class.c (finish_class):  New function.  Calls existing methods,
	but alls emits deferred inline functions.
	* jcf-parse.c (parse_class_file):  Call finish_class.
	* parse.y (java_complete_expand_methods):  Likewise.

	* expr.c (build_java_binop):  Explicit default, to silence -Wall.

	* expr.c (CHECK_PC_IN_RANGE):  Add void cast to kill warnings.

Wed Nov 25 00:50:58 1998  Marc Espie <espie@quatramaran.ens.fr>

	* jcf-write.c (generate_bytecode_conditional): Fix typo.

Tue Nov 24 17:06:38 1998  Per Bothner  <bothner@cygnus.com>

	* (generate_classfile): Always write class access flag with
 	ACC_SUPER set.

Tue Nov 24 16:34:33 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (maybe_layout_super_class): New function.
	(layout_class): Reorganized. Loop on class methods dispatched into
 	a new function. Call maybe_layout_super_class.
	(layout_class_methods, layout_class_method): New functions.
	* expr.c (expand_java_NEW): Call layout_class_methods on loaded
 	class.
	(expand_invoke): Likewise.
	* java-tree.h (all_class_list): New global variable declared.
	(layout_class_methods, layout_class_method): New function
 	prototypes.
	(LAYOUT_SEEN_CLASS_METHODS): New macro.
	* jcf-parse.c (all_class_list): New global variable.
	(load_class): Extended what class_or_name can be. Use parser
 	context mechanism to save globals before calling jcf_parse.
	(jcf_parse_source): Don't parse twice if HAS_BEEN_ALREADY_PARSED_P
 	is set on the file name.
	(jcf_parse): Layout class methods when Object is loaded, otherwise
 	record class in all_class_list for delayed method layout.
	(parse_class_file): Use LAYOUT_SEEN_CLASS_METHODS.
	* lang.c (put_decl_node): Decode <init> into the decl context
 	class name.
	* lex.c (java_allocate_new_line): Use xmalloc.
	* parse.h (INCOMPLETE_TYPE_P): Redefined to work with incomplete
 	pointers, not TREE_LIST elements.
	(struct parser_ctxt): Fixed comment indentations, added comments
 	and reordered some fields.
	(java_check_methods): Function prototype removed.
	* parse.y (java_push_parser_context): Use xmalloc.
	(java_parser_context_restore_global): Pop extra pushed ctxp only
 	when there's nothing next.
	(maybe_create_class_interface_decl): Fixed comment, add new
 	created class decl to all_class_list.
	(method_header): Use GET_REAL_TYPE on argument's types.
	(method_declarator): Use GET_REAL_TYPE, change type to the real
 	type in TREE_LIST dependency node. Build argument list with the
 	real type.
	(create_jdep_list): Use xmalloc. Removed allocation error message.
	(obtain_incomplete_type): Fixed leading comment. Broadened
 	incoming argument meaning.
	(register_incomplete_type): Use xmalloc. Removed allocation error
 	message.
	(safe_layout_class): Fixed leading comment.
	(jdep_resolve_class): Reversed if statement condition and switch
 	if and else bodies.
	(resolve_and_layout): Fixed leading comment. Broadened incoming
 	argument meaning.
	(complete_class_report_errors): New local variable name, for
 	clarity. purify_type_name used for all error cases.
	(java_get_real_method_name): Stricter check on constructors.
	(java_check_regular_methods): Reverse methods list only if not
 	already laid out. Layout artificial constructor.
	(java_check_methods): Deleted.
	(source_start_java_method): Obtain incomplete type for patchable
 	method arguments.
	(java_layout_classes): Fixed leading comment. Use
 	LAYOUT_SEEN_CLASS_METHODS, use a loop to check methods. Added else
 	statement to layout operation, reuse LAYOUT_SEEN_CLASS_METHODS
 	before returning. Fixed comments.
	(java_expand_classes): Check for errors up front.
	(patch_method_invocation): Class to search is resolved and laid
 	out.
	
Tue Nov 24 12:57:13 1998  Per Bothner  <bothner@cygnus.com>

	* expr.c (java_lang_expand_expr):  Add missing emit_queue.

	* javaop.h (int8):  Removed - not used.
	(jbyte):  Redefine portably with correct signedness.

	* jcf-write.c (generate_bytecode_insns):  Don't free sw_state.cases.

	* jcf-write.c (generate_bytecode_insns):  Fix typo
	OPCODE_getstatic to OPCODE_getfield.

	* java-tree.def (CASE_EXPR, DEFAULT_EXPR):  Kind is 'x', not '1'.
	* parse.y (java_complete_tree):  For CASE_EXPR and DEFAULT_EXPR,
	set TREE_SIDE_EFFECTS (otherwise expand_expr may skip them).

Thu Nov 19 11:16:55 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jcf-parse.c (jcf_parse_source): Function returned type is
 	void. Added prototype.
	(jcf_parse): Function returned type is void.
	(yyparse): Remove call to fclose on the last parsed file.

	* java-tree.h (jcf_parse): Changed jcf_parse prototype.

Wed Nov 18 23:54:53 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (unmangle_classname): Set QUALIFIED_P when appropriate.
	(layout_class): Cope with methods featuring WFL in decl names.
	* decl.c (unqualified_object_id_node): New global variable,
 	initialized.
	(build_decl_no_layout): Removed.
	* expr.c (build_primtype_type_ref): Handle Double.
	(java_lang_expand_expr): Fixed indentations.
	* java-tree.h (CLASS_METHOD_CHECKED_P): Flag deleted.
	(flag_wall, flag_redundant, flag_not_overriding,
 	flag_static_local_jdk1_1, unqualified_object_id_node): Global
 	variable declarations.
	(build_decl_no_layout): Removed prototype.
	(java_get_real_method_name): Added prototype.
	(IS_UNCHECKED_EXPRESSION_P): Renamed IS_UNCHECKED_EXCEPTION_P.
	(java_parse_abort_on_error): Macro now just returns.
	* jcf-parse.c (jcf_parse_source): Check fclose returned
 	value. Call emit_register_classes if java_report_errors returns
 	zero.
	* lanc.c (flag_wall, flag_redundant, flag_not_overriding,
 	flag_static_local_jdk1_1): New integer flags.
	(lang_decode_option): New flags set here.
	* parse.h (GET_REAL_TYPE, GET_METHOD_NAME): New macros.
	(OBSOLETE_MODIFIER_WARNING): Issue error message conditionally to
 	the flag_redundant variable.
	(SET_TYPE_FOR_RESOLUTION): Consider Object being java.lang.Object
 	when parsing java.lang.Object class.
	(BUILD_MONITOR_ENTER, BUILD_MONITOR_EXIT): Added terminal
 	NULL_TREE to build.
	(resolve_qualified_expression_name): Fixed indentation.
	(patch_array_ref): Changed prototype.
	(not_initialized_as_it_should_p): Prototype removed.
	(java_report_errors): Added function prototype.
	* parse.y (formal_parameter:): Changed error message for not yet
 	supported final parameters.
	(class_type_list:): Set both PURPOSE and VALUE of created
 	TREE_LIST to be class_type.
	(primary_no_new_array:): Handle class literals on primitive types.
	(parse_warning_context): Reinstalled correct force_error and
 	do_warning flags setups.
	(java_report_errors): Changed prototype. Return java_error_count
 	value.
	(variable_redefinition_error): Consider treating variable type as
 	a fake pointer.
	(create_interface): Warn about redundant abstract modifier if
 	flag_redundant is set. Changed error message.
	(lookup_field_wrapper): Save/restore globals before/after looking
 	up field.
	(duplicate_declaration_error_p): Consider treating declaration
 	type as a fake pointer.
	(register_fields): Extract real type from dependency node. Check
 	for duplicate field declaration after type adjustment. Use
 	DECL_INITIAL to store static final initialized values.
	(method_header): Extract real function type from dependency node.
	(check_abstract_method_header): Use GET_METHOD_NAME.
	(obtain_incomplete_type): Layout fake pointer type.
	(safe_layout_class): Don't try to check for methods before layout.
	(java_complete_class): Don't check for correct throws clause
 	elements inheritance here.
	(resolve_and_layout): Broadened name parameter meaning.
	(reset_method_name): Use GET_METHOD_NAME.
	(java_get_real_method_name): New function.
	(java_check_regular_methods): Don't check methods in
 	java.lang.Object.  Verify lineage of throws clause elements. Use
 	flag_no_overriding in warning report.
	(check_throws_clauses): Don't check if class was from
 	bytecode. Use IS_UNCHECKED_EXCEPTION_P macro.
	(java_check_methods): Don't set CLASS_METHOD_CHECKED_P flag.
	(declare_local_variables): Use flag_static_local_jdk1_1 to report
 	warning on unsupported final local variables. Use build_decl
 	instead of build_decl_no_layout. Get real local variable type from
 	dependency node.
	(source_start_java_method): Get real parameter type from
 	dependency node. Call build_decl instead of build_decl_no_layout.
	(java_layout_classes): Reverse tree and layout type and class as
 	required. Mark class as loaded when done.
	(resolve_field_access): Fixed indentation. Restricted condition
 	leading to static field access code generation. Set field_type
 	decl's TREE_TYPE if QUAL_DECL_TYPE not available.
	(resolve_qualified_expression_name): Initialize type_found to
 	null. Handle static field resolved during qualification. Fixed
 	layout on non primitive field decl types.
	(not_accessible_p): Fixed typo in comment.
	(patch_method_invocation): Resolve and layout class to search from
 	type.
	(lookup_method_invoke): Keep integer constant 0 as is. Resolve and
 	layout non primitive type, if necessary. Make method node only to
 	report errors.
	(find_applicable_accessible_methods_list): Consider WFL'ed method
 	decl names. Fixed indentation.
	(argument_types_convertible): Resolve and layout target type if
 	necessary.
	(java_complete_tree): Fixed indentation problems. Rewrote
 	CALL_EXPR thrown exceptions check. Re-installed further processing
 	of the assignment in certain cases.
	(patch_assignment): Call maybe_build_primttype_type_ref to perform
 	inlining on class literals.
	(valid_builtin_assignconv_identity_widening_p): Cope with constant
 	0 literal.
	(valid_method_invocation_conversion_p): Likewise.
	(patch_string): Temporary disable forbidden use of `this' in
 	explicit constructor invocations when doing string concatenation
 	within their scope.
	(patch_unaryop): Added comment. Reinstalled code to disable
 	further check on assignment operation with cast expression RHS.
	(patch_switch_statement): Fixed indentation.
	(build_try_statement): Call build_decl instead of
 	build_decl_no_layout.
	(patch_synchronized_statement): Likewise.
	(patch_throw_statement): Use IS_UNCHECKED_EXCEPTION_P instead of
 	IS_UNCHECKED_EXPRESSION_P.
	(check_thrown_exceptions_do): Changed leading comment. Resolve and
 	layout argument exception type.
	(purge_unchecked_exceptions): Use IS_UNCHECKED_EXCEPTION_P instead
 	of IS_UNCHECKED_EXPRESSION_P.
	
Wed Nov 18 14:21:48 1998  Anthony Green  <green@cygnus.com>

	* jcf-parse.c (yyparse): Open class file in binary mode.

Sun Nov 15 17:14:17 1998  Per Bothner  <bothner@cygnus.com>

	* jvgenmain.c:  Need to #include "gansidecl.h" (to get PROTO).

	* jcf-write.c (perform_relocations):  Move check out one loop.

Sun Nov 15 15:09:56 1998  Anthony Green  <green@hoser.cygnus.com>

	* Make-lang.in: Fix reference to srcdir.
	* jv-scan.c: Add missing xmalloc prototype.
	* jvgenmain.c: Ditto.

Sun Nov 15 14:36:29 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c (error_mark_node), java-tree.h:  New global.
	* parse.y:  Use empty_stmt_node instead of size_zero_node.
	(build_if_else_statement):  If missing else, use empty_stmt_node.

	* parse.y (not_initialized_as_it_should_p):  Removed, with its callers.
	(java_complete_expand_method):  Complain if return is missing.
	(java_check_regular_methods):  Comment out incorrect error check.
	(not_accessible_p):  Fix incorrect handling of protected methods.
	(patch_method_invocation):  Pass correct context to not_accessible_p.
	(find_applicable_accessible_methods_list):  Likewise.
	(qualify_ambiguous_name):  If ARRAY_REF, it's an expression name.
	(java_complete_tree):  For CASE_EXPR and DEFAULT_EXPR, set
	TREE_TYPE (to void_type_node);  otherwise expand_expr crashes.
	(patch_if_else_statement):  Fix setting of CAN_COMPLETE_NORMALLY.

	* jcf-write.c (CHECK_OP, CHECK_PUT):  Add some error checking.
	(push_int_const):  Remove reundant NOTE_PUSH.
	(generate_bytecode_insns - case STRING_CST):  Do NOTE_PUSH.
	(- case SWITCH_EXPR):  Fix code generation bug.
	(- case PREDECREMENT_EXPR etc):  Remove redundant NOTE_PUSH.
	(generate_classfile):  More robust for abstract methods.

Sun Nov 15 13:52:39 1998  Anthony Green  <green@cygnus.com>

	* Makefile.in: jv-scan and jvgenmain all require libiberty.
	* Make-lang.in: Ditto.

	* jv-scan.c: Remove xmalloc and xstrdup definitions.
	* jvgenmain: Ditto.

Sun Nov 15 14:10:56 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-parse.c (HANDLE_EXCEPTIONS_ATTRIBUTE):  New macro.

	* jcf-io.c (find_class):  Simpler/cleaner structure fixes a bug.

Sat Nov 14 17:19:18 1998  Per Bothner  <bothner@cygnus.com>

	Allow uses of interface types to verify.  This is not really
	type-safe, but it matches what Sun does, and is OK as long as
	there are appropriate run-time checks.
	* verify.c (merge_types):  If merging two interface types,
	just set the result to java.lang.Object.
	* expr.c (pop_type):  Any interface is matches by java.lang.Object.

1998-11-13  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (main): Handle --output-class-directory argument.
	* jvspec.c (lang_specific_driver): Translate `-d' into
	-foutput-class-dir.
	* jcf.h (jcf_write_base_directory): Declare.
	* lang.c (lang_decode_option): Recognize -foutput-class-dir.
	* lang-options.h: Mention -foutput-class-dir.
	* jcf-write.c (jcf_write_base_directory): New global.
	(make_class_file_name): Put generated .class file into `-d'
	directory, or into source directory if -d not given.  Function now
	static.
	(write_classfile): Free class file name.  Handle case where class
	file name is NULL.
	(DIR_SEPARATOR): New macro.
	Include <sys/stat.h>

	* Makefile.in (prefix): New macro.

Thu Nov 12 14:15:07 1998  Per Bothner  <bothner@cygnus.com>

	* parse.y (patch_invoke):  Do less if flag_emit_class_files.
	* expr.c (build_known_method_ref):  Don't check flag_emit_class_files
	here (done in patch_invoke instead).
	(case_identity):  Moved here from parse.y.

	* java-tree.h (CAN_COMPLETE_NORMALLY):  New macro.
	* parse.y (java_complete_tree etc):  Maybe set CAN_COMPLETE_NORMALLY.
	* parse.y (java_complete_tree):  Re-order COMPOUND_EXPR in BLOCK
	so they can be efficiently scanned without recursion.
	Error it ! CAN_COMPLETE_NORMALLY first part of COMPOUND_EXPR.
	* expr.c (java_lang_expand_expr):  Expand statements of COMPOUND_EXPR
	in BLOCK iteratively, rather than recursively.

	* parse.y (do_unary_numeric_promotion):  New function.
	(patch_unaryop, patch_binop, patch_array_ref):  Use it.

	* parse.y (patch_newarray):  Various fixes.

	Re-do handling of switch statements (for proper block scoping).
	* parse.y:  Add just a single block for the enture switch block,
	but don't create any "case blocks".
	(group_of_labels):  Rmeoved unneeded non-terminal.
	CASE_EXPR and DEFAULT_EXPR are added to current block.
	* expr.c (java_lang_expand_expr):  Inline SWITCH_EXPR here.
	Now also need to handle CASE_EXPR and DEFAULT_EXPR.
	* java-tree.h (SWITCH_HAS_DEFAULT):  New macro.
	* parse.y (wfl_operator, print_int_node): Make non-static.
	(java_complete_tree):  CASE_EXPR and DEFAULT_EXPR are now processed
	as part of recursive scan of block.
	(java_expand_switch ):  Removed - inlined into java_lang_expand_expr.
	(patch_switch_statement):  Most tests move dinto java_complete_tree.
	
	* parse.y:  Make various production be non-typed (void).
	* parse.y (parse_error):  Merged into issue_warning_error_from_context.
	* parse.y (add_stmt_to_compound):  Don't create/change extra node.
	(patch_method_invocation_stmt):  Renamed to patch_method_invocation.

	* jcf-write.c (struct jcf_handler):  New type.
	(struct jcf_switch_state):  New type.
	(SWITCH_ALIGN_RELOC, BLOCK_START_RELOC):  New relocation kinds.
	(alloc_handler, emit_unop, emit_reloc):  New functions.
	(adjust_typed_op):  Add extra parameter ("max type" offset).
	(emit_switch_reloc, emit_case-reloc):  New function.
	(generate_bytecode_conditional):  Handle REAL_TYPE comparisons.
	(generate_bytecode_insns):  Support REAL_CST, switch statements,
	exception handling, method calls, object/array creation, and more.
	
	* class.c:  Remove some unused variables.
	* constants.c (find_string_constant):  New function.
	(count_constant_pool_bytes):  Fix to correctly handle wide constants.
	* decl.c (complete_start_java_method):  Don't _Jv_InitClass
	if flag_emit_class_files.

1998-11-12  Tom Tromey  <tromey@cygnus.com>

	* jcf-io.c (find_class): Added explanatory comment.

	* jcf-path.c (add_entry): Look for `.zip' at end of filename.  Add
	trailing slash to `.zip' entries.

	* jvspec.c (lang_specific_driver): Correctly handle case where
	GC_NAME not defined.

1998-11-11  Tom Tromey  <tromey@cygnus.com>

	* jvspec.c (GC_NAME): New define.
	(lang_specific_driver): Use GC_NAME.  Add GC_NAME to command line
	if required.
	* Make-lang.in (jvspec.o): Define WITH_GC_<name>.

Wed Nov 11 19:08:52 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-dump.c (TABLE_SWITCH):  Fix typos.

1998-11-11  Tom Tromey  <tromey@cygnus.com>

	* jcf-dump.c (main): Correctly recognize `--'-style long options.

Tue Nov 10 12:34:03 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (is_compiled_class): Call safe_layout_class for class
 	compiled from source.
	* conver.h (convert_to_integer, convert_to_real,
 	convert_to_pointer): Added prototypes.
	* decl.c (init_decl_processing): Non longer push the decls of
 	`methodtable', `constants', `Class', `Field', `dispatchTable'
 	`jexception' and `Method'.
	* expr.c (build_invokeinterface): New function.
	(expand_invoke): static variable CLASS_IDENT now in
 	build_invokeinterface. Use build_invokeinterface.
	(expand_java_field_op): Moved code to inline
 	java.lang.PRIMTYPE.TYPE into a function.
	(build_primtype_type_ref): New function.
	* java-tree.def (INSTANCEOF_EXPR): New tree code.
	* java-tree.h (CLASS_METHOD_CHECKED_P, METHOD_DEPRECATED,
 	FIELD_DEPRECATED, CLASS_DEPRECATED): New flag macros.
	(DECL_CONSTRUCTOR_P): Fixed typo in comment.
	(DECL_LOCAL_STATIC_VALUE): New macro.
	(build_invokeinterface, build_primtype_type_ref): New function
 	prototypes.
	(java_parse_abort_on_error): Macro rewritten.
	* jcf-parse.c (current_method): Add comment to declaration.
	(parse_zip_file_entries, process_zip_dir, void parse_source_file):
 	Function prototypes fixed.
	(jcf_parse_source): push/pop parser context. save/restore global.
	(parse_source_file): Fixed leading comment. Now take a
 	IDENTIFIER_NODE as an argument. Doesn't check methods, layout
 	classes and pop the parser context anymore.
	(yyparse): Push parser context, save globals, parse the source
 	file, restore globals and pop the parser context when processing a
 	source file.
	* jcf.h (VERBOSE_SKELETON): Replaces SOURCE_FRONTEND_DEBUG define.
	* lex.c (java_parse_doc_section): New function.
	(java_lex): Call java_parse_doc_section when appropriate. Build an
 	operator around INSTANCEOF_TK.
	* lex.h (java_lineterminator, java_sprint_unicode,
 	java_unicode_2_utf8, java_lex_error, java_store_unicode):
 	Prototypes rewritten.
	(java_parse_escape_sequence, java_letter_or_digit_p,
 	java_parse_doc_section, java_parse_end_comment, java_get_unicode,
 	java_read_unicode, java_store_unicode, java_read_char,
 	java_allocate_new_line, java_unget_unicode, java_sneak_unicode):
 	Added function prototypes.
	* parse.h (VERBOSE_SKELETON): Replaces SOURCE_FRONTEND_DEBUG
 	define.
	(JNULLP_TYPE_P, CHECK_METHODS, CHECK_DEPRECATED, REGISTER_IMPORT):
 	New macros
	(struct parser_ctxt): New fields: deprecated,
 	current_parsed_class_un, gclass_list.
	(fix_method_argument_names, issue_warning_error_from_context,
 	resolve_package, lookup_package_type): New function prototypes.
	(resolve_expression_name): Fixed function prototype.
	(find_applicable_accessible_methods_list): Fixed indentation, added
	extra argument in prototype.
	(check_final_assignment, build_null_of_type, check_deprecation,
 	check_method_redefinition, reset_method_name,
 	java_check_regular_methods, java_check_abstract_methods,
 	maybe_build_primttype_type_ref): New function prototype.
	* parse.y (conver.h): Include.
	(INSTANCEOF_TK): Tagged <operator>.
	(single_type_import_declaration): Use REGISTER_IMPORT macro.
	(relational_expression:): Build binop for instanceof.
	(java_push_parser_context): Remember ctxp->gclass_list across
 	contexts.
	(java_pop_parser_context): Simply return if no context
 	exists. Remember gclass_list across contexts.
	(issue_warning_error_from_context): New function.
	(parse_error_context): Don't setup ctxp->elc here. Call
 	issue_warning_error_from_context instead.
	(parse_warning_context): Likewise.
	(maybe_create_class_interface_decl): Removed DECL_ARTIFICIAL
 	setup. Link new class/interface to ctxp->gclass_list.
	(add_superinterfaces): Register interface as incomplete if not
 	loaded.
	(create_class): Remember class unqualified name in
 	ctxp->current_parsed_class_un. Check class deprecation.
	(register_fields): Check field deprecation. Remember static final
 	field value in DECL_LOCAL_STATIC_VALUE. Changed comment in part
 	processing INIT.
	(method_header): New local variable ORIG_ARG. Use unqualified
 	current class name for check on constructor errors. Promote return
 	type if of record type. Argument list fix moved in
 	fix_method_argument_names, called here. Check method deprecation.
	(fix_method_argument_names): New function.
	(method_declarator): Promote record typed arguments.
	(safe_layout_class): Check class methods before layout.
	(java_complete_class): Compute field layout when patched.
	(do_resolve_class): Try to load class after having it renamed
 	after the package name.
	(get_printable_method_name): Use DECL_CONTEXT.
	(reset_method_name): New function.
	(check_method_redefinition): Use reset_method_name.
	(java_check_regular_methods): New local variable
 	SAVED_FOUND_WFL. Temporarily reinstall overriding/hiding method
 	names for error report. Check for compile-time error when method
 	found has default (package) access.
	(java_check_abstract_methods): Now takes an interface DECL node as
 	an argument. Also reinstall real name on unchecked
 	overriding/hiding methods for error report.
	(java_check_methods): Fixed leading comment. Get classes to verify
 	from ctxp->gclass_list. Use CHECK_METHODS macro and set
 	CLASS_METHOD_CHECKED_P on class verification.
	(lookup_java_method2): Get real method name if necessary.
	(find_in_imports): Don't check package class access here.
	(resolve_package, lookup_package_type): New functions.
	(java_layout_classes): Fixed leading comment. Take classes to be
 	laid out from ctxp->gclass_list.
	(java_complete_expand_methods): Don't expand native and abstract
 	methods.
	(java_expand_classes): New function.
	(resolve_expression_name): Use additional argument ORIG.  Retrieve
 	values of static final field of primitive types.
	(resolve_field_access): Handles static final field of promotive
 	type.
	(resolve_qualified_expression_name): Handle STRING_CST as
 	primaries and package name resolution. Check deprecation on found
 	decls. Set where_found and type_found on non static field resolved
 	during qualification. Layout non primitive field decl types.
	(check_deprecation): New function.
	(maybe_access_field): Simplified.
	(patch_method_invocation_stmt): Local variable CLASS_TYPE
 	removed. Reverse method's argument when primary is a type. Don't
 	use CLASS_TYPE to report problems, use IDENTIFIER_WFL
 	instead. Include abstract class in the list of class searchable
 	for constructors. Use DECL_CONTEXT of found method for access
 	checks. Check method deprecation.
	(patch_invoke): Pay extra care to NEW_CLASS_EXPR type call when
 	converting arguments. Handle INVOKE_INTERFACE.
	(lookup_method_invoke): Search constructor using existing
 	infrastructure (don't rely on lookup_java_constructor anymore).
	(find_applicable_accessible_methods_list): Extra argument flag
 	LC. Now include constructor in the search.
	(qualify_ambiguous_name): Conditional expression are primaries.
	(not_initialized_as_it_should_p): static final are always
 	initialized.
	(java_complete_tree): Pass extra NULL argument to
 	resolve_expression_name. Stricter test to carry on patching
 	assignments. New case for INSTANCEOF_EXPR.
	(complete_function_arguments): Inline PRIMTYPE.TYPE read access.
	(check_final_assignment, maybe_build_primttype_type_ref): New
 	functions.
	(patch_assignment): Detect resolved static finals and carry normal
 	assignment error check on them. Inline PRIMTYPE.TYPE read access.
	(try_builtin_assignconv): Access constant 0 on all primitive
 	types.
	(valid_builtin_assignconv_identity_widening_p): Accept identical
 	types. Accept all promoted type on int type.
	(valid_ref_assignconv_cast_p): Accept a null pointer to be
 	assigned to a reference.
	(valid_method_invocation_conversion_p): Accept to check null
 	pointers.
	(build_binop): Merge declaration and initialization of local
 	variable BINOP.
	(patch_binop): New case for INSTANCEOF_EXPR. NE_EXPR to accept all
 	numeric types. Improved validity test for qualify operators on
 	references.
	(patch_unaryop): Broadened rejection test for PREDECREMENT_EXPR
 	and PREINCREMENT_EXPR. Also detect resolved static finals of a
 	primitive type and issue the appropriate error message.
	(resolve_type_during_patch): Mark class loaded when resolved.
	(patch_cast): Allow null to be cased to reference types.
	(build_null_of_type): New function.
	(patch_array_ref): Handle array on references correctly.
	(patch_return): Removed unused local variable MODIFY. Force
 	boolean to be returned as integers. Allows null to be returned by
 	a function returning a reference.
	* typeck.c (convert_to_integer, convert_to_real,
 	convert_to_pointer): Prototypes moved to convert.h
	(lookup_argument_method): Use method real name, if necessary.

1998-10-30  Tom Tromey  <tromey@cygnus.com>

	* class.c (build_class_ref): Changed name of primitive classes to
	start with `_Jv_'.

	* class.c (make_class_data): Renamed fields: nmethods to
	method_count, method_count to dtable_method_count.  Always set
	`state' field to 0.
	* decl.c (init_decl_processing): Likewise.

Wed Oct 28 08:03:31 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (layout_class): Don't mangle <finit>, produce
 	__finit<class> instead. Don't verify artificial methods.
	* decl.c (finit_identifier_node): New declared global.
	(init_decl_processing): finit_identifier_node initialized.
	* java-tree.def (CONDITIONAL_EXPR): New Java tree code.
	* java-tree.h (finit_identifier_node): Declared as extern.
	(struct lang_decl): New field called_constructor.
	(DECL_CONSTRUCTOR_CALLS): Access macro to called_constructor.
	(CLASS_HAS_FINIT_P): New macro.
	(CALL_CONSTRUCTOR_P): Leading comment changed. Macro now checks
 	explicit constructor invocation.
	(CALL_EXPLICIT_CONSTRUCTOR_P, CALL_THIS_CONSTRUCTOR_P,
 	CALL_SUPER_CONSTRUCTOR_P): New macros.
	(write_classfile): Added prototype.
	* jcf-parse.c (jcf_parse_source): Parse and remember for
 	generation if the file was seen on the command line.
	(parse_source_file): Don't write the class file here.
	(yyparse): Loop on files rewritten. Set current_jcf.
	(parse_zip_file_entries): Parse class file only if it was found.
	* lang.c (init_parse): Don't open command line provided filename
 	here.
	(lang_parse): Don't set main_jcf anymore.
	* parse.h (ABSTRAC_CHECK): Capitalized arguments.
	(JCONSTRUCTOR_CHECK): New macro.
	(JBSC_TYPE_P): New macro.
	(IN_TRY_BLOCK_P, EXCEPTIONS_P): Fixed leading comment.
	(COMPLETE_CHECK_OP_2): New macro.
	(struct parse_ctxt): New field explicit_constructor_p.
	(check_class_interface_creation): Fixed prototype indentation.
	(patch_method_invocation_stmt): Prototype reflects added argument.
	(patch_invoke): Likewise.
	(complete_method_declaration, build_super_invocation,
 	verify_constructor_circularity,
 	build_this_super_qualified_invocation, get_printable_method_name,
 	patch_conditional_expr, maybe_generate_finit, fix_constructors,
 	verify_constructor_super, create_artificial_method,
 	start_artificial_method_body, end_artificial_method_body,
 	generate_field_initialization_code): New function prototypes.
	* parse.y: Fixed leading comment
	(constructor_header:, constructor_body:, block_end:): Rules tagged
 	<node>.
	(type_declaration:): Call maybe_generate_finit.
	(method_declaration:): Action for method_body: placed in new
 	function complete_method_declaration, called here.
	(constructor_declaration:): Defined actions. Removed leading
 	FIXME.
	(constructor_header:): New rule with action.
	(constructor_body:): Rule rewritten using block_begin: and
 	block_end:. Defined actions.
	(constructor_declarator:, explicit_constructor_invocation:):
 	Defined actions.
	(block:): Use new rules block_begin: block_end:.
	(block_begin:, block_end:): New rules and actions.
	(block_statements:): Fixed error message for explicit
 	constructors.
	(method_invocation:): Call build_this_super_qualified_invocation
 	if primary is `this' or `super' was seen.
	(conditional_expression:): Action defined.
	(extra_ctxp_pushed_p): New static global flag.
	(java_parser_context_save_global): Create parser context if
 	necessary. Use extra_ctxp_pushed_p to remember it.
	(java_parser_context_restore_global): Pop extra parser context if
 	one exists.
	(build_array_from_name): Array on primitive types are marked
 	loaded.
	(register_fields): Restore new name in field initializer
 	expression if type was altered. Non static fields initialized upon
 	declaration marked initialized.
	(maybe_generate_finit): New function.
	(maybe_generate_clinit): Use create_artificial_method,
 	start_artificial_method_body, end_artificial_method_body. Generate
 	debug info for enclosed initialization statements.
	(method_header): Fixed leading comment. Check constructor
 	flags. Detect constructor declarations and set DECL_CONSTRUCTOR_P
 	accordingly.
	(complete_method_declaration, constructor_circularity_msg,
 	verify_constructor_circularity): New functions.
	(get_printable_method_name): New function.
	(check_method_redefinition): Don't rename <finit> methods. Fix
 	declared constructor names. Error message for
 	constructors modified.
	(java_check_regular_methods): Local variable seen_constructor
 	renamed saw_constructor. Skip verification on constructors. Create
 	default constructor with create_artificial_method.
	(java_check_methods): Removed unnecessary empty line.
	(create_artificial_method, start_artificial_method_body,
 	end_artificial_method_body): New functions.
	(java_layout_classes): Changed leading comment. Reverse fields
 	list if necessary. Always layout java.lang.Object if being
 	defined.
	(java_complete_expand_methods): Verify constructor circularity.
	(java_complete_expand_method): Call fix_constructor on
 	constructors.  Local variable no_ac_found removed. Restore
 	bindings if method body expansion failed.
	(fix_constructors, verify_constructor_super,
 	generate_field_initialization_code): New function.
	(java_expand_classes): Fixed leading comment. Write class file
 	here.
	(resolve_expression_name): Check for illegal instance variable
 	usage within the argument scope of an explicit constructor
 	invocation.
	(resolve_qualified_expression_name): Pass extra from_super flag
 	when invoking patch_method_invocation_stmt. New case for
 	conditional expression when used as a primary. Check for error
 	when acquiring super.
	(patch_method_invocation_stmt): Added extra argument super. New
 	local variable is_static_flag. Set class_to_search according to
 	the nature of the constructor invocation. Don't add `this'
 	argument when expanding NEW_CLASS_EXPR. Check for illegal method
 	invocation within the argument scope of explicit constructor
 	invocation. Set is_static according to is_static_flag. Provide
 	extra `super' argument to patch_invoke invocation.
	(patch_invoke): New argument from_super. Loop on arguments
 	indentation fixed. Pass from_super to invocation_mode. New switch
 	case INVOKE_SUPER. Fixed error message in switch default case.
  	Don't use CALL_CONSTRUCTOR_P but rather a test on the tree node
 	value.
	(invocation_mode): Return INVOKE_SUPER mode when appropriate.
	(lookup_method_invoke): Fixed prototypes in candidates list. Error
 	message takes constructors into account.
	(find_applicable_accessible_methods_list): Fixed indentation.
	(qualify_ambiguous_name): Take explicit constructor invocation
 	into account. Deal with a conditional expression as a primary to
 	a method call.
	(java_complete_tree): Added local wfl_op3. New CONDITIONAL_EXPR
 	case. Added extra argument to patch_method_invocation_stmt.
 	Register calls made to explicit constructor `this'. Don't call
 	save_expr in ARRAY_REF case when emitting class files. Check for
 	illegal use of this when expanding explicit constructor invocation
 	arguments.
	(complete_function_arguments): Set and reset parser context
 	explicit_constructor_p field value when appropriate.
	(build_super_invocation, build_this_super_qualified_invocation):
 	New functions.
	(patch_assignment): Fixed typo.
	(patch_unaryop): Check on final fields occurs only when a decl
 	exits.
	(patch_return): Take constructors into account.
	(patch_conditional_expr): New function.
	* typeck.c (build_java_signature): Removed unnecessary empty line.
	
Wed Oct 28 00:46:15 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (jcf-dump, gcjh): Link in $(LIBS) too.

1998-10-28  Tom Tromey  <tromey@cygnus.com>

	* decl.c (init_decl_processing): Renamed fields.
	* class.c (make_class_data): Renamed bfsize, nfields, nsfields,
	interface_len, msize fields.

	* class.c (make_class_data): Removed subclass_head and
	subclass_next fields.
	* decl.c (init_decl_processing): Removed subclass_head and
	subclass_next fields.

Wed Oct 28 00:46:15 1998  Jeffrey A Law  (law@cygnus.com)

	* jcf-write.c (emit_load_or_store): Avoid implicit int arguments.
	* mangle.c (emit_unicode_mangled_name): Similarly.

Mon Oct 26 12:17:23 1998  Nick Clifton  <nickc@cygnus.com>

	* jcf-parse.c (get_constant): Place braces around code to compute
	'd' when REAL_ARITHMETIC is not defined.

Sun Oct 25 14:58:05 1998  H.J. Lu  (hjl@gnu.org)

	* Make-lang.in (jv-scan$(exeext)): Add stamp-objlist to
	dependency.

1998-10-23  Tom Tromey  <tromey@cygnus.com>

	* lang-specs.h: `.zip' files are input to jc1.

Thu Oct 22 23:01:54 1998  Per Bothner  <bothner@cygnus.com>

	* jvspecs.c:  Add (but don't enable) support for combining multiple
	.class and .java input filenames to a single jc1 invocation.
	Add support for -C flag (copile to .class files).
	Translate -classpath and -CLASSPATH arguments.
	* lang-specs.h:  Don't set %2 spec.

1998-10-22  Tom Tromey  <tromey@cygnus.com>

	* jcf-path.c (add_entry): Don't add trailing separator if entry is
	a .zip file.
	(add_path): Don't add trailing separator to non-empty path
	elements.

	* lang.c (lang_decode_option): Check for -fclasspath and
	-fCLASSPATH before examining other `-f' options.

	* java-tree.h (finalize_identifier_node): Don't declare.
	* class.c (make_class_data): Don't push "final" field.
	* decl.c (init_decl_processing): Don't push "final" field.
	(finalize_identifier_node): Removed.
	(init_decl_processing): Don't set finalize_identifier_node.

	* config-lang.in (stagestuff): Added jcf-dump and jv-scan.

Sun Oct 11 10:31:52 1998  Anthony Green  <green@cygnus.com>

	* Make-lang.in (java): Depend on jcf-dump and jv-scan.
	(JV_SCAN_SOURCES): New macro.
	(JCF_DUMP_SOURCES): Likewise.
	(jcf-dump$(exeext)): New target.
	(jv-scan$(exeext)): New target.

1998-10-22  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in (LEX): Removed.
	(LEXFLAGS): Likewise.
	(SET_BISON): New macro.
	(BISON): Removed.
	($(PARSE_C)): Use SET_BISON.  Run bison from srcdir to avoid
	spurious diffs in parse.c.
	($(PARSE_SCAN_C)): Likewise.
	(PARSE_DIR): New macro.
	(PARSE_C): Use it.
	(PARSE_SCAN_C): Likewise.
	(PARSE_RELDIR): New macro.

	* jcf-io.c (saw_java_source): Define here, not in jcf-parse.c.

	* jcf-io.c (find_class): Use saw_java_source to determine when to
	look for `.java' file.
	* jcf-parse.c (saw_java_source): New global.
	(yyparse): Set it if `.java' file seen.

	* Make-lang.in (JAVA_SRCS): Added jcf-path.c.
	(GCJH_SOURCES): Likewise.
	* Makefile.in (datadir): New macro.
	(libjava_zip): Likewise.
	(JAVA_OBJS): Added jcf-path.o.
	(../jcf-dump$(exeext)): Depend on and link with jcf-depend.o.
	(../gcjh$(exeext)): Likewise.
	(jcf-path.o): New target.
	* java-tree.h (fix_classpath): Removed decl.
	* jcf-parse.c (fix_classpath): Removed.
	(load_class): Don't call fix_classpath.
	* parse.y (read_import_dir): Don't call fix_classpath.
	* lex.h: Don't mention classpath.
	* lex.c (java_init_lex): Don't initialize classpath.
	* jcf-io.c (classpath): Removed global.
	(find_class): Use jcf_path iteration functions.  Correctly search
	class path for .java file.
	(open_in_zip): New argument `is_system'.
	* jcf-dump.c (main): Call jcf_path_init.  Recognize all new
	classpath-related options.
	* lang.c (lang_decode_option): Handle -fclasspath, -fCLASSPATH,
	and -I.
	(lang_init): Call jcf_path_init.
	* lang-options.h: Mention -I, -fclasspath, and -fCLASSPATH.
	* lang-specs.h: Handle -I.  Minor cleanup to -M options.
	Correctly put braces around second string in each entry.
	* gjavah.c (main): Call jcf_path_init.  Recognize all the new
	classpath-related options.
	(help): Updated for new options.
	* jcf.h: Declare functions from jcf-path.c.  Don't mention
	`classpath' global.
	* jcf-path.c: New file.

	* jcf-depend.c: Include jcf.h.

	* jcf-write.c (localvar_alloc): Returns `void'.
	(localvar_free): Removed unused variable.

	* lang.c (OBJECT_SUFFIX): Define if not already defined.
	(init_parse): Use OBJECT_SUFFIX, not ".o".

Wed Oct 21 07:54:11 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (emit_register_classes): Renamed from
 	emit_register_class.
	* java-tree.h (emit_register_classes): Prototype renamed from
 	emit_register_class.
	* jcf-parse.c (yyparse): Call emit_register_classes once before
 	returning.
	* parse.y (java_expand_classes): No longer register classes.

Tue Oct 20 09:15:38 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* class.c (is_compiled_class): New local variable
 	seen_in_zip. Identify classes found in currently compiled source
 	file(s).
	* decl.c (complete_start_java_method): Fixed typo.
	* java-tree.h (CLASS_FROM_CURRENTLY_COMPILED_SOURCE_P,
 	HAS_BEEN_ALREADY_PARSED_P, IS_A_COMMAND_LINE_FILENAME_P): New macros.
	(CLASS_P): Moved around.
	(java_parse_abort_on_error): Macro moved from jcf-parse.c
	* jcf-parse.c (java_parse_abort_on_error): Macro moved to
 	java-parse.h
	(jcf_parse_source): Changed leading comment. Removed unnecessary
 	fclose and CLASS_FROM_SOURCE_P marking.
	(parse_source_file): New local variables remember_for_generation
 	and filename. Mark parsed file name identifier node. Removed block
 	executed when parse_only was null. Set remember_for_generation. 
	Use it as an argument to java_pop_parser_context.
	(yyparse): New local variables several_files, list, next node and
 	current_file_list. Split ampersand separated file names into
 	current_file_list. Iterate through the list and parse accordingly.
	* parse.h (java_pop_parser_context): New function prototype.
	* parse.y (ctxp_for_generation): New static global variable.
	(java_pop_parser_context): New argument generate. Link popped ctxp
 	to ctxp_for_generation list accordingly.
	(java_complete_expand_methods): Fixed indentation.
	(java_expand_classes): New function.
	
Sat Oct 17 11:25:21 1998  Per Bothner  <bothner@cygnus.com>

	* Makefile.in:  Link with libiberty.a instead of memmove.o.

Fri Oct 16 10:59:01 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lex.c (setjmp.h): No longer included.
	* lex.h (setjmp.h): Included.
	* parse.h (SET_TYPE_FOR_RESOLUTION): New macro.
	(duplicate_declaration_error_p): Renamed from
 	duplicate_declaration_error.
	(build_array_from_name): New function prototype.
	* parse.y (setjmp.h): No longer included.
	(variable_declarator_id): Define action.
	(build_array_from_name): New function.
	(duplicate_declaration_error_p): Renamed from
 	duplicate_declaration_error.  Fixed leading comment.
	(register_fields): Main `for' loop reorganized. Uses
 	SET_TYPE_FOR_RESOLUTION and build_array_from_name.
	(method_declarator): Uses SET_TYPE_FOR_RESOLUTION and call
 	build_array_from_name.
	(resolve_class): Set CLASS_LOADED_P on newly build array dimension
 	types.
	(read_import_dir): Don't try to skip `.' and `..'.
	(declare_local_variables): Uses SET_TYPE_FOR_RESOLUTION and
 	build_array_from_name. Main `for' loop reorganized.
	(resolve_qualified_expression_name): When building access to a
 	field, use the type where the field was found, not its own type.
	(maybe_access_field): Use field DECL_CONTEXT if the type where the
 	field was found is null.
	(qualify_ambiguous_name): Sweep through all successive array
 	dimensions.
	
Wed Oct 14 18:21:29 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* java-tree.h (pop_labeled_block, lang_printable_name,
 	maybe_add_interface, set_super_info, get_access_flags_from_decl,
 	interface_of_p, inherits_from_p, fix_classpath,
 	complete_start_java_method, emit_handlers, init_outgoing_cpool,
 	make_class_data, register_class, alloc_name_constant): New
 	function prototypes.
	* lang.c (lang_decode_option): Set argc argument unused. Fixed
 	indentation. Added cast to remove warning.
	(lang_printable_name): Set v argument unused.
	(lang_print_error): Added argument to lang_printable_name call.
	(java_dummy_print, print_lang_decl, print_lang_type,
 	print_lang_identifier, lang_print_xnode): All argument marked
 	unused.
	* lex.c (java_unget_unicode): Removed unnecessary argument.
	(java_allocate_new_line): Unused local variable is gone.
	(java_read_char): Added parenthesis in expressions to remove
 	warnings.  Added final return statement.
	(java_read_unicode): Added parenthesis in expression to remove
 	warning.
	(java_parse_end_comment): Fixed java_unget_unicode invocation.
	(java_parse_escape_sequence): Likewise.
	(java_lex): Unused local variables are gone. Fixed
 	java_unget_unicode invocation.
	* lex.h (set_float_handler): Prototype added when JC1_LITE not
 	defined.
	* parse.h (ERROR_CANT_CONVERT_TO_BOOLEAN): Fixed
 	lang_printable_name invocation in macro.
	(ERROR_CANT_CONVERT_TO_NUMERIC, ERROR_CAST_NEEDED_TO_INTEGRAL):
 	Likewise.
	(duplicate_declaration_error): Suppressed unused argument in
 	prototype.
	(identical_subpath_p): Function declaration is gone.
	(patch_invoke): Suppressed unused argument in prototype.
	(patch_cast, build_labeled_block, check_thrown_exceptions):
 	Likewise.
	* parse.y (setjmp.h): Included
	(toplev.h): Likewise.
	(field_declaration:): Suppressed unused local
	(label_decl:): Fixed build_labeled_block invocation.
	(java_pop_parser_context): Put extra parenthesis around assignment
 	in if.
	(yyerror): Suppressed unused local variables.
	(variable_redefinition_error): Fixed lang_printable_name
 	invocation.
	(create_interface): Suppressed unused local variables.
	(create_class): Likewise.
	(duplicate_declaration_error): Suppressed unused argument. Fixed
 	lang_printable_name invocation.
	(register_fields): Suppressed unused local variable. Fixed
 	duplicate_declaration_error invocation.
	(method_header): Suppressed unused local variable.
	(method_declarator, parser_check_super): Likewise.
	(java_complete_class): Suppressed unused local variable. Fixed
 	fatal error message.
	(complete_class_report_errors): Added default: in switch.
	(java_check_regular_methods): Fixed lang_printable_name
 	invocations.
	(check_throws_clauses): Likewise.
	(java_check_abstract_methods): Suppressed unused local
 	variable. Fixed lang_printable_name invocation.
	(read_import_entry): Added supplemental return statement.
	(read_import_dir): Suppressed unused local variables.
	(check_pkg_class_access, declare_local_variables): Likewise.
	(source_start_java_method): Suppressed unused extern variable
 	declarations
	(expand_start_java_method): Suppressed unused extern and local
 	variable declarations.
	(java_complete_expand_methods): Likewise.
	(java_complete_expand_method): Suppressed unused local variables.
	(make_qualified_name): Likewise.
	(resolve_qualified_expression_name): Added default: in
 	switch. Fixed lang_printable_name invocation.
	(class_instance_creation_expression): Added parenthesis around
 	expressions.
	(patch_method_invocation_stmt): Fixed lang_printable_name and
 	patch_invoke invocations.
	(check_for_static_method_reference): Fixed lang_printable_name
 	invocation.
	(patch_invoke): Suppressed unused arguments and local variables.
	(lookup_method_invoke): Suppressed unused local variables.
	(qualify_ambiguous_name): Added default: in switch.
	(identical_subpath_p): Function removed.
	(patch_assignment): Suppressed unused local variables. Suppressed
 	unnecessary if statement. Fixed lang_printable_name invocations.
	(try_builtin_assignconv): Fixed lang_printable_name invocations.
	(valid_ref_assignconv_cast_p): Parenthesis around
 	expression. Suppressed unused local variables.
	(build_binop): Suppressed unused local variables. fixed
 	lang_printable_name invocations.
	(string_constant_concatenation): Suppressed unused local
 	variables.
	(patch_unaryop): Fixed lang_printable_name invocation.
	(patch_cast): Suppressed unnecessary argument. Fixed
 	lang_printable_name invocation.
	(patch_array_ref): Fixed lang_printable_name invocation.
	(patch_newarray, patch_return, patch_if_else_statement): Likewise.
	(build_labeled_block): Suppressed unused argument.
	(generate_labeled_block): Fixed build_labeled_block invocation.
	(build_loop_body): Suppressed unused local variables.
	(patch_loop_statement): Likewise.
	(patch_exit): Fixed lang_printable_name invocation.
	(patch_switch_statement): Likewise.
	(case_identity): First argument marked unused.
	(patch_try_statement): Fixed lang_printable_name invocations.
	(patch_synchronized_statement, patch_throw_statement): Likewise.
	(check_thrown_exceptions): Fixed check_thrown_exceptions and
 	lang_printable_name invocations.
	(check_thrown_exceptions_do): Suppressed unused argument.

1998-10-14  Tom Tromey  <tromey@cygnus.com>

	* jcf-write.c (write_classfile): Add output class file as target.
	* lang-options.h: Added -MD, -MMD, -M, and -MM.
	* jcf.h: Added declarations for dependency-tracking functions.
	* lang-specs.h: Handle -M, -MM, MD, and -MMD.
	* lang.c (lang_decode_option): Recognize -MD and -MMD.
	(finish_parse): Call jcf_dependency_write.
	(dependency_tracking): New global.
	(DEPEND_SET_FILE): New define.
	(DEPEND_ENABLE): New define.
	(init_parse): Enable dependency tracking if required.
	Include "flags.h".
	* Makefile.in (JAVA_OBJS): Added jcf-depend.o.
	(../jcf-dump$(exeext)): Depend on and link with jcf-depend.o.
	(../gcjh$(exeext)): Likewise.
	(jcf-depend.o): New target.
	* Make-lang.in (JAVA_SRCS): Added jcf-depend.c.
	(GCJH_SOURCES): Likewise.
	* jcf-io.c (open_class): Call jcf_dependency_add_file.  Added
	dep_name argument.
	(find_classfile): Added dep_name argument.
	(find_class): Compute name of dependency.
	(open_in_zip): Call jcf_dependency_add_file.
	* gjavah.c (output_file): No longer global.
	(usage): Don't mention "gjavah".
	(help): Likewise.
	(java_no_argument): Likewise.
	(version): Likewise.
	(main): Recognize and handle -M family of options.
	(print_mangled_classname): Return is void.
	(process_file): Handle case where output is suppressed.
	(HANDLE_END_FIELD): Likewise.
	(HANDLE_METHOD): Likewise.
	* jcf-depend.c: New file.

Tue Oct 13 23:34:12 1998  Jeffrey A Law  (law@cygnus.com)

	* java-tree.def: Add missing newline at EOF.

1998-10-13  Tom Tromey  <tromey@cygnus.com>

	* jcf-dump.c (process_class): Use FATAL_EXIT_CODE, not -1.
	(main): Likewise.  Exit with SUCCESS_EXIT_CODE at end of
	function.
	Include <config.h> and "system.h".
	(disassemble_method): Undefine RET to avoid clash with
	config/i386/i386.h.

Tue Oct 13 03:50:28 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (runtime_exception_type_node, error_exception_type_node):
 	New global variables.
	(init_decl_processing): Initialized.
	* expr.c (java_lang_expand_expr): Set caught exception type to
 	null if catch handler argument doesn't exit.
	* java-tree.def (SYNCHRONIZED_EXPR, THROW_EXPR): New Java specific
 	tree codes.
	* java-tree.h (runtime_exception_type_node,
 	error_exception_type_node): Global variables declared.
	(DECL_FUNCTION_THROWS): New macro.
	(DECL_FUNCTION_BODY): Modified comment.
	(DECL_SPECIFIC_COUNT): Likewise.
	(struct lang_decl): New field throws_list.
	(IS_UNCHECKED_EXPRESSION_P): New macro.
	* lex.c (java_lex): Generate location information for THROW_TK.
	* parse.h (PUSH_EXCEPTIONS, POP_EXCEPTIONS, IN_TRY_BLOCK_P,
 	EXCEPTIONS_P): New macros.
	(enum jdep_code): New value JDEP_EXCEPTION.
	(BUILD_MONITOR_ENTER, BUILD_MONITOR_EXIT,
 	BUILD_ASSIGN_EXCEPTION_INFO, BUILD_THROW, SET_WFL_OPERATOR,
 	PATCH_METHOD_RETURN_ERROR): New macros.
	(patch_method_invocation_stmt): Added new argument to prototype.
	(patch_synchronized_statement, patch_throw_statement,
 	check_thrown_exceptions, check_thrown_exceptions_do,
 	purge_unchecked_exceptions, check_throws_clauses): New function
 	prototypes.
	* parse.y Fixed typo in keyword section.
	(throw:): Rule tagged <node>.
	(THROW_TK): Keyword tagged <operator>.
	(method_header:): Last argument to call to method_header passed
 	from throws: rule.
	(throws:, class_type_list:, throw_statement:,
 	synchronized_statement:, synchronized:): Defined actions.
	(method_header): New local variable current. Register exceptions
 	from throws clause.
	(java_complete_tree): Complete and verify exceptions from throws
 	clause.
	(complete_class_report_errors): Error message on exceptions not
 	found
	(java_check_regular_methods): Fixed typo. Shortcut on private
 	overriding methods. Changed error message on method
 	redefinition. Check for throws clause compatibility.
	(check_throws_clauses): New function.
	(java_check_abstract_methods): Use DECL_NAME for wfl or current
 	method. Changed error message on method redefinition.
	(currently_caught_type_list): New static variable.
	(java_complete_expand_methods): Purge unchecked exceptions from
 	throws clause list. Call PUSH_EXCEPTIONS before walk and
 	POP_EXCEPTIONS after.
	(resolve_qualified_expression_name): Pass new argument as NULL to
 	patch_method_invocation_stmt.
	(patch_method_invocation_stmt): New argument ref_decl. Invoke
 	PATCH_METHOD_RETURN_ERROR when returning with error. Reverse
 	argument list when appropriate. Use new argument if non null to
 	store selected method decl.
	(patch_invoke): Convert if necessary args of builtin types before
 	forming CALL_EXPR. Argument list no longer reversed here.
	(invocation_mode): Treat final methods as static methods.
	(java_complete_tree): New cases for THROW_EXPR: and
 	SYNCHRONIZED_EXPR:. Check thrown exceptions when completing
 	function call.
	(complete_function_arguments): No more RECORD_TYPE
 	conversion. Function parameter nodes no longer saved.
	(valid_ref_assignconv_cast_p): Avoid handling null type.
	(patch_binop): Fixed null constant reference handling.
	(build_try_statement): Use BUILD_ASSIGN_EXCEPTION_INFO and
 	BUILD_THROW macros.
	(patch_try_statement): Fixed comments. Record caught types in
 	list, push the list, expand try block and pop the list.
	(patch_synchronized_statement, patch_throw_statement,
 	check_thrown_exceptions, check_thrown_exceptions_do,
 	purge_unchecked_exceptions): New functions.
	* typeck.c (lookup_argument_method): Allow WFL in place of method
 	DECL_NAME during method definition check
	
1998-10-09  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (decode_signature_piece): New function.
	(print_c_decl): Use it.  Added `name_override' argument.
	(print_method_info): Use name_override argument to print_c_decl.
	(seen_fields): Removed.
	(print_field_info): Don't update seen_fields.
	(struct method_name): New structure.
	(method_name_list): New global.
	(print_method_info): Add new method to list of methods.
	(name_is_method_p): New function.
	(print_field_info): If field name has same name as method, then
	change field name.
	(process_file): Parse methods before fields.
	(field_pass): New global.
	(HANDLE_END_FIELD): Take field_pass into account.

Wed Oct  7 12:10:48 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (keyword.h): Add -L KR-C -F ', 0' flags to gperf.
	(keyword.h): Regenerate using gperf 2.7.1 (19981006 egcs).

Sat Oct  3 13:29:46 1998  Anthony Green  <green@cygnus.com>

	* jvspec.c: Fix bug in jvgenmain_spec patch.

Fri Oct  2 17:22:52 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* Makefile.in (lang.o:): Install dependency on java-tree.def.
	* decl.c (soft_exceptioninfo_call_node): New global variable.
	(init_decl_processing): Fixed indentation. soft_badarrayindex_node
 	takes extra integer argument. soft_exceptioninfo_call_node
 	initialized.
	* except.c (java_set_exception_lang_code): New function
	(method_init_exceptions): Called here.
	(prepare_eh_table_type): New function.
	(expand_end_java_handler): Called here.
	* expr.c (build_java_throw_out_of_bounds_exception): Now features
 	one argument. Modified generation of call to
 	soft_badarrayindex_node to use new argument.
	(build_java_arrayaccess): Pass faulty index value to
 	build_java_throw_out_of_bounds_exception.
	(generate_name): New function.
	(java_lang_expand_expr): New local variables node, current,
 	has_finally_p. Expand TRY_EXPR node.
	(process_jvm_instruction): Replace top of the stack with thrown
 	object reference when entering exception handler.
	* java-tree.def (TRY_EXPR, CATCH_EXPR, FINALLY_EXPR): New Java
 	specific tree codes.
	* java-tree.h (soft_exceptioninfo_call_node): Declaration of new
 	global.
	(DECL_SPECIFIC_COUNT): New macro.
	(prepare_eh_table_type, java_set_exception_lang_code,
 	generate_name): New function declarations.
	(match_java_method): Declaration deleted.
	(FINALLY_EXPR_LABEL, FINALLY_EXPR_BLOCK, CATCH_EXPR_GET_EXPR): New
 	macros.
	* lex.c (TRY_TK, CATCH_TK): Generate location information.
	* parse.h (redefinition_error, refine_accessible_methods_list,
 	can_cast_to_p): Function declaration removed.
	(classitf_redefinition_error, variable_redefinition_error,
 	parse_jdk1_1_error, find_applicable_accessible_methods_list,
 	find_most_specific_methods_list, argument_types_convertible,
 	enter_a_block, valid_builtin_assignconv_identity_widening_p,
 	valid_cast_to_p, valid_method_invocation_conversion_p,
 	try_reference_assignconv, add_stmt_to_compound,
 	build_jump_to_finally, build_tree_list, patch_try_statement,
 	java_get_catch_block): New function declarations.
	* parse.y (string_buffer_type): Global variable deleted.
	(group_of_labels, catches, catch_clause, catch_clause_parameter,
 	finally): Rules tagged <node>.
	(TRY_TK, CATCH_TK): Token tagged <operator>.
	(class_body_declaration:, class_member_declaration:,
 	formal_parameter:, explicit_constructor_invocation:,
 	interface_member_declaration:, constant_declaration:,
 	primary_no_new_array:, class_instance_creation_expression:,
 	array_creation_expression:): Issue error on unsuported JDK1.1
 	features.
	(try_statement:, catches:, finally:): Define actions.
	(catch_clause_parameter): New rule.
	(catch_clause:): Use new rule catch_clause_parameter.
	(parse_jdk1_1_error): New function.
	(redefinition_error): Renamed classitf_redefinition_error.
	(variable_redefinition_error): New function.
	(check_class_interface_creation): Call
 	classitf_redefinition_error.
	(java_complete_tree): Added error message on JDEP_TYPE: case.
	(complete_class_report_errors): Fixed indentation.
	(declare_local_variables): Call variable_redefinition_error.
	(source_end_java_method): Call java_set_exception_lang_code and
 	emit_handlers where appropriate.
	(java_method_add_stmt): Call add_stmt_to_block.
	(add_stmt_to_block): New function.
	(lookup_method_invoke): Fixed outside comment. new local variable
 	candicates.  Call find_applicable_accessible_methods_list and
 	find_most_specific_methods_list when searching for a
 	method. Modified error report to list possible candidates when
 	applicable.
	(find_applicable_accessible_methods_list,
 	find_most_specific_methods_list, argument_types_convertible): New
 	function.
	(refine_accessible_methods_list): Function deleted.
	(java_complete_tree): Handle TRY_EXPR. ARRAY_REF handling: save
 	expr (if applicable) before calling patch_array_ref.
	(build_expr_block): Fixed BLOCK_EXPR_BODY assignment.
	(enter_block): Fixed comment.
	(enter_a_block): New function.
	(patch_assignment): Reorganized. Call try_reference_assignconv for
 	references. Call valid_cast_to_p instead of can_cast_to_p.
	(try_reference_assignconv,
 	valid_builtin_assignconv_identity_widening_p): New functions.
	(valid_ref_assignconv_cast_p): Fixed inverted test on CLASS_FINAL.
	(valid_cast_to_p, valid_method_invocation_conversion_p): New
 	functions.
	(build_string_concatenation): Don't resolve StringBuffer.
	(patch_cast): Fixed inverted arguments.
	(patch_array_ref): Code to save array expr deleted. Call
 	valid_cast_to_p instead of can_cast_to_p.
	(generate_labeled_block): Call generate_name.
	(build_jump_to_finally, build_try_statement, java_get_catch_block,
 	patch_try_statement): New functions.
	* typeck.c (match_java_method): Function deleted.
	
Fri Oct  2 13:48:36 1998  Anthony Green  <green@cygnus.com>

	* jvspec.c: jvgenmain_spec uses different temporary file names.

Fri Oct  2 12:50:19 1998  Anthony Green  <green@cygnus.com>

	* jvspec.c (lang_specific_driver): Fail if user specifies
	--main= when not linking.

Mon Sep 28 13:48:33 1998  Tom Tromey  <tromey@cygnus.com>

	* class.c (make_class_data): Push value for `thread' field.
	* decl.c (init_decl_processing): Added `thread' field to class.

	* class.c (add_field): Always make static fields externally
	visible.

Sat Sep 26 08:22:47 1998  Anthony Green  <green@cygnus.com>

	* expr.c (build_java_athrow,
	build_java_throw_out_of_bounds_exception, expand_invoke,
	build_newarray, expand_java_multianewarray, build_java_monitor):
	Update comments to reflect _Jv_* function names.

Fri Sep 25 16:03:02 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c (complete_start_java_method):  DECL_RESULT is always promoted.
	* decl.c (start_java_method):  Handle PROMOTE_PROTOTYPES target macro.
	* parse.y (expand_start_java_method):  Likewise.

Thu Sep 24 12:20:35 1998  Per Bothner  <bothner@cygnus.com>

	* expr.c (pop_arguments):  Handle PROMOTE_PROTOTYPES target macro.

	* class.c (push_class):  IDENTIFIER_SIGNATURE_TYPE is now POINTER_TYPE.
	(add_field):  No longer need to convert from RECORD_TYPE to pointer,
	* expr.c:  Remove no-longer-needed calls to promote_type.
	* decl.c (give_name_to_locals):  Liekwise.
	* jcf-parse.c (get_class_constant):  Compensate for new signatures.
	* parse.y:  Add/remove promote_type calls as appropriate.
	* typeck.c (parse_signature_type):  Returns POINTER_TYPE for objects.
	(parse_signature_string):  Likewise.
 	(build_java_array_type):  Fix for now signature convenions.

	* lex.c (java_lex):  Fix (from Alex) for JC1_LITE problem.

Wed Sep 23 14:49:35 1998  Tom Tromey  <tromey@cygnus.com>

	* class.c (init_class_processing): libjava function renamed to
	_Jv_RegisterClass.

Tue Sep 22 12:00:02 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (java_lang_expand_expr): New case for SWITCH_EXPR.
	* java-tree.def: Fixed DEFTREECODE third argument.
	(UNARY_PLUS_EXPR, NEW_ARRAY_EXPR, NEW_CLASS_EXPR, THIS_EXPR,
 	CASE_EXPR, DEFAULT_EXPR): New tree codes for Java.
	* java-tree.h: (IS_CRAFTED_STRING_BUFFER_P): New macro.
	(JAVA_UNARY_PLUS_EXPR, JAVA_NEW_ARRAY_EXPR, JAVA_NEW_CLASS_EXPR,
 	JAVA_THIS_EXPR): Now replaced by tree code definitions.
	(CALL_CONSTRUCTOR_P): Now uses NEW_CLASS_EXPR.
	* lang.c (java_tree_code_type, java_tree_code_length,
 	java_tree_code_name): New arrays.
	(lang_init): Append Java tree node definitions to Gcc ones.
	* lex.c (expression_obstack): Declared as extern when JC1_LITE
 	defined.
	(java_init_lex): Initialize wfl_append, wfl_string_buffer,
 	wfl_to_string.
	(java_lex): Allow declaration of empty string constants. Retain
 	location information on CASE_TK and DEFAULT_TK.
	* parse.h (JFLOAT_TYPE_P, JINTEGRAL_TYPE_P, JNUMERIC_TYPE_P,
 	JPRIMITIVE_TYPE_P, JSTRING_TYPE_P, JSTRING_P, JREFERENCE_TYPE_P):
 	Modified to be more robust.
	(BUILD_APPEND, BUILD_STRING_BUFFER): New macros.
	(build_new_invocation, try_builtin_assignconv,
 	patch_switch_statement, string_constant_concatenation,
 	build_string_concatenation, patch_string_cst, patch_string,
 	java_expand_switch): New function declarations.
	* parse.y: Rules related to switch and EH tagged <node>.
	(label_id): Set to NULL_TREE
	(wfl_string_buffer, wfl_append, wfl_to_string): New static global
 	tree nodes.
	(this_or_super:): Fixed indentation.
	(statement:, statement_nsi:, statement_without_trailing_substatement:,
 	statement_expression:): Removed call to RULE on all sub-rules.
	(switch_expression:, switch_labels:): New rules.
	(switch_statement:, switch_block:, switch_block_statement_groups:,
 	switch_block_statement_group:, switch_labels:, switch_label:):
 	Defined actions.
	(throw_statement:, synchronized_statement:, try_statement:):
 	Defined temporary actions.
	(class_instance_creation_expression:): Call
 	build_new_invocation. Fixed indentation.
	(field_access): Fixed indentation.
	(method_invocation): Likewise.
	(make_qualified_primary): Use THIS_EXPR.
	(resolve_qualified_expression_name): Use NEW_CLASS_EXPR. When
 	resolving from SUPER, set *type_found.
	(qualify_ambiguous_name): Use NEW_CLASS_EXPR.
	(java_complete_tree): Removed unused local variable `location'. Case
 	for SWITCH_EXPR, sharing code with LOOP_EXPR. Use NEW_ARRAY_EXPR,
 	NEW_CLASS_EXPR, UNARY_PLUS_EXPR and THIS_EXPR. New string handling
 	on MODIFY_EXPR: and all binary operator tree code cases. Removed
 	STRING_CST: case. default: checks for patchable strings.
	(complete_function_arguments): Transform string constant or
 	crafted StringBuffer if necessary.
	(build_method_invocation): Fixed comments.
	(build_new_invocation): New function.
	(patch_assignment): Call try_builtin_assignconv to figure a valid
 	assignment conversion between builtin types.
	(try_builtin_assignconv): New function.
	(build_binop): Use URSHIFT_EXPR directly to call build.
	(operator_string): Use UNARY_PLUS_EXPR.
	(patch_binop): Use UNARY_PLUS_EXPR. Handle string concatenation
 	operator.
	(do_merge_string_cste, merge_string_cste,
 	string_constant_concatenation, build_string_concatenation,
 	patch_string, patch_string_cst): New function.
	(build_unary_op): Use UNARY_PLUS_EXPR and CONVERT_EXPR.
	(patch_unaryop): Likewise. New test of valid ++/-- operands.
	(build_newarray_node): Use NEW_ARRAY_EXPR.
	(build_this): Use THIS_EXPR.
	(build_return): Enable debug information on return statement.
	(build_if_else_statement): Likewise.
	(complete_labeled_statement): Fixed related comment.
	(build_loop_body): Fixed comment.
	(build_bc_statement): Enable debug information on break/continue
 	statements.
	(patch_bc_statement): Fixed typos. Handle SWITCH statement
 	context.
	(patch_switch_statement, case_identity, java_expand_switch): New
 	functions.

Mon Sep 21 13:21:35 1998  Per Bothner  <bothner@cygnus.com>

	* buffer.h (BUFFER_INIT):  New macro.
	* jcf-write.c (struct jcf_partial):  New type.  Put global stuff here.
	Pass (struct jcf_partial *state) to most functions.
	(jcf_block, jcf_relocation):  New types.
	Support labels, branches, conditionals, loops.

Mon Sep 21 15:08:48 1998  Tom Tromey  <tromey@cygnus.com>

	* decl.c (INT_TYPE_SIZE): Define as BITS_PER_WORD if not defined.

Mon Sep 21 13:21:35 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c (integer_type_node):  Make it have INT_TYPE_SIZE.
	* verify.c (verify_jvm_instructions):  Use int_type_not (32 bits),
	not integer_type_node (INT_TYPE_SIZ bits).

	* parse.y (patch_if_else_statement):  Accept promoted_boolean_type_node.

	* jcf-reader.c (get_attribute):  New HANDLE_EXCEPTION_TABLE hook.
	* jcf-dump.c (print_exception_table):  New function.
	(disassemble_method):  Better handling of wide instructions.
	Make more robust for bad input.

Wed Sep 30 20:53:51 1998  Jeffrey A Law  (law@cygnus.com)

	* jcf-write.c (OP2, OP4): Use "_i", not "_I" to avoid problems on
	FreeBSD.

Thu Sep 17 19:45:01 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (jcf-dump, jvgenmain): Link in memmove.o too.

Thu Sep 17 16:21:52 1998  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in ($(PARSE_H)): Removed target.

Thu Sep 17 01:57:07 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (JAVA_OBJS): Add memmove.o
	(memmove.o): New target & rules.

Tue Sep 15 23:21:55 1998  Tom Tromey  <tromey@cygnus.com>

	* expr.c (expand_invoke): Don't generate a call to the class init
	code.

Mon Sep 14 10:14:47 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in: Add many missing dependencies.
	* buffer.c, class.c, constants.c, decl.c: Use system.h and toplev.h
	as appropriate.
	* except.c, expr.c, jcf-io.c jcf-parse.c, jcf-write.c: Likewise.
	* jvgenmain.c lang.c mangle.c typeck.c verify.c: Likewise.

Fri Sep 11 14:05:21 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c (complete_start_java_method):  If method is static (and
	not private) call _Jv_InitClass.
	* expr.c (expand_invoke):  Don't call build_class_init.

	* jvspec.c (jvgenmain_spec):  Fix spec for generated .o file.

Thu Sep 10 10:33:31 1998  Jeffrey A Law  (law@cygnus.com)

	* Make-lang.in (GCJ): Define before using.

Wed Sep  9 21:23:10 1998  Jeffrey A Law  (law@cygnus.com)

	* gjavah.c (java_no_argument): Renamed from no_argument to avoid
	losing due to namespace pollution in GNU getopt.h

Wed Sep  9 13:33:39 1998  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (java.all.build): Don't mention jvgenmain or gcjh.
	(java.all.cross): Likewise.
	(java.rest.encap): Likewise.

Tue Sep  8 10:34:05 1998  Jeffrey A Law  (law@cygnus.com)

	* gjavah.c (print_class_decls): Fix thinko in arglist
	* jcv-io.c (find_classfile): Similarly.

Mon Sep  7 13:59:49 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (INCLUDES): Update for recent toplevel gcc changes.

Sat Sep  5 16:08:01 1998  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (java.maintainer-clean): Don't remove parse.h.
	(java.mostlyclean): Remove parse.c and parse-scan.c, not parse.h.
	* Makefile.in (PARSE_C): New macro.
	(PARSE_H): Likewise.
	(PARSE_SCAN_C): Likewise.
	($(PARSE_C)): Target renamed from parse.c.
	($(PARSE_SCAN_C)): Target renamed from parse-scan.c.
	(clean): Remove parse-scan.c as well.
	(parse.o): Depend on $(PARSE_C).

Sat Sep  5 08:48:40 1998  Anthony Green  <green@cygnus.com>

	* README, license.terms: Removed.

	* Make-lang.in, Makefile.in, class.c, config-lang.in, constants.c,
	decl.c, except.c, expr.c, gjavah.c, java-except.h, java-tree.h,
	javaop.def, javaop.h, jcf-dump.c, jcf-io.c, jcf-parse.c,
	jcf-reader.c, jcf-write.c, jcf.h, jvgenmain.c, jvspec.c,
	keyword.gperf, keyword.h, lang-options.h, lang-specs.h, lang.c,
	lex.c, lex.h, mangle.c, parse-scan.y, parse.h, parse.y, typeck.c,
	verify.c, zextract.c, zipfile.h: Fixed copyright assignment,
	and Java trademark attribution.

Fri Sep  4 10:42:05 1998  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in: Use gcjh, not gjavah.
	* config-lang.in (stagestuff): Use gcjh, not gjavah.
	* Make-lang.in: Changed gjavah to gcjh everywhere.

Thu Sep  3 18:04:09 1998  Per Bothner  <bothner@cygnus.com>

	* gjavah.c:  Support new -prepend -add -append flags.
	(print_method_info):  Method is not virtual if class is final.	

Thu Sep  3 12:03:53 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* jv-scan.c: Fixed copyright assignment.
	* keyword.gperf: Likewise.
	* keyword.h: Likewise.
	* lex.c: Fixed copyright assignment.
	(java_lex): Push unicode back when parsing '<'.
	* lex.h: Fixed copyright assignment.
	* parse-scan.y: Likewise.
	* parse.h: Fixed copyright assignment.
	(build_debugable_stmt, complete_for_loop): New function prototypes.
	* parse.y: Fixed copyright assignment.
	(for_statement:): Call complete_for_loop. Set EXIT_EXPR to be
 	size_zero_node when completing a loop with no exit condition.
	(for_statement_nsi:): Define action.
	(for_init:, for_update:): Return size_zero_node when empty.
	(declare_local_variables): Call build_debugable_stmt.
	(build_debugable_stmt): New function.
	(build_loop_body): Build debugable statement around loop
 	condition part.
	(complete_loop_body): Take into account the debugable statement
	around the EXIT_EXPR.
	(complete_loop_body): New function.
	(patch_exit_expr): Fixed condition inversion.

Wed Sep  2 11:53:58 1998  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (jvspec.o): Use GCC_THREAD_FILE to compute correct
	name of thread define.
	* jvspec.c (THREAD_NAME): New macro.
	(GCLIB): Likewise.
	(THREADLIB): Likewise.
	(lang_specific_driver): Recognize attempt to link with thread
	library or gc library.  Recognize -ljava on command line so it
	isn't linked against more than once.

Wed Sep  2 11:28:35 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* parse-scan.y (report_main_declaration): Name of the class
 	containing `main' can be a qualified name.

Mon Aug 31 13:25:58 1998  Tom Tromey  <tromey@cygnus.com>

	* config-lang.in: Changed gjavac to gjc everywhere.
	* Make-lang.in: Changed gjavac to gjc everywhere.

Thu Aug 27 02:28:27 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* Make-lang.in (JAVA_TARGET_INDEPENDENT_BIN_TOOLS): New variable.
	(java.install-common:): Loop over JAVA_TARGET_INDEPENDENT_BIN_TOOLS
	and install the files.
	* Makefile.in (JAVA_OBJS_LITE): New variable.
	(compiler:): Now include jv-scan as a dependency.
	(../jv-scan$(exeext), parse-scan.c): New targets.
	(../jcf-dump$(exeext)): Was jcf-dump$(exeext) before.
	* config-lang.in (compilers): Removed gcj, gjavah from the list.
	* jcf-parse.c (parse_source_file): Call java_layout_classes and
 	check for errors even if parse_only.
	* lex.c (java_init_lex): Reorganized and skip parts if JC1_LITE is
 	defined.
	(yylex): New function. Uses java_lex body.
	(java_lex): Removed commented out statement. Remove local variable
 	literal. Use SET_LVAL_NODE_TYPE and SET_LVAL_NODE where
 	appropriate.  Use macros FLOAT_TYPE_NODE, DOUBLE_TYPE_NODE,
 	DCONST0, SET_FLOAT_HANDLER, SET_REAL_VALUE_ATOF,
 	SET_LVAL_NODE_TYPE and GET_TYPE_PRECISION. Don't create STRING_CST
 	if JC1_LITE is defined. Use BUILD_ID_WFL to build identifiers. Use
 	SET_MODIFIER_CTX, SET_LVAL_NODE, BUILD_ID_WFL and GET_IDENTIFIER
 	where appropriate.
	(java_lex_error): Empty if JC1_LITE is defined.
	(java_get_line_col): Return 0 if JC1_LITE is defined.
	* lex.h (JAVA_FLOAT_RANGE_ERROR, JAVA_INTEGRAL_RANGE_ERROR,
 	SET_MODIFIER_CTX): Moved into the section containing the macros
 	conditionally defined by JC1_LITE.
	(BUILD_OPERATOR,BUILD_OPERATOR2): Just return the TOKEN
 	argument if JC1_LITE is defined.
	(HOST_BITS_PER_WIDE_INT, HOST_WIDE_INT, REAL_VALUE_ATOF,
 	REAL_VALUE_ISINF, REAL_VALUE_ISNAN): Preset to values if JC1_LITE
 	is defined.
	(DCONST0, SET_FLOAT_HANDLER, GET_IDENTIFIER, SET_REAL_VALUE_ATOF,
 	FLOAT_TYPE, DOUBLE_TYPE, SET_MODIFIER_CTX, GET_TYPE_PRECISION,
 	SET_LVAL_NODE, SET_LVAL_NODE_TYPE, BUILD_ID_WFL): New macros, set
 	to different values according to JC1_LITE.
	* parse.h (int_fits_type_p, stabilize_reference): Prototype not
 	declared if JC1_LITE set.
	(jdep_code, typedef struct _jdep, typedef struct _jdeplist): Not
 	defined if JC1_LITE not set.
	(struct parser_ctx): Reorganized and skip the jc1 front end part
 	if JC1_LITE set.
	(java_layout_classes): New function definition.
	(java_push_parser_context, java_init_lex, yyparse, yylex,
 	yyerror): Prototype always declared. All other static function
 	prototypes declared only if JC1_LITE is not set.
	* parse.y (yyparse, yylex, yyerror): No longer declared here. Now
 	declared in parse.h.
	(java_layout_classes): New function.
 	(java_complete_expand_methods): No longer layout the class here.
	* parse-scan.y: New file.
	* jv-scan.c: New file.

Tue Aug 25 10:17:54 1998  Tom Tromey  <tromey@cygnus.com>

	* gjavah.c (main): Handle -friend option.
	(friend_specs): New global.
	(generate_access): Handle friend_specs.
	(process_file): Likewise.
	(MAX_FRIENDS): New macro.
	(friend_count): New global.
	(print_cxx_classname): Added `prefix' argument.  Ignore arrays.
	Changed all callers.

Mon Aug 24 20:19:27 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-dump.c (process_class):  Move JCF_FINISH use to main,
	(main):  Handle processing all the entries of a named .zip archive.
	* jcf-io.c (jcf_trim_old_input):  New function.
	* jcf.h (GET_u2_le,GET_u4_le,JCF_readu2_le,JCF_readu4_le):  New macros.

Mon Aug 24 07:35:13 1998  Per Bothner  <bothner@cygnus.com>

	* lang.c (flag_assume_compiled):  Make default be on.

Fri Aug 21 17:29:04 1998  Per Bothner  <bothner@cygnus.com>

	* jcf-dump.c:  Add bunches of flags to control output more.
	(process_class):  New function;  support printing more than one class.
	(main): Support new --print-main and --javap flags.
	* jcf-reader.c (IGNORE_ATTRIBUTE):  New hook.
	* jcf.h (CPOOL_INDEX_IN_RANGE):  New macro.

Thu Aug 20 14:24:47 1998  Per Bothner  <bothner@cygnus.com>

	Change mangling of dispatch table to match C++ vtable (w/thunks).
	* class.c (build_dtable_decl), java-tree.h:  New function.
	(make_class_data):  Call it.
	* decl.c (init_decl_processing):  Likewise.

Wed Aug 19 17:57:07 1998  Warren Levy  <warrenl@cygnus.com>

	* decl.c (init_decl_processing): Use _Jv_NewObjectArray, not
 	soft_anewarray; adjust args passed.
	* expr.c (build_anewarray): Adjust args for soft_anewarray_node to
 	match _Jv_NewObjectArray.
	
Wed Aug 19 09:33:23 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* decl.c (push_labeled_block, pop_labeled_block): New functions.
	* expr.c (loopup_label): Call create_label_decl.
	(create_label_decl): New function.
	(java_lang_expand_expr): Call expand_start_bindings with argument
 	set to zero.
	* java-tree.h Added space after PROTO in function declarations
 	when necessary.
	(IS_FOR_LOOP_P, IS_BREAK_STMT_P): New macros.
	(create_label_decl, push_labeled_block): New function
 	declarations.
	* lex.c (label_id): Initialize.
	(SUPER_TK, THIS_TK, RETURN_TK): Merged common actions in final
 	switch.
	* parse.h Added space after PROTO in function declarations when
 	necessary.
	(LOOP_EXPR_BODY_MAIN_BLOCK, LOOP_EXPR_BODY_UPDATE_BLOCK,
 	LOOP_EXPR_BODY_CONDITION_EXPR, LOOP_EXPR_BODY_LABELED_BODY,
 	LOOP_EXPR_BODY_BODY_EXPR, LOOP_HAS_LABEL_P, LOOP_HAS_LABEL_SKIP_P,
 	PUSH_LABELED_BLOCK, POP_LABELED_BLOCK, PUSH_LOOP, POP_LOOP): New
 	macros.
	(struct parser_ctxt): New fields current_loop,
 	current_labeled_block.
	(build_if_else_statement, patch_if_else_statement,
 	add_stmt_to_compound, patch_exit_expr, build_labeled_block,
 	generate_labeled_block, complete_labeled_statement,
 	build_bc_statement, patch_bc_statement, patch_loop_statement,
 	build_new_loop, build_loop_body, complete_loop_body): New function
 	declarations.  
	* parse.y (java_warning_count): New global variable.
	(label_id): New static variable.
	(BREAK_TK, CONTINUE_TK): Token tagged <operator>.
	(block:): Return size_zero_node when block is empty.
	(empty_statement:): Return size_zero_node.
	(statement:): Implement supplemental action when for_statement: is
 	reduced.
	(label_decl:): New rule.
	(labeled_statement:): Rewritten using label_decl. Actions
 	implemented.
	(labeled_statement_nsi:): Likewise.
	(if_then_statement): Actions implemented.
	(while_expression): New rule.
	(while_statement:): Rewritten using while_expression. Actions
 	implemented.
	(while_statement_nsi:): Likewise.
	(do_statement_begin:): New rule.
	(do_statement:): Rewritten using do_statement_begin. Actions
 	implemented.
	(for_statement:): Rewritten using for_begin. Actions implemented.
	(for_statement_nsi:): Likewise.
	(for_header:, for_begin:): New rules.
	(for_init:): Actions implemented.
	(statement_expression_list:, break_statement:,
 	continue_statement:): Likewise.
	(yyerror): Count number of issued warning(s).
	(java_report_errors): Report error(s) and/or warning(s).
	(java_complete_class): Use build_java_argument_signature to
 	recompute completed method signature.
	(java_check_regular_methods): New locals method_wfl and aflags.
  	Use method_wfl instead of lookup_cl during error reports. Fixed
 	indentation and modified some error messages. Use
 	lang_printable_name in method instead of the DECL_NAME. New code
 	to issue warnings on methods not overriding corresponding methods
 	private to a different package.
	(java_method_add_stmt): Call add_stmt_to_compound.
	(add_stmt_to_compound): New function.
	(java_complete_tree): Handle LABELED_BLOCK_EXPR, EXIT_BLOCK_EXPR,
 	LOOP_EXPR, EXIT_EXPR and COND_EXPR.
	(build_if_else_statement, patch_if_else_statement,
 	build_labeled_block, generate_labeled_block,
 	complete_labeled_statement, build_new_loop, build_loop_body,
 	complete_loop_body, patch_loop_statement, build_bc_statement,
 	patch_bc_statement, patch_exit_expr): New functions.
	* typeck.c (build_java_signature): Build argument signature before
 	enclosing it in between parenthesis.
	
Mon Aug 17 17:44:24 1998  Warren Levy  <warrenl@cygnus.com>

	* Make-lang.in (JAVA_SRCS): Created for dependencies * Makefile.in
 	(JAVA_OBJS): Added reminder comment

Thu Aug 13 10:01:45 1998  Nick Clifton  <nickc@cygnus.com>

	* gjavah.c (D_NAN_MASK): Append LL to the constant to force it to
	be interpreted as a long long.

Thu Aug 13 14:34:07 1998  Warren Levy  <warrenl@cygnus.com>

	* decl.c (init_decl_processing): Use _Jv_InitClass, not
 	soft_initialise_class.  Use _Jv_NewMultiArray, not
 	soft_multianewarray.  Use _Jv_ThrowBadArrayIndex, not
 	soft_badarrayindex.  Use _Jv_CheckCast, not soft_checkcast.  Use
 	_Jv_CheckArrayStore, not soft_checkarraystore.  Use
 	_Jv_LookupInterfaceMethod, not soft_lookupinterfacemethod.
	
Wed Aug 12 14:23:13 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c, java-tree.h (this_identifier_node, super_identifier_node,
	length_identifier_node):  New global tree node constants.
	* parse.y (kw_super, kw_this, kw_length):  Removed globals.
	Replace uses by super_identifier_node etc.
	* lex.c (kw_super, kw_this, kw_length):  Don't initialize.

	* parse.y (resolve_field_access):  Don't special-case ".length" if
	flag_emit_class_files.
	(patch_array_ref):  Leave as ARRAY_REF if flag_emit_class_files.
	* jcf-write.c (generate_bytecode_insns):  Handle ARRAY_REF opcode
	and ARRAY.length.

Tue Aug 11 11:31:55 1998  Per Bothner  <bothner@cygnus.com>

	* decl.c (init_decl_processing): Remove unused method_type_node fields.
	* class.c (make_method_value):  Remove init for removed fields.

	* class.c (layout_class):  Use build_java_argument_signature.
	* java-tree.h (TYPE_ARGUMENT_SIGNATURE):  New macro.

	* typeck.c (push_java_argument_signature):  Removed.  Merged into ...
	(build_java_argument_signature):  Use TYPE_ARGUMENT_SIGNATURE cache.
	(build_java_signature):  Don't use push_java_argument_signature.

	* typeck.c (lookup_argument_method):  New function.
	* parse.y (java_check_regular_methods):  Use lookup_argument_method
	instead of lookup_java_method2 followed by lookup_java_method.
	
	* parse.y (check_method_redefinition):  Minor optimization.
	
	* jcf-write.c (generate_bytecode_insns):  Handle RETURN_EXPR,
	MINUS_EXPR, MULT_EXPR, TRUNC_DIV_EXPR, and RDIV_EXPR.

Mon Aug 10 09:57:15 1998  Tom Tromey  <tromey@cygnus.com>

	* Make-lang.in (jc1$(exeext)): Don't depend on c-common.o or
	c-pragma.o.

	* gjavah.c (java_float_finite): Use K&R-style definition.
	(java_double_finite): Likewise.
	(generate_access): Now returns void.  Changed all callers.
	(last_access_generated): Removed.
	(process_file): Only make a single pass over the .class file.

Wed Jul 29 17:50:23 1998  Per Bothner  <bothner@cygnus.com>

	* class.c (get_dispatch_table):  Add extra dummy vtable entry,
	for compatibility for G++ (with -fvtable-thunks).
	* expr.c (build_invokevirtual):  Add one for extra dummy vtable entry.

	* gjavah.c (process_file):  Use public inheritance for super-class.

Wed Jul 29 13:19:03 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* lex.c (java_init_lex): Initialize ctxp->package.
	* parse.h (struct parser_ctxt): package and package_len replaced
 	by tree package, an identifier node. Field method_decl_list is
 	gone. Fixed comments.
	(lookup_field_wrapper, merge_qualified_name, not_accessible,
 	class_in_current_package): New function prototypes.
	* parse.y (array_type:): Set class loaded flag on primitive type
 	arrays.
	(package_declaration:): Assign ctxp->package to the
 	identifier node.
	(method_invocation:): Handle invocation of method qualified by
 	`super'.
	(single_type_import_declaration:): Removed ambiguity check.
	(java_pop_parser_context): New local variable `next'. Reset and
 	set IMPORT_CLASSFILE_NAME flags on current and previous import
 	list.
	(java_accstring_lookup): Use new local macro COPY_RETURN.
	(lookup_field_wrapper): New function.
	(parser_qualified_classname): Use merge_qualified_name.
	(parser_check_super_interface): Broaden error message.
	(do_resolve_class): Check for qualified class name in the current
 	compilation unit if appropriate.
	(process_imports): Check for already defined classes.
